<div class="withHeader">
    <div data-dojo-type="cqthink.wb.List2" class="orderListHeader" id="orderList2Header">
        {% ifequal all_window.allInTpl 1 %}
        <table class="orderHeadTable" style="width:100%;border-bottom: #eee 1px solid;border-top: #eee 1px solid;background:white;"
        border="0" cellspacing="0" cellpadding="0">
            <tbody>
                <tr class="orderHead">
                    <td>
                        <li class="tableLiChecked" name="13">全部</li>
                    </td>
                    <td>
                        <li class="tableLi" name="11">进行中</li>
                    </td>
                    <td>
                        <li class="tableLi" name="12">待评价</li>
                    </td>
                </tr>
            </tbody>
        </table>
        {% else %}
        <div class="orderListH1"></div>
        {% endifequal %}
    </div>
    
    <div id="tradeListInfo" style="display:none;">
        <div class="m-cart-e" style="font-size:20px;">没有找到相关预约</div>
    </div>
    
    <ul class="m-list wbList_sjmd" id="wb_list" data-dojo-type="cqthink.wb.List3"
    rs_wb_md="SYF_TSCSF_WB" rs_wb_flt="13" rs_wb_param="({CLIENT:widgets.userInfo.info.partnerId})"
    rs_wb_page="20">
        {% if items.length %}
        {% for item in items %}
        <li class="wbList_sjmd_li">
            <div style="width:100%;position:relative;">
                <div class="zw" style="display:block;"></div>
                <!--firstLine-->
                <div class="stateDiv">
                    <span style="float:left;" class="stateLeft">{{item.DEPTID.DeptName}}</span>
                    <!--1.再次预约2.评价3.联系卖家-->
                    <em>
                        {% ifequal item.IS_PAY 0 %}
                            {% ifequal item.WBSTATE 4 %}
                                <span style="float:right;" class="stateRight" >
                                    预约已取消
                                </span>
                            {% else %}
                                <span style="float:right;" class="stateRight" onclick="window.moveToView('orderDetail',{{item.DELBILLTOWB}})">
                                     待付款
                                </span>
                            {% endifequal %}
                        {% else %}
                        <span style="float:right;" class="stateRight" >
                                    
                                <!--3-->{% ifequal item.WBSTATE 1 %}等待审核{% endifequal %}
                                <!--3-->{% ifequal item.WBSTATE 2 %}已审核{% endifequal %}
                                <!--进行中-->
                                <!--1 2 3-->{% ifequal item.WBSTATE 3 %}预约已完成{% endifequal %}
                                <!--待评价-->
                                <!--1 3-->{% ifequal item.WBSTATE 4 %}预约已取消{% endifequal %}
                        </span>
                        {% endifequal %}
                        {% ifequal item.cancelWb "1" %}
                            <span style="float:right;margin-right:12px" class="stateRight wbid_{{item.WBID}} yuid_{{item.DELBILLTOWB}}" >
                                取消预约
                            </span>
                        {% endifequal %}
                    </em>
                </div>
                <div class="miDiv">
                    <div class="imgDiv">
                        <img src='../../img/load/{{all_window.g_sys_info.code}}-{{item.SERVICEID.T0_IconURLID}}.png'
                        class="imgImg" style="width:70px;height:70px;" />
                    </div>
                    <div class="contentDiv">
                        <div class="serviceDiv">
                            <span>服务：{{item.SERVICEID.T0_GName}}</span>
                        </div>
                        <div class="priceDiv">
                            <span>价格：{{item.SERVICEID.T3_RetailPrice|floatformat:"2"}}</span>
                        </div>
                        <div class="plansTimeDiv">
                            <span>预约时间：{{item.PLANSTIME}}</span>
                        </div>
                        <div class="remarkDiv">
                            <span>服务地址：<div class="rd">{{item.DEPTID.Remark}}</div></span>
                        </div>
                    </div>
                </div>
                <div class="orderAgainDiv">
                    <div class="callSellDiv">
                     <span onclick="window.moveToMsgList();">联系卖家</span>
                    </div>
                    <!--如果订单状态为已完成-->{% ifequal item.WBSTATE 3 %}
                    <!--如果是否评价为未评价-->{% ifequal item.IS_EVA 0 %}
                    <div class="yesAppraise">
                        <span style="display:block;" onclick="window.moveToView('addEva','wb_{{item.WBID}}')">
                        <!--'{{item.DELBILLTOWB}}_{{item.SERVICEID}}_{{item.DELBILLTOWB.T0_DeliBillID}}_{{item.WBID}}')-->
                            <a>评价</a>
                            <!--wb_eva="{{item.DELBILLTOWB.T4_EntryID}}" wb_wcid="{{item.SERVICEID.T0_MID}}" -->
                        </span>
                    </div>
                    {% else %}
                    <div class="noAppraise">
                        <span style="display:none;">
                            <a>评价</a>
                        </span>
                    </div>
                    {% endifequal %}
                    <!--<div class="orderAgain">-->
                    <!--    <span onclick="window.moveToView('addWb','{{item.DELBILLTOWB.T4_EntryID}}');">再次预约</span>-->
                    <!--</div>-->
                    {% endifequal %} 
                    <!--{% ifequal item.WBSTATE 4 %}-->
                    <!--<div class="orderAgain">-->
                    <!--    <span onclick="window.moveToView('addWb','{{item.DELBILLTOWB.T4_EntryID}}');">再次预约</span>-->
                    <!--</div>-->
                    <!--{% endifequal %}-->
                </div>
            </div>
        </li>
        {% endfor %}
        {% else %}
		<div class="notFoundItem">
            <div class="notFoundItem_img">
                <img src="../../Content/standardTmp01/images/noOrder.png"/>
            </div>
            <div class="notFoundItem_txt">
                <span>当前没有相关预约！</span>
            </div>
            <div class="getTarget">
                <a href="#beautyReserve">立即预约</a>
            </div>
        </div>
		{% endif %}
    </ul>
</div>