﻿require([
	"dojo/ready",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dojo/_base/json",
	"dojo/_base/xhr",
	"dojo/_base/connect",
	"dojo/dom-attr",
	"dojo/dom-class",
	"dojo/dom-construct",
	"dojo/dom-style",
	"dojo/query",
	"dojo/topic",
	"dojo/Deferred",
	"dijit/registry",
	"dojo/cookie",
	"dojox/mobile/scrollable",
	"dojox/mobile/parser",
	"dojox/mobile/compat",
	"dojox/mobile/ProgressIndicator",
	"dojox/mobile/ContentPane",
	"dojox/dtl/tag/logic",
	"dojo/parser"
], function (ready, lang, array, json, xhr, connect, domAttr, domClass, domConstruct, domStyle, query, topic, Deferred, registry, cookie, scrollable) {
    window._directToPage = function (url) {
        window.location.href = url;
    };
    window.code = g_sys_info.code;
	//若当前访问页面域名和服务配置的域名不一致，重定向到指定域名
    if (g_sys_info.svcHost && window.location.host !== g_sys_info.svcHost) {
        //return window._directToPage(window.location.href.replace(window.location.host, g_sys_info.svcHost));
    }
    //赵春辉	提供获取微信openID的重定向操作	2015-02-04
    window.redirectWxOpenId = function (appId, redirectUrl) {
        location.href = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + appId + "&redirect_uri=" + encodeURIComponent(redirectUrl) + "&response_type=code&scope=snsapi_base&state=1#wechat_redirect";
    };
    window.directWxOpenId = function (code, url) {
        window._directToPage(window.location.href.split("/w/")[0] + "/w/wxAuth/GetWxID/" + code + "?returnurl=" + encodeURIComponent(url));
    };
    //浏览器信息的属性
    window.util = {
        versions: function () {
            var u = navigator.userAgent || navigator.vendor || window.opera;
            //只用到了这两个，处理这两个就足够了
            return {//移动终端浏览器版本信息 
                weixin: /MicroMessenger/.test(u), //是微信浏览器
                mobile: /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(u) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(u.substr(0, 4)) //是否为移动终端
            };
        } (),
        //判断和获取终端信息的方法
        isBrowser: function () {
            return !this.getDeviceNum();
        },
        getDeviceNum: function () {
            return window.device && device.uuid;
        },
        isMobile: function () {
            return "Desktop" !== this.getDevice();
        },
        getDevice: function () {
            if (/(iPhone)/i.test(navigator.userAgent)) return "iPhone";
            else if (/(iPad)/i.test(navigator.userAgent)) return "iPad";
            else if (/(Android)/i.test(navigator.userAgent)) return "Android";
            else return "Desktop";
        }
    };
	//微信环境下的特殊处理
	if(window.util.versions.weixin){
		//若商家启用了自动登陆，且取不到用户微信ID
		if(-1<g_sys_info.payType.join(",").indexOf("weixin")&&g_sys_info.svcPlatCode&&(!cookie(g_sys_info.svcPlatCode + "_openid"))){
			//若平台允许微信支付，且没有消费者在对应平台的微信ID，获取在支付平台的微信ID
			return window.directWxOpenId(g_sys_info.svcPlatCode, window.location.href.toLowerCase().split("/w/")[0] + "/w/data/getWxOpenId/" + g_sys_info.svcPlatCode + "?returnUrl=" + encodeURIComponent(location.href));
		}else if(g_sys_info.quickLogin){
			if((!cookie(g_sys_info.code + "_openid"))){
				//获取客户在商家的微信ID
				return window.redirectWxOpenId(g_sys_info.wxAppId, window.location.href.toLowerCase().split("/w/")[0] + "/w/data/getWxOpenId/" + g_sys_info.code + "?returnUrl=" + encodeURIComponent(location.href));
			}else{
				window.wx_openId = cookie(g_sys_info.code + "_openid");
				window.wx_did = cookie(g_sys_info.code + "_did")||"";
				window.wx_pid = cookie(g_sys_info.code + "_pid")||"";
			}
		}
        //赵春辉	处理图片长按识别二维码问题	2015-10-11
        scrollable.prototype.isFormElement = function (node) {
            if (node && node.nodeType !== 1) { node = node.parentNode; }
            if (!node || node.nodeType !== 1) { return false; }
            var t = node.tagName;
            return (t === "SELECT" || t === "INPUT" || t === "TEXTAREA" || t === "BUTTON" || "IMG" === t);
        };
		setTimeout(function(){
			require(["widgets/config/wxConfig"]);
		},5000);
	}
	//页面重定向全部完成
	
    //定义获取地址栏中参数的方法
    window.getParam = function (key) {
        var values = window.location.search.substr(1).split(/[&=]/g), index = array.indexOf(values, key);
        while (-1 < index && 1 === (index & 1)) {
            index = array.indexOf(values, key, index + 1);
        }
        return index > -1 && index < values.length - 1 ? values[index + 1] : "";
    };
	
    //openId保存用户名算了，原来的openId保存在属性window.wxId中
    window.getOpenId = function () {
        return cookie(window.code+"un"||localStorage.getItem(window.code, openId));
    };
    //记录用户名
    window.setOpenId = function (openId) {
        window.openId = openId;
        localStorage.setItem(window.code, openId);
    };
    //提供关闭窗口的方法
    window.closeWindow = function () {
        if (window.WeixinJSBridge) {
            WeixinJSBridge.invoke('closeWindow', {}, function () { });
        } else {
            window.close();
        }
    };
    window.openId = window.getOpenId();
	
    //赵春辉	现在根本没有用到，降低了用户体验	2015-02-07
    window.srcPid = window.srcWxId = "";
    //赵春辉	获取页面的来源的程序	2014-11-27
    var srcInfo = json.fromJson(localStorage.getItem(window.code + "_srcInfo") || "({})"), now = (new Date()).getTime();
    if (!(srcInfo.timeStemp && now - srcInfo.timeStemp < 10000)) {
        //认为来源已过期，需要重新记录来源
        lang.mixin(srcInfo, {
			srcPid: getParam("srcPid"),
			srcWxId: getParam("srcWxId"),
			timeStemp: now
		});
        localStorage.setItem(window.code + "_srcInfo", json.toJson(srcInfo));
    }
    //赵春辉	货主让利的目的不是优惠，而是扩大宣传，所以自己的来源不能是自己	2014-11-27
    window.srcPid = srcInfo.srcPid === window.wx_pid ? "" : srcInfo.srcPid;
    window.srcWxId = srcInfo.srcWxId === window.wx_openId ? "" : srcInfo.srcWxId;
	//将分享页面的来源信息交给分享接口来处理
	
	//app中打开时的特殊处理
	var onAppReady = function(){
		//设置样式，确保有顶部返回栏
		domClass.add(document.body, "inApp");
		//终止启动画面
		navigator&&navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();
	};
    document.addEventListener('deviceready', function () {
		//设置样式，确保有顶部返回栏
		domClass.add(document.body, "inApp");
		//终止启动画面
		navigator&&navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();
		//alert(navigator.splashscreen);
		require(["widgets/common/appDeviceInfo"]);
		//张松   识别网络并保存到window的util属性中
		if(navigator.connection && navigator.connection.type){
			var networkState = navigator.connection.type;
			var states = {};
			states[Connection.UNKNOWN]  = '未知连接';
			states[Connection.ETHERNET] = '以太网';
			states[Connection.WIFI]     = 'WiFi';
			states[Connection.CELL_2G]  = '2G';
			states[Connection.CELL_3G]  = '3G';
			states[Connection.CELL_4G]  = '4G';
			states[Connection.CELL]     = 'Cell generic connection';
			states[Connection.NONE]     = '无网络连接';
			window.util.networkState = states[networkState];
		}
    }, false);
	
    //处理busy时闪烁的问题，free之后busy时间间隔很小，就应该不busy
    var loading = true, needFree = false, initFree = function () {
        var h = domStyle.get(pane, "height");
        if (h) {
            window.free = function () {
                needFree = true;
                setTimeout(function () {
                    if (needFree) {
                        domStyle.set("__loader", "display", "none");
                    }
                }, 300);
            }; window.free();
        } else {
            setTimeout(initFree, 100);
        }
    }, loadView = function () {
        if (loading === false) {
            setTimeout(window.onHashChange, 100);
            loadView = function () { };
            initFree();
        } else {
            setTimeout(loadView, 100);
        }
    }, tryResize = function () {
        //赵春辉	body的高度可能为0，需要强制修改body的高度，使显示正常	2015-01-15
        var h = window.innerHeight || (document.documentElement && document.documentElement.clientHeight) || document.body.clientHeight;
        if (h && document.body) {
            loadView();
        } else {
            setTimeout(function () {
                tryResize();
            }, 300);
        }
    };
    tryResize();
    window.busy = function () {
        needFree = false;
        domStyle.set("__loader", "display", "");
    };
    window.free = function () {
        //domStyle.set("__loader", "display", "none");
    };
	//张松   识别并下载最新APP版本
    window.checkAppVersion = function(){
    	// alert(localStorage.getItem(window.g_sys_info.code + "_version"));
    	var def = new Deferred();
    	window.loadData({
    		modalName:"APP_TSSCF_SMART_APP",
    		where:"APP_ID=" + cqthinkinfo.APP_ID
    	}).then(function(data){
    		if(data&&data.length == 1){
    			// 如果数据库中版本与APP本地版本不一致
    			if(data[0].APP_VER == localStorage.getItem(window.g_sys_info.code + "_version")){
    				def.resolve("已是最新版本");
    			}else{
    				// localStorage.setItem(window.g_sys_info.code + "_version", data[0].APP_VER);
    				/*var lk = domConstruct.create("a",{
    					href:data[0].APP_URL,
    					download:data[0].APP_NAME + "_" + data[0].APP_VER + ".apk"
    				},document.body);
    				lk.click();
    				lk.parentNode.removeChild(lk);*/
    				def.resolve(data[0]);
    			}
    		}else{
    			def.resolve("暂不支持");
    		}
    	});
    	return def;
    };
	//处理view切换动画还没结束就启动新的view切换的问题
    var curViewBak = "", sliding = false,uinfo = null,addLog = function(){
		var p = location.hash.substr(1).split("-");
		p.splice(0,1);
		try{
			var data = {
				logType:"viewChange",
				logTime:g_s.getDateTime(),
				host:location.hostname,
				svc:g_sys_info.code,
				oldView:oldView||"",
				newView:curView,
				param:p.join("-")
			};
			if(uinfo&&uinfo.getUserInfo()&&uinfo.getUserInfo().partnerId){
				data.pid = uinfo.getUserInfo().partnerId;
			}
			if(window.wx_openId){
				data.wxId = window.wx_openId;
			}
			xhr("POSt",{
				async:true,
				url:"http://log.cqthink.com/log/add",
				content:{
					data:json.toJson(data)
				}
			});
		}catch(e){
			
		}
	};
	window.onHashChangeDone = function(){
    	//两种都没取到时的默认值
		var newView = window.curView = window.curView || "main";
		window.did = window.did || 0 === window.did ? window.did : "";
		if (window.viewParam[newView].view) {
			window.viewParam[newView].view.show();
			addLog();
		} else {
			return require([window.viewParam[newView].dojoType], function (View) {
				var v = window.viewParam[newView].view = new View(lang.mixin(window.viewParam[newView], {
					id: newView,
					style: "position:relative;display:block;",
					height: "100%"
				}));
				v.connect(v, "onAfterTransitionIn", function () {
					topic.publish("widgets/show/view", this.id);
				});
				pane.appendChild(v.domNode);
				v.startup();
				v.show();
				addLog();
			});
		}
		setTimeout(function () {
			window.viewParam[newView].view.resize();
			window.viewParam[newView].view.initData();
		});
    }

    
    window.onHashChange = function (e) {
        window.busy();
        window.oldView = window.curView;
        var params = null;

        //处理新老接口的兼容性
        var hash = (window.location.hash || "#").split("?")[0].split("&")[0].substr(1).split("-");
		window.curView = hash.shift();
        // window.curView = hash.shift() || "main";
        window.did = hash.join("-") || "";
        //赵春辉	有时候?出现在#之后，会导致错误	2015-12-18
        window.did = window.did.split("?")[0];
        sliding = true;
        setTimeout(function () {
        	sliding = false;
        }, 500);
        curViewBak = window.oldView||"";
		// 张松    启动画面，如果没有当前视图，且为本地APP，且为第一次打开，且config中有startNav配置----则显示startNav视图
        if(!window.curView && window.isLocalApp&&window.util.networkState!="无网络连接"){
			
        	window.checkAppVersion().then(function(data){
        		if(data.APP_VER && window.viewParam["startNav"]){
        			window.curView = "startNav";
        		}
        		window.onHashChangeDone();
        	});
        }else{
    		window.onHashChangeDone();
        }
    };
    window.getCurrentView = function () {
        return registry.byId(window.curView);
    };
    connect.connect(window, "onhashchange", window.onHashChange);
    window.moveToView = function (view, did) {
        return window.location.href = "#" + view + (did || 0 === did ? "-" + did : "");
    };
    //视图盖度的问题
    connect.connect(window, "onresize", window, function () {
        var view = window.curView && window.viewParam[window.curView].view;
        if (view) {
            view.set("height", "100%");
            view.resize();
        }
    });

    window.fixedTo = function (value, cm) {
        // 有值才处理小数
        if (value || 0 === value) {
            cm = parseInt(cm, 10);
            if (cm && cm < 8) {
                //有效数字为 0 到 6 位时
                value = parseFloat(value, 10).toFixed(cm - 1);
            } else {
                //不控制时，解析为正常的小数
                value = parseFloat(value, 10);
            }
        } else {
            value = "";
        }
        return value;
    };

    window.initUserInfo = function (token) {
        window.userInfo = lang.mixin(window.userInfo || {}, {
            token: token || (new Date()).getTime()
        });
        window.updateUserInfo();
    };
    window.updateUserInfo = function () {
        localStorage.setItem(window.code + "i", json.toJson(window.userInfo));
    };
    window.userInfo = localStorage.getItem(window.code + "i");

    if (window.userInfo) {
        window.userInfo = json.fromJson(window.userInfo);
    } else {
        window.initUserInfo();
    }

    var topPane = null;
    //取数据的方法
    //param的内容1：{modalName:"",where:"",orderBy:"",pageSize:"",pageIndex:""},modalName和where是必须的
    //param的内容2：{modalName:"",filter:"",param:{},orderBy:"",pageSize:"",pageIndex:""},modalName/filter/param是必须的，param属性为hash
    window.loadData = function (param) {
        if (param.filter) {
            param.hash = encodeURIComponent(json.toJson(param.param));
            delete param.param;
        }
        var def = new Deferred();
        xhr("GET", {
            url: g_sys_info.url_usr,
            handleAs: "json",
            load: function (data) {
                def.resolve((data && data.data && data.data.items) || []);
            }, //load中可以获取数据
            sync: false,
            preventCache: true,
            content: param
        });
        return def;
    };

    //工具函数
    g_s = {
        datePart: function (interval, dtTmp) {
            try {
                var partStr = "";
                //如果是字符串转换为日期型    
                if (typeof dtTmp == 'string') myDate = this.stringToDate(dtTmp);
                var Week = ['日', '一', '二', '三', '四', '五', '六'];
                switch (interval) {
                    case 'y': partStr = myDate.getFullYear(); break;
                    case 'm': partStr = myDate.getMonth() + 1; break;
                    case 'd': partStr = myDate.getDate(); break;
                    case 'w': partStr = Week[myDate.getDay()]; break;
                    case 'wm': partStr = this.weekNumOfMonth(myDate); break;
                    case 'wy': partStr = this.weekNumOfYear(myDate); break;
                    case 'h': partStr = myDate.getHours(); break;
                    case 'n': partStr = myDate.getMinutes(); break;
                    case 's': partStr = myDate.getSeconds(); break;
                    default:
                }
                return partStr;
            } catch (e) {
                RSAlert(g_sExcept + "datePart()" + e);
            }
            return 1;
        },
        stringToDate: function (DateStr) {
            if (typeof (DateStr) === "string") {
                var dateArray = array.map(DateStr.split(/[ \-:]/g), function (i) {
                    return i - 0;
                });
                if (dateArray.length !== 6) {
                    if (dateArray[0] > 1000) {
                        dateArray.push(0, 0, 0);
                    } else {
                        dateArray.splice(0, 0, 1970, 1, 1);
                    }
                }
                return new Date(dateArray[0], dateArray[1] - 1, dateArray[2], dateArray[3], dateArray[4], dateArray[5]);
            } else if ("number" === typeof (DateStr)) {
                return new Date(DateStr);
            } else {
                return DateStr;
            }
        },
        weekNumOfMonth: function (dtTmp) {
            try {
                var ary = this.toArray(dtTmp);
                var date = new Date(ary[0], parseInt(ary[1]), ary[2]);
                var w = date.getDay();
                var d = date.getDate();
                //(6-w)当前周的还有几天过完（不算今天）。ceil返回大于等于其数字参数的最小整数。
                var monthWeek = Math.ceil((d + 6 - w) / 7);
                return monthWeek;
            } catch (e) {
                RSAlert(g_sExcept + "weekNumOfMonth()" + e);
            }
            return 1;
        },
        toArray: function (dtTmp) {
            var dateArr = [];
            if (dtTmp && typeof (dtTmp) === "object") {
                dateArr = this.toDateString(dtTmp).split("-");
                dateArr[1] = dateArr[1] - 1;
            }
            return dateArr;
        },
        weekNumOfYear: function (dtTmp) {
            try {
                var ary = this.toArray(dtTmp);
                var date1 = new Date(ary[0], parseInt(ary[1]), ary[2]);
                //当年第一天
                var date2 = new Date(ary[0], 0, 1);
                //d是当前日期是今年第多少天
                var d = Math.round((date1.valueOf() - date2.valueOf()) / 86400000) + 1;
                //用d + 当前年的第一天的周差距的和在除以7就是本年第几周
                var yearWeek = Math.ceil((d + date2.getDay()) / 7);
                return yearWeek;
            } catch (e) {
            }
            return 1;
        },
        getGuid: function () {
            var guid = window.wx_openId || localStorage.getItem((window.code || g_sys_info.code) + "guid");
            if (!guid) {
                guid = this.newGuid();
                localStorage.setItem((window.code || g_sys_info.code) + "guid", guid);
            }
            return guid;
        },
        newGuid: function () {
            var guid = "";
            for (var i = 1; i <= 32; i++) {
                var n = Math.floor(Math.random() * 16.0).toString(16);
                guid += n;
                if ((i == 8) || (i == 12) || (i == 16) || (i == 20))
                    guid += "-";
            }
            return guid;
        },
        getDate: function () {
			var d = new Date();
			d.setTime(d.getTime() - this._dateDiff);
			return this.toDateString(d);
        },
        getDateTime: function () {
        	var d = new Date();
        	d.setTime(d.getTime() - this._dateDiff);
			return this.toDateTimeString(d);
        },
        //提供日期相关函数
        //日期转日期字符串
        toDateString: function (date) {
            return typeof (date) === "string" ? date : date.getFullYear() + "-" + (date.getMonth() < 9 ? "0" : "") + (date.getMonth() + 1) + "-" + (date.getDate() < 10 ? "0" : "") + date.getDate();
        },
        //日期转时间字符串
        toTimeString: function (date) {
            return typeof (date) === "string" ? date : (date.getHours() < 10 ? "0" : "") + date.getHours() + ":" + (date.getMinutes() < 10 ? "0" : "") + date.getMinutes() + ":" + (date.getSeconds() < 10 ? "0" : "") + date.getSeconds();
        },
        //日期转日期时间字符串
        toDateTimeString: function (date) {
            return typeof (date) === "string" ? date : this.toDateString(date) + " " + this.toTimeString(date);
        },
        //字符串转日期，若没有时间部分，时间部分设置为00:00:00
        toDate: function (dateString) {
            return this.stringToDate(dateString);
        },
        //时间增加
        dateAdd: function (dtTmp, strInterval, Number) {
            try {
                var myDate = this.toDate(dtTmp);
                switch (strInterval) {
                    case 's': return new Date(Date.parse(myDate) + (1000 * Number));
                    case 'n': return new Date(Date.parse(myDate) + (60000 * Number));
                    case 'h': return new Date(Date.parse(myDate) + (3600000 * Number));
                    case 'd': return new Date(Date.parse(myDate) + (86400000 * Number));
                    case 'w': return new Date(Date.parse(myDate) + ((86400000 * 7) * Number));
                    case 'm': return new Date(myDate.getFullYear(), (myDate.getMonth()) + Number, myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                    case 'q': return new Date(myDate.getFullYear(), (myDate.getMonth()) + Number * 3, myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                    case 'y': return new Date((myDate.getFullYear() + Number), myDate.getMonth(), myDate.getDate(), myDate.getHours(), myDate.getMinutes(), myDate.getSeconds());
                    default:
                }
            } catch (e) {
                RSAlert(g_sExcept + "dateAdd()" + e);
            }
            return 1;
        },
        dateDiff: function (strInterval, dateStart, dateEnd) {
            var dtStart = dateStart;
            var dtEnd = dateEnd;
            //如果是字符串转换为日期型  
            if (typeof dateStart == 'string') dtStart = this.stringToDate(dateStart);
            if (typeof dateEnd == 'string') dtEnd = this.stringToDate(dateEnd);
            switch (strInterval) {
                case 's': return parseInt((dtEnd - dtStart) / 1000);
                case 'n': return parseInt((dtEnd - dtStart) / 60000);
                case 'h': return parseInt((dtEnd - dtStart) / 3600000);
                case 'd': return parseInt((dtEnd - dtStart) / 86400000);
                case 'w': return parseInt((dtEnd - dtStart) / (86400000 * 7));
                case 'm': return (dtEnd.getMonth() + 1) + ((dtEnd.getFullYear() - dtStart.getFullYear()) * 12) - (dtStart.getMonth() + 1);
                case 'y': return dtEnd.getFullYear() - dtStart.getFullYear();
                default:
            }
            return 1;
        },
        //服务器时间与本地时间的差值
        _dateDiff:0,
        initDateDiff: function () {
            xhr("POST", {
                url: "/w/data/GetDataTime/" + g_sys_info.code,
                handleAs: "json",
                load: lang.hitch(this, function (result) {
                    if (result.nowTime) {
						this._dateDiff = (new Date()).getTime()-this.stringToDate(result.nowTime).getTime();
                    }
                })
            });
        }
    };

    ready(function () {
		g_s.initDateDiff();

		window.confirm = function (txt) {
			var iframe = domConstruct.create("IFRAME", { style: "display:none;" });
			domAttr.set(iframe, "onload", function (e) { e.preventDefault(); });
			iframe.setAttribute("src", 'data:text/plain,');
			document.documentElement.appendChild(iframe);
			var rtn = window.frames[0].window.confirm(txt || "");
			iframe.parentNode.removeChild(iframe);
			return rtn;
		};
		window.prompt = function (txt, t) {
			var iframe = domConstruct.create("IFRAME", { style: "display:none;" });
			domAttr.set(iframe, "onload", function (e) { e.preventDefault(); });
			iframe.setAttribute("src", 'data:text/plain,');
			document.documentElement.appendChild(iframe);
			var rtn = window.frames[0].window.prompt(txt || "", t || "");
			iframe.parentNode.removeChild(iframe);
			return rtn;
		};
		require(["widgets/userInfo"], function (userInfo) {
			userInfo.hasLogin();
			uinfo = userInfo;
		});
		
        topPane = registry.byId("topPane");
        domStyle.set(topPane.domNode, "height", "100%");
        topPane.connect(topPane, "onLoad", function () {
            pane = query(".centerPane")[0];
            loading = false;
            //获取alert节点
            var alertDom = query(".toast")[0];
            //如果没有alert节点，则显示默认的alert
            if (alertDom) {
                window.alert = function (txt) {
                    //如果有alert节点，则修改节点显示内容并显示
                    query(".toast_inner p")[0].innerHTML = txt;
                    domStyle.set(alertDom, "display", "block");
                    //3秒后，隐藏alert
                    setTimeout(function () {
                        domStyle.set(alertDom, "display", "none");
                    }, 3000);
                };
            } else {
                window.alert = function (txt) {
                    var iframe = domConstruct.create("IFRAME", { style: "display:none;" });
                    domAttr.set(iframe, "onload", function (e) { e.preventDefault(); });
                    iframe.setAttribute("src", 'data:text/plain,');
                    document.documentElement.appendChild(iframe);
                    window.frames[0].window.onclick = function (e) { e.preventDefault(); };
                    var rtn = window.frames[0].window.alert(txt || "");
                    iframe.parentNode.removeChild(iframe);
                    return rtn;
                };
            }
        });
		
		//处理Android设备上的返回键的点击
		var backMenuTimer = null,backMenuClicked = false,backButtonClick = function(){
			if("main"==window.curView||""==window.curView){
				//window.hideToastMessage();
				if(backMenuClicked){
					document.removeEventListener("backbutton", backButtonClick, false);
					if(navigator.app&&navigator.app.exitApp){
						navigator.app.exitApp();
					}else{
						history.back();
					}
				}
				//window.toastMessage("再次点击退出");
				alert("再次点击退出");
				if(backMenuTimer){
					clearTimeout(backMenuTimer);
				}
				backMenuClicked = true;
				setTimeout(function(){
					backMenuClicked = false;
				},2000);
			}else{
				history.back();
			}
		};
		document.addEventListener("backbutton", backButtonClick, false);
		if(window.navigator&&navigator.splashscreen){
			navigator.splashscreen.hide();
		}
		/*window.toastMessage = function(message,duration,position,success,error){
			window.plugins&&window.plugins.toast&&window.plugins.toast.show(message,duration||'short',position||'bottom',success||function(){
			},error||function(){
			});
		};
		window.hideToastMessage = function(){
			window.plugins&&window.plugins.toast&&window.plugins.toast.hide();
		};*/
    });
	
	//发送验证码
	var isSend = true; //定义全局变量 是否发送的标志  60秒内不能重复发送
	var isVari = true; //定义全局变量  验证码是否有效  5分钟内验证码有效
	//发送验证码
	window.sendMsg = function (phone) { //发送验证码
		if (isSend) {
			isSend = false; //60秒后方可再次发送
			var def = new Deferred();
			xhr("GET", {
				url: "/w/data/getSmsPwd/" + g_sys_info.code + "?phone=" + phone,
				handleAs: "json",
				load: lang.hitch(this, function (result) {
					if (1 === result.rtnType) {
						alert("验证码已发送，请查看新的手机短信息！如果您的手机具备手机拦截功能，也请检查被拦截的短信息。");
						def.resolve(true);
						isVari = true; //验证码5分钟内有效
						setTimeout(function () {
							isSend = true;
						}, 60000); //60 000ms后即60秒可以发送
						setTimeout(function () {
							isVari = false;
						}, 300000); //30 000ms后即5分钟后，验证码过期，需重新发送
					} else {
						//执行失败
						alert("验证码发送失败，请稍后重试。如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
						def.resolve(false);
					}
				}),
				error: function () {
					isSend = true; //60秒后方可再次发送
					//出错
					def.resolve();
				}
			});
			return def;
		} else {
			alert("您的发送验证码请求间隔太短，请稍候再发送验证码！");
			window.free();
		}
	};
	//验证验证码
	window.postVerCode = function (phone, code) {
		if (isVari) {
			var def = new Deferred();
			xhr("GET", {
				url: "/w/data/validSmsPwd/" + g_sys_info.code + "?phone=" + phone + "&pwd=" + code,
				handleAs: "json",
				content: {
					guid: g_s.getGuid()
				},
				load: lang.hitch(this, function (result) {
					if (1 === result.rtnType) {
						if (result.data && userInfo.serverUserInfoBack) {
							userInfo.serverUserInfoBack(result.data);
						}
						def.resolve(true);
					} else {
						//执行失败
						alert("您输入的验证码不正确，请检查后重新输入！如您长时间未收到系统发送的验证码，请检查是否被拦截功能拦截，或请致电400-023-8993咨询！");
						def.resolve(false);
					}
				}),
				error: function () {
					//出错
					def.resolve(false);
				}
			});
			return def;
		} else {
			alert("验证码5分钟内有效，您的验证码已过期，请再次发送验证码！");
			window.free();
		}
	};
});