﻿define([
	"dojo/_base/lang",
	"cqthink/mobile/util"
],function(lang,util){
	var capture = null,inited = null,pendding = false,setPending = function(){
		pendding = false;
	},isPendding = function(){
		if(pendding){
			return true;
		}else{
			pendding = true;
			setTimeout(setPending,500);
			return false;
		}
	};/*
	if(window.WeixinJSBridge&&1===2){
		//微信浏览器模式，通过2微信浏览器jsapi选取文件，有问题，不可行
		var xhr = null,domConstruct;
		require(["dojo/dom-construct","dojo/_base/xhr"],function(dojoDomConstruct,dojoXhr){
			domConstruct = dojoDomConstruct;
			xhr = dojoXhr;
		});
		capture = function(){
			if(isPendding()){
				return;
			}
			if(null===inited){
				this._initWxConfig(callback,errorback);
			}else{
				wx.chooseImage({
					success:function(res){
						var localIds = res.localIds;
						if(callback&&localIds&&localIds.length){
							callback(localIds[0]);
						}
					},
					error:errorback||function(){}
				});
			}
		};
		return {
			show:capture,
			showOpener:function(domNode,position,callback,errorback){
				return this.show(callback,errorback);
			},
			_initWxConfig:function(callback,errorback){
				//加载微信jsapi的js
				domConstruct.create("script",{
					type:"text/javascript",src:"http://res.wx.qq.com/open/js/jweixin-1.0.0.js",
					load:lang.hitch(this,function(){
						//微信程序加载成功，请求微信jsapi初始化配置参数
						xhr("GET",{
							url:"/w/wxauth/GetSvcJsApiConfig/"+g_sys_info.code,
							handleAs:"json",
							content:{
								u:window.location.href.split("#")[0]
							},
							load:lang.hitch(this,function(res){
								if(res&&1==res.rtnType&&res.data&&res.data.jsApiList){
									wx.ready(function(){});
									//成功获取到商家微信jsapi配置信息，初始化配置
									wx.config(res.data);
									//若公众号支持使用选取图片的jsapi，认为支持，否则，不支持
									inited = -1<res.data.jsApiList.join(",").indexOf("chooseImage");
									setPending();
									this.show(callback,errorback);
								}else{
									//商家不支持使用微信jsapi
									inited = false;
									errorbak({message:"加载微信配置程序错误"});
								}
							}),
							error:lang.hitch(this,function(res){
								//请求配置参数出错，认为不支持微信jsapi
								inited = false;
								errorbak({message:"加载微信配置程序错误"});
							})
						});
					}),
					error:function(){
						//加载微信js程序出错，认为不支持
						inited = false;
						errorbak({message:"加载微信程序错误"});
					}
				},document.body);
			}
		};
	}else if(util.isBrowser()){*/
		var fs = null;
		//浏览器，通过本地磁盘文件系统选取图片文件
		require(["cqthink/fs/localDiskFS"],function(FS){
			fs = FS;
		});
		capture = function(callback,errorback){
			if(isPendding()){
				return;
			}
			fs.selectFiles({
				fileType:"image/*"
			}).then(function(files){
				if(files.length){
					fs.readAsDataURL([files[0]]).then(function(urls){
						callback(urls[0]);
					});
				}else{
					callback("");
				}
			},errorback);
		};
		return {
			show:capture,
			showOpener:function(domNode,position,callback,errorback){
				return this.show(callback,errorback);
			}
		};/*
	}else{
		//设备APP状态，通过cordova插件选取图片获取调用相机
		var List = null,Item = null,SimpleDialog = null,domStyle = null;
		require(["dojo/dom-style","dojox/mobile/EdgeToEdgeList","dojox/mobile/ListItem","dojox/mobile/SimpleDialog"],function(dojoDomStyle,EdgeToEdgeList,ListItem,Dialog){
			domStyle = dojoDomStyle;
			List = EdgeToEdgeList;
			Item = ListItem;
			SimpleDialog = Dialog;
		});
		return {
			_init:function(callback,errorback){
				this._callback = callback;
				this._errorback = errorback;
				if(this.dialog){
					return;
				}
				this._inited = true;
				this.dialog = new SimpleDialog({style:"width:240px;",title:"选择来源"});
				this.dialog.containerNode.appendChild((this.list = new List()).domNode);
				this.list.addChild(new Item({
					label:"拍照",
					clickable:true,
					noArrow:true,
					onClick:lang.hitch(this,function(){
						this._captureImg("CAMERA");
					})
				}));
				this.list.addChild(new Item({
					label:"相册",
					clickable:true,
					noArrow:true,
					onClick:lang.hitch(this,function(){
						this._captureImg("PHOTOLIBRARY");
					})
				}));
				this.list.addChild(new Item({
					label:"图片",
					clickable:true,
					noArrow:true,
					onClick:lang.hitch(this,function(){
						this._captureImg("SAVEDPHOTOALBUM");
					})
				}));
				this.list.addChild(this.cancelItem = new Item({
					label:"取消",
					clickable:true,
					noArrow:true,
					onClick:lang.hitch(this,function(){
						this.dialog.hide();
					})
				}));
				document.body.appendChild(this.dialog.domNode);
				this.dialog.startup();
			},
			show:function(callback,errorback){
				if(isPendding()){
					return;
				}
				this._init(callback,errorback);
				domStyle.set(this.cancelItem.domNode,"display","");
				this.dialog.containerNode.appendChild(this.list.domNode);
				this.dialog.show();
				this.dialog.resize();
			},
			showOpener:function(domNode,position,callback,errorback){
				if(isPendding()){
					return;
				}
				this._init(callback,errorback);
				domStyle.set(this.cancelItem.domNode,"display","none");
				util.showInOpener(this.list.domNode,domNode,position);
			},
			//原来是公开文件，现在是私有的，代码处问题时再检查，应该没人调用这个函数
			_captureImg:function(type){
				this.dialog&&this.dialog.hide();
				util.hideOpener();
				this.catureImgData(type,this._callback,this._errorback);
			},
			catureImgData:function(type,callback,errorback){
				if(!navigator.camera) return alert("需要移动设备的支持");
				navigator.camera.getPicture(
					function(data){
						if(callback){
							callback("data:image/png;base64,"+data);
						}
					},
					errorback||function(){},
					{
						quality: 50, 
						//允许编辑会导致的图像不清晰----即使分辨率足够高
						//赵春辉	周六讨论的结果是允许编辑，图片质量的问题再处理	20140421
						allowEdit: true,
						//这两个参数实际上是图片的长宽比，不是去的的图片的实际像素值
						//targetWidth:640,
						//targetHeight:480,
						//获取的图片的目标类型是base64字符串
						destinationType:navigator.camera.DestinationType.DATA_URL,
						sourceType:navigator.camera.PictureSourceType[type],
						//图片类型为png格式
						encodingType:Camera.EncodingType.PNG
					}
				);
			}
		};
	}*/
});