define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array"
], function(declare,base,registry,query,array) {
    return declare("widgets.common._ClassRoomListMixin", [base], {
        indexReVillagerElement:function(){
            this.inherited(arguments);
            this.cultivation = registry.byNode(query(".cultivation",this.domNode)[0]);
        },
        getItemPos:function(i){
            var appendClass = "";
            if((i+1)%4==0)
            {
                appendClass = "villagerRightItem";
            }
            return appendClass;
        },
        initReVillagerEvent:function(){
            this.inherited(arguments);
            this.connect(this.cultivation,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item,i){
                    // 如果行数/4的余数为0
                    //item.appendClass = this.getItemPos(i);
                    
                    item.appendClass = "";
                    if((i+1)%3==0){
                        item.appendClass = "margin-right:0;";
                    }
                    if(i>2){
                        item.appendClass += "margin-top:10px;";
                    }
                },this);
            });
        },
        refreshAllList:function(){
            this.cultivation.refreshList();
        }
    });
});