define([
    "dojo/_base/declare", 
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/Deferred",
    "../orderCarRecord", 
    "../userInfo"
], function(declare, lang, array, xhr, json, Deferred, orderCarRecord, userInfo) {
    return declare("widgets.common._DepositMixin",null,{
        _dealDeposit: function(mat,qty) {
            var def = new Deferred();
            xhr("GET",{
                url:"/w/data/GetMatsCreditByQty/"+window.code+"-"+window.openId,
                handleAs:"json",
                content: {
                    mats: mat,
                    qtys: qty
                },
                load:function(result) {
                    var desInfo = {};
                    if(result&&result.data&&result.data.items){
                        //商品的积分政策
                        Deposit = parseFloat(result.data.items[0].CREDIT,10)||0;
                    }
                    //将提交结果直接返回给调用者
                    def.resolve(Deposit);
                },
                error:function(err){
                    //提交订单错误，返回错误及信息
                    def.resolve({
                        rtnType:"101",
                        message:err&&err.message||"数据错误"
                    });
                }
            });
            return def;
        }
    });
});