define([
    "dojo/_base/declare",
    "dijit/registry"
], function(declare,registry) {
    return declare("widgets.common._HotSaleMixin", null, {
        isHotSaleListLoaded: function() {
            return !!this.hotSaleList;
        },
        indexHotSaleElement: function() {
            this.hotSaleList = dijit.registry.getEnclosingWidget(dojo.query("._z")[0]);
        },
        initHotSaleEvent: function() {
        },
        refreshAllList: function() {
            this.hotSaleList.refreshList();
            this.inherited(arguments);
        }
    });
});