define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "../userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr"
    ], function(declare, lang, registry, userInfo,json,xhr) {
    return declare("widgets.common._IllegalQryMixin", null, {
        isIllegalQryLoaded: function() {
            return !!this.illegalQry;
        },
        indexIllegalQryElement: function() {
            this.illegalQry = registry.byId("driveIlegalList");
        },
        refreshAllList: function() {
            if (window.titleNode) {
                window.titleNode.innerHTML = "违章记录";
            }
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this, function(s) {
                if (s) {
                    xhr("POST", {
                        url: "/w/exec/exec/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token+"&tp=drive_illegal&paramStr="+g_sys_info.aid+","+userInfo.getUserInfo().partnerId+",NULL,NULL",
                        handleAs: "json",
                        load: lang.hitch(this, function(result) {
                            if (1 == result.rtnType) {
                                this.illegalQry.refreshList();
                            } else {
                                alert(result.message || "数据错误!");
                                window.free();
                            }
                        })
                    });
                } else {
                    window.nextPageOnLogin = "driveIlegal";
                    userInfo.showLogin();
                }
            }));
        }
    });
});