define([
    "dojo/_base/declare", 
    "dijit/registry"], function(declare, registry) {
    return declare("widgets.common._MatLegalDtlMixin", null, {
        isMatLegalDtlLoaded:function(){
            return !!this.nList;
        },
        indexMatLegalDtlElement:function(){
            this.nList =registry.byId("legalDtl");
            this.orderList = registry.byId("legalOrder");
        },
        initMatLegalDtlEvent:function(){
            this.connect(this.nList,"onDefRendered",function(data){
                if(data.data.items.length){
                    window.orderId = data.data.items[0].BILLID.T4_EntryID;
                    this.orderList.refreshList();
                }
            });
        },
        refreshAllList: function() {
            this.inherited(arguments);
            window.updateTitle("投诉详情");
            this.did = window.did;
            this.nList.refreshList();
            this.scrollTo({x:0,y:0});
        }
    });
});