define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class"
], function(declare, registry,domAttr,query,array,lang,domStyle, domClass) {
    return declare("widgets.common._MatListZctMixin.js",null,{
        defaultflt:"36",
        OrigAid:true,
        isMatListLoaded:function(){
            return !!this.matList;
        },
        refreshAllList:function(){
            
            //window.updateTitle("商品列表");
            if(this.order_control){
                this.matList.rs_wb_order = "[T0_MCode] ASC";
                query("a",this.order_control).forEach(function(n){
                    if(!domAttr.get(n,"changeViewEf")){
                        if(domAttr.get(n,"name")=="[T0_MCode]"){
                            domAttr.set(n,"class","arrow-up");
                            domAttr.set(n,"selected","true");
                        }else{
                            domAttr.set(n,"class","");
                            domAttr.set(n,"selected","false");
                        }
                    }
                });
            }
            query("#topUl li")[1].innerText="全部分类";
            if(window.did.indexOf('aid_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = this.defaultflt;
                var aid=window.did.split("_")[1];
                if(this.OrigAid)
                {
                    this.bigParam = {"OrigAid":aid,"INPUT":'',"T0_TPCH_NUM":'',"childMGID":'',"parentMGID":'',"IS_CX":"","IS_TG":"","SERVICE_TYPE":"","GName":""};
                }
                else
                {
                    this.bigParam = {"AID":aid,"INPUT":'',"T0_TPCH_NUM":'',"childMGID":'',"parentMGID":'',"IS_CX":"","IS_TG":"","SERVICE_TYPE":"","GName":""};
                }
                if(aid==window.g_sys_info.aid&&this.OrigAid)
                {
                    this.bigParam.OrigAid="";
                }
                this.matList.rs_wb_param="("+JSON.stringify(this.bigParam)+")";
                this.matList.refreshList();
                if(!this.OrigAid)
                {
                    this.matGroup.rs_wb_param = "({AID:"+aid+"})";
                }
                this.matGroup.refreshList();
                this.curMatList = this.matList;
                
            }else if(window.did.indexOf('std_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "24";
                this.matList.rs_wb_param = "({MGID:"+window.did.split("_")[1]+",INPUT:''})";
                this.matList.refreshList();
                this.matGroup.rs_wb_param = "({AID:"+g_sys_info.aid+"})";
                this.matGroup.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('matgroup_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "03";
                this.matList.rs_wb_param = "({AID:"+window.did.split("_")[1]+",MGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.matGroup.rs_wb_param = "({AID:"+g_sys_info.aid+"})";
                this.matGroup.refreshList();
                this.curMatList = this.matList;
            }else if(window.did.indexOf('dist_')>-1){
                this.did = window.did;
                this.matList.rs_wb_flt = "27";
                this.matList.rs_wb_param = "({DistID:"+window.did.split("_")[1]+",PGID:"+window.did.split("_")[2]+",INPUT:''})";
                this.matList.refreshList();
                this.matGroup.rs_wb_param = "({AID:"+g_sys_info.aid+"})";
                this.matGroup.refreshList();
                this.curMatList = this.matList;
            }else{
                if (window.did != this.did) {
                    this.did = window.did;
                    if(this.OrigAid)
                    {
                        this.bigParam={"T0_TPCH_NUM":"","childMGID":"","parentMGID":window.did,"OrigAid":"","IS_CX":"","IS_TG":"","SERVICE_TYPE":"","GName":""};
                    }
                    else
                    {
                        this.bigParam={"T0_TPCH_NUM":"","childMGID":"","parentMGID":window.did,"IS_CX":"","IS_TG":"","SERVICE_TYPE":"","GName":""};
                    }
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")","",this.defaultflt);
                    this.matGroup.rs_wb_param = "({AID:"+g_sys_info.aid+"})";
                    this.matGroup.refreshList();
                }else{
                    window.updateTitle(this.mGroupName);
                }
                this.curMatList = this.matList;//记录当前list2
            } 
            query("#topUl li")[2].innerText="默认排序";
            query("#topUl li")[3].innerText="筛选";
           // this._clearUlStyle();
            setTimeout(window.free,100);
            
            //{"T0_TPCH_NUM":"","childMGID":"","parentMGID":window.did,"OrigAid":"","IS_CX":"","IS_TG":"","SERVICE_TYPE":""}
            /*
                T0_TPCH_NUM：限购
                childMGID：子分类下的商品
                parentMGID：某一级分类下所有商品
                OrigAid：商家id
                IS_CX：是否促销商品
                IS_TG：团购商品
                SERVICE_TYPE:服务类型
                GName:商品名称
            */
        },
        myRefreshList:function(param,order,flt){
            if(this.matList)
            {
                // this.bigParam=param;
                this.matList.rs_wb_param =param||"("+JSON.stringify(this.bigParam)+")";
                this.matList.rs_wb_order = order||"[T0_MCode]";
                this.matList.rs_wb_flt=flt||this.curMatList.rs_wb_flt;
                this.matList.refreshList();
                this._closeNavDropDownItem();
                window.busy();
                this.curMatList = this.matList;
            }
        },
        indexMatListElement:function(){
            if(!this.isMatListLoaded()){
                this.order_control = query(".order_control",this.bodyNode)[0];   //找到商品列表中的排序
                this.matList = registry.byId("materList");                       //得到matlist节点的id
                this.searchMatBtn = query(".btn-search",this.bodyNode)[0];
                var head=query(".m-list-1",this.domNode)[0];
                var search=query(".m-list-0",this.domNode)[0];
                this.shelfHeader=query(".shelfHeader",this.domNode)[0];
                this.SearchTxt=query(".searchExpert")[0];                        //搜索
                
                this.shelfHeader.appendChild(search);
                this.shelfHeader.appendChild(head);
                
                var head1 = query("#head", this.domNode)[0];
                this.shelfHeader.appendChild(head1);
                
                this.matGroup=registry.byId("MatGroup"); //得到商品分类的节点
                this.childMG=registry.byId("ChildMG");   //得到商品二级节点
                this.orderDiv=registry.byId("orderUl");  //得到商品排序节点
                this.pointType=registry.byId("pointType");  //得到商品类型的节点
            }

            this.nav_ul = query(".nav_ul", this.domNode)[0];
            this.nav_li = query("li", this.nav_ul);
            this.nav_li.pop();
            this.nav_dropdown_items = query(".nav_dropdowm_item", this.domNode);
            this.nav_dropdowm = query(".nav_dropdowm", this.domNode)[0];
            this.nav_dropdownbg = query(".nav_dropdownbg", this.domNode)[0];
            // changeViewLI             
            this.changeViewLi = query(".changeViewLi", this.domNode)[0];
            this.changeViewLiChild = query("span", this.changeViewLi)[0];
            // 筛选页面所有复选框  所有的复选框及label
            this.checkboxForNav = query(".checkboxForNav", this.domNode);
        },
        initMatListEvent:function(){
            this.connect(this.matList, "onDefRendered", function(data) {
                if(!window.did||window.did.indexOf("aid_")>-1){
                    this.mGroupName = "商品列表";//界面标题更新为商品列表
                }else if(window.did.indexOf("std_")>-1){
                    this.mGroupName = data.data.items[0]["T0_ProductGroupID.PGName"];//界面标题为品类名
                }else{
                    if(data.data&&data.data.items&&data.data.items.length){
                        this.mGroupName = data.data.items[0]["T4_MGName"];//界面标题为商品类别
                    }else{
                        this.mGroupName = '暂无商品';
                    }
                }
                //规范数据中 T0_TPCH_NUM (限购) 的值
                for(var i=0;i<data.data.items.length;i++)
                {
                    if(!data.data.items[i].T0_TPCH_NUM||data.data.items[i].T0_TPCH_NUM<1)
                       data.data.items[i].T0_TPCH_NUM=0; 
                }
               array.forEach(data.data.items,function(item,i){
                   if((i+1)%2==1){
                        item.matlistli="left";
                    }else{
                        item.matlistli="right";
                    }
                    // 如果是分销商品
                    if(item.T0_MTID)
                    {
                        if(item.T18_TPCH_NUM&&item.T18_TPCH_NUM!=0)
                        {
                            item.IS_XG = 1;
                        }
                        else
                        {
                            item.IS_XG = 0;
                        }
                    }
                    // 不是自己的商品
                    else
                    {
                        if(item.T0_TPCH_NUM&&item.T0_TPCH_NUM!=0)
                        {
                            item.IS_XG = 1;
                        }
                        else
                        {
                            item.IS_XG = 0;
                        }
                    }
                    
               });
                //处理界面的标题
                window.updateTitle(this.mGroupName);
                window.free();
            });
          
            /*
             this.connect(this.matList, "onDataReady", function(data) {
                var t=query(".t");
                if(t)
                {
                   array.forEach(t,function(item){
                       if(item.innerText.length>19)
                        {
                            item.innerText=item.innerText.substring(0,19);
                            domClass.add(item,"bbb")
                        }
                   })
                }
             });
            */
            
            //商品分类
            this.connect(this.matGroup,"onDefRendered",function(data){
                var indexAid=window.did.indexOf('aid_')||-1;
                if(data&&data.data&&data.data.items){
                    //初始化二级分类信息
                    this._groupHash = {};
                    var len = data.data.items.length;
                    data.data.items.isBeSelected=0;
                    while(len--){
                        data.data.items[len].selected=0;
                        //遍历所有分类
                        //若是二级分类
                        if(data.data.items[len].UpLevelMGID.MGID){
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID] = this._groupHash[data.data.items[len].UpLevelMGID.MGID]||[];
                            //将本分类添加到二级分类信息中
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID].push(data.data.items[len]);
                            //将当前分类从加载到的分类信息中删除
                            data.data.items.splice(len,1);
                        }
                        else if(indexAid==-1&&window.did!=""&&data.data.items[len].MGID==window.did)
                        {
                            //设置首页进入的分类名称
                            query("#topUl li")[1].innerText=data.data.items[len].MGName;
                            data.data.items[len].selected=1;
                            data.data.items.isBeSelected=1;
                            this.cate_id=data.data.items[len].MGID;
                        }
                    }
                }
                
                //之前做的
               // var arrParentMGid=array.filter(data.data.items, function(item){ //找到所有一级节点
                 //   return item.UpLevelMGID.MGID =="";
                // });
                // this.arrChildMGid=[];   //存放二级节点的数组
                // var index=0;
               //  array.forEach(arrParentMGid,function(item){
               //      //找到每个一级节点对应的二级节点 存放到数组中
                //    var arr=array.filter(data.data.items,function(info){
                 //       return info.UpLevelMGID.MGID==item.MGID
                 //    });
                //     if(arr.length>0)
                //     {
                //        this.arrChildMGid[index]={"mgid":item.MGID,"parentGgId":arr};
                //        index++;
                //     }
                // },this);
            });
            
            //商品一级分类的点击事件
            this.connect(this.matGroup.domNode,"onclick",function(event){
                var str=domAttr.get(event.target,"cate_id");
                
                if(str)
                {
                    array.forEach(dojo.query("#MatGroup li"),function(item){
                        if (domClass.contains(item, "beSelected")){
                            domClass.remove(item,"beSelected");
                        }
                        domClass.remove(item,"cur");
                        domStyle.set(item,{"border-top":"0px"});
                    });
                    domClass.add(event.target,"cur");
                    domStyle.set(event.target,{"border-top":"1px solid white"});
                    if(str=="0")
                    {
                        str="";
                    }
                    window.did=str;
                    //加载二级分类信息
                    if(this._groupHash[str]){
                        this.childMG.onDataReady({
                            data:{items:this._groupHash[str]}
                        });
                        var firstNode=query("#ChildMG li")[0];
                        if(firstNode)
                        {
                            domAttr.set(firstNode,"mgName",event.target.innerText);
                        }
                    }else{
                        //刷新商品列表的数据
                        query("#topUl li")[1].innerText=event.target.innerText;
                        
                        //清空参数信息
                       /* this.bigParam.T0_TPCH_NUM='';
                        this.bigParam.IS_CX='';
                        this.bigParam.IS_TG='';*/
                        this.bigParam.parentMGID=str;
                        this.bigParam.childMGID='';
                        this.myRefreshList("("+JSON.stringify(this.bigParam)+")");
                        this.childMG.onDataReady({   //清空二级分类信息
                            data:{items:[]}
                        });
                        //清空筛选栏的显示
                       this._clearUlStyle();
                    }
                }
            });
            
            //商品二级分类的点击事件
            this.connect(this.childMG.domNode,"onclick",function(event){
                var str=domAttr.get(event.target,"cate_id");
                
                //清空参数信息
               /* this.bigParam.T0_TPCH_NUM='';
                this.bigParam.IS_CX='';
                this.bigParam.IS_TG='';*/
                //this.bigParam.GName="";
                //刷新商品列表的数据
                if(str)
                { 
                    //传入二级分类ID刷新list（点击二级分类）
                    query("#topUl li")[1].innerText=event.target.innerText;
                    //this.bigParam=JSON.parse(this.curMatList.rs_wb_param);
                    this.bigParam.parentMGID='';
                    this.bigParam.childMGID=str;
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")")
                }
                else
                {
                    //传入一级分类ID刷新list（点击全部）
                    //this.bigParam=JSON.parse(this.curMatList.rs_wb_param);
                    this.bigParam.childMGID='';
                    this.bigParam.parentMGID=window.did;
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")")
                    var mgName=domAttr.get(event.target,"mgName");
                    if(mgName){
                         query("#topUl li")[1].innerText=mgName;
                    }
                }
                //清空筛选栏的显示
                query("#topUl li")[2].innerText="默认排序";
                query("#topUl li")[3].innerText="筛选";
                
                //清空样式
                this._clearUlStyle();
            });
            
            //商品排序点击事件
            this.connect(this.orderDiv.domNode,"onclick",function(event){
                var wborder=domAttr.get(event.target,"wborder");
                if(wborder)
                {
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")",wborder)
                }
                query("#topUl li")[2].innerText=event.target.innerText;
            });
            
            //活动商品的筛选
            this.connect(this.pointType.domNode,"onclick",function(event){
                var cancel=domAttr.get(event.target,"myCancel");
                var complete=domAttr.get(event.target,"myComplete");
                var dom=event.target;
                while(dom!=this.pointType.domNode){
                    if(dom.tagName=="LI"){
                        break;
                    }
                    dom=dom.parentNode;
                }
                if(event&&dom&&dom.tagName=="LI")
                {
                    //设置选中样式
                    var check=query(".divCheckbox",dom)[0];
                    domClass.toggle(check, "divInput");
                    if(domClass.contains(check, "divInput")){
                        domStyle.set(check,{backgroundColor:"#e5004f"});
                    }
                    else{
                        domStyle.set(check,{backgroundColor:"white"});
                    }
                }
                var checkList=query("div.divInput",dom.parentNode);
                if(cancel){   //重置
                    //清空选中
                    array.forEach(checkList,function(item){
                        domClass.remove(item,"divInput");
                        domStyle.set(item,{backgroundColor:"white"});
                    });
                    this.bigParam.T0_TPCH_NUM="";   
                    this.bigParam.IS_CX="";   
                    this.bigParam.IS_TG="";  
                    this.bigParam.SERVICE_TYPE="";
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")");
                }
                else if(complete){   //完成
                    this.bigParam.T0_TPCH_NUM="";   
                    this.bigParam.IS_CX="";   
                    this.bigParam.IS_TG="";  
                    this.bigParam.SERVICE_TYPE="";
                    array.forEach(checkList,lang.hitch(this,function(item){
                        var T0_TPCH_NUM=domAttr.get(item.parentNode,"T0_TPCH_NUM");
                        var myCx=domAttr.get(item.parentNode,"IS_CX");
                        var IS_TG=domAttr.get(item.parentNode,"IS_TG");
                        var ServiceType=domAttr.get(item.parentNode,"ServiceType");
                        if(T0_TPCH_NUM){
                            this.bigParam.T0_TPCH_NUM=T0_TPCH_NUM;
                        }
                        else if(myCx){
                            this.bigParam.IS_CX=myCx;
                        }
                        else if(IS_TG){
                            this.bigParam.IS_TG=IS_TG;
                        }
                        else if(ServiceType){
                            this.bigParam.SERVICE_TYPE=ServiceType;
                        }
                    }));
                    this.myRefreshList("("+JSON.stringify(this.bigParam)+")");
                }
                 event.stopPropagation();
            })
            
            
            if(this.searchMatBtn){
                this.searchMatBtn.onclick = lang.hitch(this,this._onMatListSearch);
            }
            if(document.getElementById('search_name')){
                document.getElementById('search_name').onkeydown = lang.hitch(this,function(){
                    if(event.keyCode==13){
                        this._onMatListSearch();
                    }
                });
            }
            if(this.order_control){// 判断是否有商品列表中的排序节点
                this.connect(this.order_control,"onclick",function(e){
                    var dom = e.target;
                    while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                        dom = dom.parentNode;
                    }
                    if(dom&&dom!==this.order_control){
                        if(!domAttr.get(dom,"changeViewEf")){
                            var name = domAttr.get(dom,"name");
                            var cls = domAttr.get(dom,"class");
                            var orderDesc = domAttr.get(dom,"orderDesc");
                            var selected = domAttr.get(dom,"selected");
                            if(selected=="true"){
                                //更新查询条件
                                domAttr.set(dom,"class",(cls===""||cls==="arrow-down")?"arrow-up":"arrow-down");
                                this.curMatList.rs_wb_order = name?((cls===""||cls==="arrow-down")?name:name+" DESC"):"";
                            }else{
                                domAttr.set(dom,"selected","true");
                                this.curMatList.rs_wb_order = name+" "+orderDesc;
                                domAttr.set(dom,"class",orderDesc==="DESC"?"arrow-down":"arrow-up");
                            }
                            this._clearSearchBarStart(dom);
                            this.curMatList.refreshList();
                        }else{
                            domAttr.set(dom,"class",domAttr.get(dom,"class")==="verticalList"?"levelList":"verticalList");
                            domAttr.set(this.matList.domNode,"class",(domAttr.get(this.matList.domNode,"class")==="m-list matList")?"m-l-list matList":"m-list matList");
                        }
                    }
                });
            }
            // 导航栏添加点击事件
            this.connect(query(".nav_ul", this.domNode)[0], "onclick", lang.hitch(this, this._navUlClicked));
            // 点击遮罩层时，关闭弹出的div
            this.connect(this.nav_dropdownbg, "onclick", lang.hitch(this, this._closeNavDropDownItem));
           /* // 重置按钮点击事件
            this.connect(query(".nav_dropdowm_item_btn span", this.nav_dropdown_items[3])[0], "onclick", lang.hitch(this, function(e){
                // 重置所有复选框为未选择
                array.forEach(query("input", this.nav_dropdown_items[3]), function(item){
                    item.checked = false;
                });
                array.forEach(query("label", this.nav_dropdown_items[3]), function(item){
                    domStyle.set(item, {backgroundColor:"white"});
                });
            }));
            // 完成按钮点击事件
            this.connect(query(".nav_dropdowm_item_btn span", this.nav_dropdown_items[3])[1], "onclick", lang.hitch(this,function(e){
                // TODO 完成选择并且提交选择结果，刷新列表数据
                var point=dojo.query(".nav_dropdowm_item_slider li input:checkbox:checked");
               var pointId=domAttr.get(point.domNode,"id");
                    if(pointId=="checkboxFirstInput")
                    {
                        var param="{T0_TPCH_NUM:'2',childMGID:'',parentMGID:str}"
                        this.myRefreshList(param)
                    }
                    else if(pointId=="checkboxFirstInput")
                    {
                        var param="{T0_TPCH_NUM:'0',childMGID:'',parentMGID:"+str+"}"
                        this.myRefreshList(param)
                    }
                    else{
                         var param="{T0_TPCH_NUM:'',childMGID:'',parentMGID:''}"
                         this.myRefreshList(param)
                    }
                
                // 关闭页面
                this._closeNavDropDownItem();
            }));*/
            // changeViewLi 点击事件
            this.connect(this.changeViewLi, "onclick", this.clickChangeViewLi);
            /*lang.hitch(this, function(e){
                this.clickChangeViewLi(e);
            })*/
            // 统一添加点击事件
            this.connect(this.nav_dropdowm, "onclick", lang.hitch(this, function(evt){
                var dom = evt.target;
                if(dom && dom.tagName === "LABEL"){
                    // 筛选页面复选框点击事件
                    domStyle.set(dom, {backgroundColor:domAttr.get(query("input", dom.parentNode)[0], "checked")?"white":"red"});
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartArea")){
                    // TODO 大区域点击事件
                    // 修改点击大区域的样式
                    array.forEach(query(".smartArea li", this.nav_dropdown_items[0]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                    // 显示对应子区域列表(实时加载对应区域数据到子区域列表中/提前加载好，显示对应子区域)
                    var subArea = query(".subSmartArea")[0];
                    if(domAttr.get(dom, "fujin") == 1){
                        subArea.innerHTML = '<li area_id="32095">石桥铺</li><li area_id="32091">杨家坪</li><li area_id="32030">解放碑</li><li area_id="32031">两路口</li>';
                    }else if(domAttr.get(dom, "hotarea") == 1){
                        subArea.innerHTML = '<li area_id="32095">沙坪坝</li><li area_id="32091">洋人街</li><li area_id="32030">解放碑</li><li area_id="32031">北京</li><li area_id="32031">上海</li>';
                    }else if(domAttr.get(dom, "areaid") == "123"){
                        subArea.innerHTML = '<li area_id="32095">科园一路</li><li area_id="32091">科园二路</li><li area_id="32030">科园三路</li><li area_id="32031">科园四路</li><li area_id="32031">科园五路</li>';
                    }else{
                        subArea.innerHTML = "";
                    }
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartArea")){
                    // TODO 子区域点击事件
                    array.forEach(query(".subSmartArea li", this.nav_dropdown_items[0]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartClassification") ){
                    // TODO 大分类点击
                    array.forEach(query(".smartClassification li", this.nav_dropdown_items[1]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                    
                    var subSmartClassification = query(".subSmartClassification")[0];
                    if(domAttr.get(dom, "cate_id") == 0){
                        subSmartClassification.innerHTML = '<li area_id="32095">分类1</li><li area_id="32091">分类2</li><li area_id="32030">分类3</li><li area_id="32031">分类4</li>';
                    }else if(domAttr.get(dom, "cate_id") == 1){
                        subSmartClassification.innerHTML = '<li area_id="32095">骨膜贴片1</li><li area_id="32091">骨膜贴片2</li><li area_id="32030">骨膜贴片3</li><li area_id="32031">骨膜贴片4</li><li area_id="32031">骨膜贴片5</li>';
                    }else if(domAttr.get(dom, "cate_id") == 2){
                        subSmartClassification.innerHTML = '<li area_id="32095">科园一路</li><li area_id="32091">科园二路</li><li area_id="32030">科园三路</li><li area_id="32031">科园四路</li><li area_id="32031">科园五路</li>';
                    }else{
                        subSmartClassification.innerHTML = "";
                    }
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartClassification") ){
                    // TODO 小分类点击
                    array.forEach(query(".subSmartClassification li", this.nav_dropdown_items[1]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartSort")){
                    // TODO 排序列表点击事件 排序后关闭页面
                    array.forEach(query(".smartSort li", this.nav_dropdown_items[2]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }
                if(dom && dom.tagName === "LI"){
                    domClass.add(dom, "beSelected");
                }
                if(dom && (dom.tagName === "LI" || dom.tagName === "UL") && 
                (domClass.contains(dom.parentNode, "subSmartArea") || domClass.contains(dom.parentNode, "subSmartClassification")
                || domClass.contains(dom.parentNode, "smartSort"))){
                    this._closeNavDropDownItem();
                }
            }));
            
            //搜索框的ENTER事件
            this.connect(this.SearchTxt,"onkeydown",function(e){
                if(e.keyCode==13){
                    this.searchEvent();
                }
            });
            
            //取消搜索
            if(query(".cancel")&&query(".cancel")[0])
            {
                this.connect(query(".cancel")[0],"onclick",function(){
                    this.SearchTxt.value="";
                    this.bigParam.GName="";
                    this.matList.rs_wb_param="("+JSON.stringify(this.bigParam)+")";
                    window.busy();
                    this.matList.refreshList();
                    window.free();
                });
            }
            
            //点击搜索
            this.connect(this.SearchTxt,"onclick",function(){
                this._closeNavDropDownItem();
            });
            // 筛选页面点击事件 复选框点击事件
            /* this.connect(this.nav_dropdown_items[3],"onclick",lang.hitch(this,function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LABEL"){
                    domStyle.set(dom, {backgroundColor:domAttr.get(query("input", dom.parentNode)[0], "checked")?"white":"red"});
                }
            })); */
            // 区域列表点击事件
            /* this.connect(this.nav_dropdown_items[0], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartArea")){
                    // TODO 大区域点击事件
                    // 修改点击大区域的样式
                    // 显示对应子区域列表
                    console.log(dom.innerHTML);
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartArea")){
                    // TODO 子区域点击事件
                    this.closeNavDropDownItem(0);
                    console.log(dom.innerHTML);
                }
            })); */
            // 分类列表点击事件
            /* this.connect(this.nav_dropdown_items[1], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartClassification") ){
                    // TODO 大分类点击
                    console.log(dom.innerHTML);
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartClassification") ){
                    // TODO 小分类点击
                    this.closeNavDropDownItem(1);
                    console.log(dom.innerHTML);
                }
            })); */
            // 智能排序点击事件
            /* this.connect(this.nav_dropdown_items[2], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartSort")){
                    // TODO 排序列表点击事件 排序后关闭页面
                    this.closeNavDropDownItem(2);
                }
            })); */
        },
        clickChangeViewLi:function(e){
            var dom = e.target;
            if(dom && (dom == this.changeViewLi || dom == this.changeViewLiChild)){
                domAttr.set(this.changeViewLiChild, "class", domAttr.get(this.changeViewLiChild, "class")==="changeViewLiV"?"changeViewLiH":"changeViewLiV");
            }
            domAttr.set(this.matList.domNode,"class",(domAttr.get(this.matList.domNode,"class")==="m-list matList matListHeight")?"m-l-list matList":"m-list matList matListHeight");
            this._closeNavDropDownItem();
        },
        // 关闭弹出层方法
        _closeNavDropDownItem:function(itemIndex){
            domStyle.set(this.nav_dropdowm, {display:"none"});
            domStyle.set(this.nav_dropdownbg, {display:"none"});
            array.forEach(this.nav_li, function(nthLi){
                domClass.remove(nthLi, "beSelected");
            });
            
            // domClass.remove(this.nav_li[itemIndex], "beSelected");
        },
        _navUlClicked: function(e){
            var dom = e.target;
            // 判断事件源是否是导航栏前4个li元素
            if(dom.tagName === "LI" && !domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                // 先清除上次点击的li元素的beSelected类
                array.forEach(this.nav_li, function(nthLi){
                    domClass.remove(nthLi, "beSelected");
                });
                // 为当前事件源添加beSelected
                domClass.add(dom, "beSelected");
                // 隐藏上一次显示的div，并显示本次事件源所对应的div
                array.forEach(this.nav_dropdown_items, function(item, index){
                    if(index == domAttr.get(dom,"dropindex")){
                        domStyle.set(item,{display:"block"});
                    }else{
                        domStyle.set(item,{display:"none"});
                    }
                });
                
                domStyle.set(this.nav_dropdownbg, {display: "block"});
                domStyle.set(this.nav_dropdowm, {display: "block"});
                //商品分类点击进入商品列表时点击顶部菜单分类后展开该分来的信息
                /*if(!this.isEvent&&this.cate_id&&domAttr.get(dom,"dropindex")=="1"){
                    setTimeout(lang.hitch(this,function(){
                        //alert(query("li[cate_id='"+this.cate_id+"']",this.domNode)[0]);
                        query("li[cate_id='"+this.cate_id+"']",this.domNode)[0].click();
                    
                    domClass.add(query("#ChildMG li",this.domNode)[0],"beSelected");
                    this.isEvent=true;
                    }),10)
                    
                }*/
                if(domAttr.get(dom,"dropindex")=="3"){
                    if(this.bigParam.IS_CX!=""){
                        var myCx=query("li[IS_CX]",this.domNode)[0];
                        domAttr.set(myCx,"IS_CX",this.bigParam.IS_CX);
                        domClass.add(query("div.divCheckbox",myCx)[0],"divInput");
                    }
                    if(this.bigParam.IS_TG!=""){
                        var myCx=query("li[IS_TG]",this.domNode)[0];
                        domAttr.set(myCx,"IS_TG",this.bigParam.IS_TG);
                        domClass.add(query("div.divCheckbox",myCx)[0],"divInput");
                    }
                    if(this.bigParam.T0_TPCH_NUM!=""){
                        var myCx=query("li[T0_TPCH_NUM]",this.domNode)[0];
                        domAttr.set(myCx,"T0_TPCH_NUM",this.bigParam.T0_TPCH_NUM);
                        domClass.add(query("div.divCheckbox",myCx)[0],"T0_TPCH_NUM");
                    }
                    if(this.bigParam.SERVICE_TYPE!=""){
                        var myCx=query("li[ServiceType]",this.domNode)[0];
                        domAttr.set(myCx,"ServiceType",this.bigParam.SERVICE_TYPE);
                        domClass.add(query("div.divCheckbox",myCx)[0],"ServiceType");
                    }
                    /*var checkFlit=query(".divCheckbox");
                    array.forEach(checkFlit,function(item){
                        var IS_CX=domAttr.get(item,"IS_CX");
                        var IS_TG=domAttr.get(item,"IS_TG");
                        var T0_TPCH_NUM=domAttr.get(item,"T0_TPCH_NUM");
                        var ServiceType=domAttr.get(item,"ServiceType");
                        
                        domClass.remove(item,"divInput");
                        domStyle.set(item,{backgroundColor:"white"});
                    });*/
                }
            }else if(dom.tagName === "LI" && domStyle.get(this.nav_dropdowm, "display") == "block" && domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                domClass.remove(dom, "beSelected");
                domStyle.set(this.nav_dropdownbg, {display: "none"});
                domStyle.set(this.nav_dropdowm, {display: "none"});
            }
        },
        mGroupName:"",
        _clearSearchBarStart:function(node){
            if(this.order_control){
                query("a",this.order_control).forEach(function(n){
                    if(n!==node&&!domAttr.get(n,"changeViewEf")){
                        domAttr.set(n,"class","");
                        domAttr.set(n,"selected","false");
                    }
                });
            }
        },
        _onMatListSearch:function(){
            //if(document.getElementById('search_name').value){
                if(window.did.indexOf("aid_")>-1){
                    this.curMatList.rs_wb_param = "({APP_ID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else if(window.did.indexOf("std_")>-1){
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else{
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }
                this.curMatList.refreshList();
            //}
        },
        _clearUlStyle:function(){
            query("#topUl li")[2].innerText="默认排序";
            query("#topUl li")[3].innerText="筛选";
            
            //清空样式信息
            var orde=query(".smartSort li.beSelected")[0];
            var flit=query(".nav_dropdowm_item_slider li.beSelected")[0];
            if(orde){
                 domClass.remove(orde,"beSelected");
            }
            if(flit){
                domClass.remove(flit,"beSelected");
            }
        },
        searchEvent:function(){
            this.bigParam.GName=this.SearchTxt.value;
            this.matList.rs_wb_param="("+JSON.stringify(this.bigParam)+")";
            window.busy();
            this.matList.refreshList();
            window.free();
        },
    });
});