define([
    "dojo/_base/declare",
    "dojo/query",
    "dojo/_base/lang",
    "../userInfo",
    "dojo/Deferred"], function(declare, query, lang, userInfo, Deferred) {
    return declare("widgets.common._MdfPwdMixin", null, {
        isMdfPwdLoaded:function(){
            return !!this.mdfPwdBtn;
        },
        indexMdfPwdElement: function() {
            this.mdfPwdBtn = query("#mdfPwdPost", this.domNode)[0];
        },
        initMdfPwdEvent: function() {
            this.mdfPwdBtn.onclick = function() {
                var info = {
                    oldPwd: query("#orPwd")[0].value,
                    newPwd: query("#newPwd")[0].value,
                    RPwd: query("#twPwd")[0].value
                };
                userInfo._mdfPwdDef = new Deferred();
                userInfo._onMdfPwdOk(info);
                userInfo._mdfPwdDef.then(function(isOK) {
                    if (isOK) {
                        window.moveToView("user");
                        query("#orPwd")[0].value = "";
                        query("#newPwd")[0].value = "";
                        query("#twPwd")[0].value = "";
                    }
                });
            };
        },
        refreshAllList: function() {
            if (window.titleNode) {
                window.titleNode.innerHTML = "修改密码";
            }
        }
    });
});