define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/dom-class",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "cqthink/mobile/imgPrc/bigImg",
    "widgets/userInfo",
    "cqthink/mobile/TalkMsgList",
], function(declare, registry,domAttr,domClass,query,array,lang,domStyle,bigImg,userInfo,TalkMsgList) {
    return declare("widgets.common._MsgList_sjmdMixin",null,{
        isMsgList_sjmdLoaded:function(){
            return !!this.msgList_sjmdNode;
        },
        indexMsgList_sjmdElement:function(){
            this.msgList_sjmdNode = query(".msgListNode",this.domNode)[0];
            this.mList = new TalkMsgList({
                svcLogo:g_sys_info.icon.split("-").pop().split(".")[0],
                svcName:g_sys_info.title
            });
            this.bodyNode.appendChild(this.mList.domNode);
            this.mList.startup();  
        },
        refreshAllList:function(){
            domStyle.set(this.domNode,"height","100%");
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                this.mList.set({
                    "pid":s?userInfo.getUserInfo().partnerId:"",
                    "wxId":g_s.getGuid(),
                    "tuid":window.did
                });
                this.mList.resize();
                this.mList.startTimer();
                this.mList.refreshMsgList();
                
                /*setInterval(lang.hitch(this,function(){this.mList.refreshMsgList();}),2000);*/
            }));
        },
        initMsgList_sjmdEvent:function(){
            this.connect(this.msgList_sjmdNode,"onDefRendered",function(data){
                window.updateTitle("专家咨询");
            });
            this.connect(this.mList._msgList.domNode,"onclick",function(e){
                var src = query("div.speech img",this.mList._msgList.domNode);
                var index = 0;
                var srcArr = array.map(src,function(item,i){
                    if(item == e.target || item.parentNode == e.target){
                        index = i;
                    }
                    return {src:domAttr.get(item,"src")};
                });
                if(domClass.contains(e.target,"speech") && e.target.children[0] && e.target.children[0].tagName.toLowerCase() == "img" || (e.target.tagName.toLowerCase() == "img" && domClass.contains(e.target.parentNode,"speech"))){
                    bigImg.show(srcArr,index);
                }
            });
        }
    });
});