define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/query",
    "dojo/dom-class"
], function(declare, registry,query,domClass) {
    return declare("widgets.common._NewsListMixin", null, {
        mGroupName:"",
        openNewsGrp:false,
        isNewsListLoaded:function(){
            return !!this.nList;
        },
        indexNewsListElement:function(){
            this.nList = registry.byId("newsListId");
        },
        refreshAllList: function() {
            //比如在10112中调用10111的aid则隐藏header
            this.gepheader&&domClass.add(this.gepheader,"hide");
            if(window.did.indexOf('code_')>-1){
                this.nList.rs_wb_flt = "20";
                this.nList.rs_wb_param = '({"SECTION_CODE":"'+window.did.split("_")[2]+'","SAID":"'+window.did.split("_")[0]+'"})';
                this.nList.refreshList();
            }else if(window.did.indexOf('aid_')>-1){
                this.nList.rs_wb_flt = "21";
                this.nList.rs_wb_param = '({"INPUT":"'+window.did.split("_")[2]+'","AID":"'+window.did.split("_")[1]+'"})';
                this.nList.refreshList();
            }
            else {
                if(this.openNewsGrp){
                    this.gepheader&&domClass.remove(this.gepheader,"hide");
                    this.newgep.refreshList();
                }else{
                    this.nList.refreshList();
                    this.scrollTo({x:0,y:0});
                    window.updateTitle(this.mGroupName);
                }
            }
        },
        initNewsListEvent:function(){
            this.connect(this.nList, "onDefRendered", function(data) {
                if(data.data&&data.data.items&&data.data.items.length){
                    if(this.did){// 有did才指定资讯栏目
                        this.mGroupName = data.data.items[0]["SECTION_ID.TITLE"];
                    }else{
                        this.mGroupName = "资讯列表";
                    }
                }else{
                    this.mGroupName = '暂无资讯';
                }
                //alert(this.mGroupName);
                window.updateTitle(this.mGroupName);
            });
        }
    });
});