define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/userInfo",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/dom-class"
], function(declare, registry,domAttr,query,array,lang,domStyle,userInfo,xhr,json,domClass) {
    return declare("widgets.common._OrderWbList",null,{
        isOrderWbListLoaded:function(){
            return !!this.orderWbList;
        },
        refreshAllList:function(){
            //console.log(userInfo);
            //console.log(userInfo.info);
            //console.log(userInfo.info.hasLogin);
            // 如果用户未登录，跳转到登录界面
            //if(!userInfo.info.hasLogin){
            //    userInfo.showLogin();
                //window.moveToView("newRegister");
            //}else{
            //    this.orderWbList.refreshList();
            //}
            // 如果用户已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    // this.loadDataFun();
                    this.orderWbList.refreshList();
                }else{
                    userInfo.showLogin();
                }
            }));
        },
        indexOrderWbListElement:function(){
            if(!this.isOrderWbListLoaded()){
                this.orderWbList = registry.byId("orderWbListV");
                this.tabHeader = query(".tabHeader")[0];// 头部tab栏，分类
                query(".shelfHeader",this.domNode)[0].appendChild(query(".beautyReserveTabs")[0]);
            }
        },
        initOrderWbListEvent:function(){
            if(this.tabHeader){
                this.connect(this.tabHeader,"onclick",function(e){
                    var dom = e.target;
                    while(dom && "li" !== dom.tagName.toLowerCase() && dom != this.tabHeader){
                        dom = dom.parentNode;
                    }
                    if(dom){
                        domClass.remove(query(".on",this.tabHeader)[0],"on");
                        domClass.add(dom,"on");
                        //window.busy();
                        var domId = domAttr.get(dom,"id");
                        window.busy();
                        this.orderWbList.rs_wb_flt = domId === "all"?24:(domId==="canUse"?26:27);
                        this.orderWbList.refreshList();
                        window.free();
                        /*xhr("GET",
                            {
                                url:g_sys_info.url_usr,
                                handleAs:"json",
                                load:lang.hitch(this,function(data){
                                    console.log(data);
                                    (data&&data.data&&data.data.items).map(function(item){
                                        item.DeliveryQtyLast = item.T4_D_TIMES - item.T4_DeliveryQty;
                                    });
                                    // console.log(this);
                                    this.orderWbList.onDataReady(data);
                                    this.orderWbList.refreshList();
                                }),
                                sync:false,
		                        preventCache:true,
		                        content:{
		                            tp:"query3",
		                            modalName:"XSY_VSDSG_DELIVERYBILL2",
		                            pageSize:20,
		                            filter:domId==="all"?24:(domId==="canUse"?26:27),
		                            pageIndex:1,
		                            appId:window.g_sys_info.aid,
		                            hash:encodeURIComponent(json.toJson({
		                                PID:userInfo.info.partnerId
		                            }))
		                        }
                        });*/
                    }
                });
            }
            /*this.connect(this.orderWbList,"onDefRendered",function(data){
                window.updateTitle("预约列表");
            });*/
        },
        loadDataFun:function(){
            xhr("GET",
            {
                url:g_sys_info.url_usr,
                handleAs:"json",
                load:lang.hitch(this,function(data){
                    //console.log(data);
                    (data&&data.data&&data.data.items).map(function(item){
                        item.DeliveryQtyLast = item.T4_D_TIMES - item.T4_DeliveryQty;
                    });
                    console.log(this);
                    this.orderWbList.onDataReady(data);
                }),
                sync:false,
		        preventCache:true,
		        content:{
		            tp:"query3",
		            modalName:"XSY_VSDSG_DELIVERYBILL2",
		            pageSize:20,
		            filter:24,
		            pageIndex:1,
		            appId:window.g_sys_info.aid,
		            hash:encodeURIComponent(json.toJson({
		                PID:userInfo.info.partnerId
		            }))
		        }
            });
        }
    });
});