define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/userInfo"
], function(declare, registry,domAttr,query,array,lang,domStyle,userInfo) {
    return declare("widgets.common._OrderWbedList",null,{
        isOrderWbedListLoaded:function(){
            return !!this.orderWbedList;
        },
        refreshAllList:function(){
            // 如果用户已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    this.orderWbedList.refreshList();
                }else{
                    userInfo.showLogin();
                }
            }));
        },
        indexOrderWbedListElement:function(){
            if(!this.isOrderWbedListLoaded()){
                this.orderWbedList = registry.byId("orderWbedListV");
            }
        },
        initOrderWbedListEvent:function(){
            this.connect(this.orderWbedList,"onDefRendered",function(data){
                window.updateTitle("消费记录");
            });
        }
    });
});