define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/json",
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/query",
    "dojo/_base/xhr",
    "dojo/dom-style",
    "cqthink/mobile/imgPrc/bigImg"
], function(declare, lang, array, json, registry, domAttr, domConstruct, query, xhr,domStyle,bigImg) {
    domConstruct.create("style",{
        type:"text/css",
        innerHTML:".mblDomButtonCheckboxOn{position:relative;width:30px;height:30px;border-width:1px;border-style:outset;border-color:#a5a2a5;color:white;border-radius:3px;background-color:#d6d3d6;background:-webkit-gradient(linear,left top,left bottom,from(#eff3ef),to(#bdbebd));background:linear-gradient(to bottom,#eff3ef 0,#bdbebd 100%)}.mblDomButtonCheckboxOn>div{position:absolute;top:15px;left:3px;width:14px;height:4px;margin:0;font-size:1px;background-color:#00cf00;border-top:1px solid #4a5a71;border-radius:2px;-webkit-transform:rotate(50deg);transform:rotate(50deg)}.mblDomButtonCheckboxOn>div>div{position:absolute;top:-10px;left:0;width:20px;height:4px;margin:0;font-size:1px;background-color:#00cf00;border-top:0;border-bottom:1px solid #4a5a71;border-radius:2px;-webkit-transform:rotate(-100deg);transform:rotate(-100deg)}.mblDomButtonBlackCircleCross{position:relative;width:29px;height:29px}.mblDomButtonBlackCircleCross>div{position:relative;top:3px;left:3px;width:23px;height:23px;background-color:white;border-radius:12px;-webkit-box-shadow:0 1px 2px rgba(0,0,0,0.5);box-shadow:0 1px 2px rgba(0,0,0,0.5)}.mblDomButtonBlackCircleCross>div>div{position:relative;top:2px;left:2px;width:19px;height:19px;background-color:black;border-radius:10px}.mblDomButtonBlackCircleCross>div>div>div{position:absolute;top:8px;left:3px;width:13px;height:3px;margin:0;font-size:1px;border-style:none;background-color:white;-webkit-transform:rotate(45deg);transform:rotate(45deg);border-radius:1px}.mblDomButtonBlackCircleCross>div>div>div>div{position:absolute;top:-5px;left:5px;width:3px;height:13px;margin:0;font-size:1px;background-color:white;border-radius:1px}.mblDomButtonGreenCirclePlus{position:relative;width:29px;height:29px}.mblDomButtonGreenCirclePlus>div{position:relative;top:2px;left:2px;width:22px;height:22px;border:1px solid #b5b6b5;border-radius:12px;-webkit-box-shadow:0 1px 2px rgba(0,0,0,0.5);box-shadow:0 1px 2px rgba(0,0,0,0.5)}.mblDomButtonGreenCirclePlus>div>div{position:relative;top:2px;left:2px;width:18px;height:18px;border-radius:9px;background:-webkit-gradient(linear,left top,left bottom,from(#7be75a),to(#398c08),color-stop(0.5,#6bc642),color-stop(0.5,#4aad21));background:linear-gradient(to bottom,#7be75a 0,#6bc642 50%,#4aad21 50%,#398c08 100%)}.mblDomButtonGreenCirclePlus>div>div>div{position:absolute;top:8px;left:3px;width:13px;height:3px;margin:0;font-size:1px;border-style:none;background:white}.mblDomButtonGreenCirclePlus>div>div>div>div{position:absolute;top:-5px;left:5px;width:3px;height:13px;margin:0;font-size:1px;background-color:white}.mblDomButtonGreenCircleMinus{position:relative;width:29px;height:29px}.mblDomButtonGreenCircleMinus>div{position:relative;top:2px;left:2px;width:22px;height:22px;border:1px solid #b5b6b5;border-radius:12px;-webkit-box-shadow:0 1px 2px rgba(0,0,0,0.5);box-shadow:0 1px 2px rgba(0,0,0,0.5)}.mblDomButtonGreenCircleMinus>div>div{position:relative;top:2px;left:2px;width:18px;height:18px;border-radius:9px;background:-webkit-gradient(linear,left top,left bottom,from(#7be75a),to(#398c08),color-stop(0.5,#6bc642),color-stop(0.5,#4aad21));background:linear-gradient(to bottom,#7be75a 0,#6bc642 50%,#4aad21 50%,#398c08 100%)}.mblDomButtonGreenCircleMinus>div>div>div{position:absolute;top:8px;left:3px;width:12px;height:3px;margin:0;font-size:1px;border-style:none;background:white}"
    },document.head);
    return declare("widgets.common._PrizeDrawingMixin", null, {
        TName:"",
        isPrizeDrawingLoaded:function(){
            return !!this.prizeTable;
        },
        //找到界面所有关心的元素
        indexPrizeDrawingElement: function() {
            //随机投票大转盘特有界面区域
            //随机投票大转盘区域
            this.draw1 = query(".draw1",this.domNode)[0];
            //随机投票相关界面
            this.prizeTable = query(".prizeDrawing", this.domNode)[0];
            //抽奖按钮
            this.prizeDra = query(".pDra", this.domNode)[0];
            //随机转盘周围的图片，排成一个圈
            var pDraImg = query(".pDraImg", this.domNode);
            this.pDraImg = [pDraImg[0], pDraImg[1], pDraImg[2], pDraImg[4], pDraImg[7], pDraImg[6], pDraImg[5], pDraImg[3]];
            //提示信息
            this.intPW = query('.intPW',this.domNode)[0];
            
            //图片投票区域特有元素
            //图片投票区域
            this.draw5 = query(".draw5",this.domNode)[0];
            //接受投票的人的图片
            this.draw5VoteImg = query(".draw5VoteImg",this.domNode)[0];
            //我的头像
            this.draw5UploadImg = query(".draw5UploadImg",this.domNode)[0];
            //图片给他投票按钮
            this.voteImgBtn = query(".voteImgBtn",this.domNode)[0];
            //切换到上传图片界面的按钮
            this.voteToImgBtn = query(".voteToImgBtn",this.domNode)[0];
            //报名时上传图片按钮
            this.voteImgUploadBtn = query(".voteImgUploadBtn",this.domNode)[0];
            //
            this.voteImgUploadBtn1 = query(".voteImgUploadBtn1",this.domNode)[0];
            
            //界面显示投票人得票信息相关节点
            //得票信息容器DIV
            this.resultPW = query('.resultPW',this.domNode)[0];
            //得奖人的昵称
            this.nick = query(".nick")[0];
            //得奖人的得票数
            this.counts = query(".counts")[0];
            
            //投票公共区域
            //抽奖说明信息
            this.pCom = query('.comment')[0];
            //抽奖结果列表
            this.resultCount = registry.byId("resultCounts");
        },
        //初始化界面事件，按钮的点击
        initPrizeDrawingEvent: function() {
            //随机投票相关事件
            //随机投票抽奖按钮点击响应
            this.connect(this.prizeDra, 'onclick', this.onPrizeDrawImg);
            
            //图片投票相关界面
            //图片投票按钮的点击事件
            this.connect(this.voteImgBtn,"onclick",this.onVoteImg);
            //点击我的得票或者我来报名按钮的响应
            this.connect(this.voteToImgBtn,"onclick",function(){
                //隐藏投票相关界面元素
                domStyle.set(this.draw5VoteImg,"display","none");
                domStyle.set(this.voteImgBtn,"display","none");
                domStyle.set(this.voteToImgBtn,"display","none");
                domStyle.set(this.draw5UploadImg,"display","");
                
                //加载自己的信息
                this._getPDCounts(window.wx_openId);
            });
            //报名上传按钮的点击事件
            this.connect(this.voteImgUploadBtn,"onchange",this.onVoteImgUpload);
            this.connect(this.draw5VoteImg,"onclick",this.onVoteImgClick);
            this.connect(this.draw5UploadImg,"onclick",this.onVoteImgClick);
            
            //得票结果列表点击事件，点击图片看大图
            this.connect(this.resultCount.domNode,"onclick",this.onResultCountClick);
        },
        
        //结果列表，看大图
        onResultCountClick:function(e){
            var node = e.target;
            if(node.tagName=="IMG"&&node.src){
                bigImg.show(node.src);
            }
        },
        
        //图片票选相关处理函数
        //图片投票，给人投票
        onVoteImg:function(){
            if (this._timer) {
                return;
            }
            if(!window.srcWxId){
                return alert("无法识别投票对象，无法投票");
            }
            //加载抽奖结果
            this.onImport();
        },
        //图片投票，被投票的图片点击看大图
        onVoteImgClick:function(e){
            var node = e.target;
            if(node.src&&node.src!=="../../Content/htapp/images/headImg.png"){
                bigImg.show(node.src);
            }
        },
        //图片投票报名操作，上传图片
        onVoteImgUpload:function(e){
            if(!window.wx_openId){
                alert("无法识别身份");
                return;
            }
            
            var file = e.target&&e.target.files&&e.target.files[0];
            if(file){
                var fileType = file.type,reader = new FileReader();
                reader.onload = lang.hitch(this,function() {
                    // 头不带图片格式，需填写格式
                    var re = /^data:base64,/;
                    var ret = reader.result + '';
                    if (re.test(ret)){
                        ret = ret.replace(re, 'data:' + this.mime[fileType] + ';base64,');
                    }
                    if(ret){
                        this._onImgCaptured(ret);
                    }
                });
                reader.readAsDataURL(file);
            }
        },
        //用户选择图片之后
        _onImgCaptured:function(url){
            //重置图片大小，剪切
            this.imgSelector.selectImg(null,{
                width:480,
                height:640
            },url).then(lang.hitch(this,function(url2){
                window.busy();
                //插入抽奖结果
                xhr("POST",{
                    url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                    handleAs: "json",
                    content: {
                        data: json.toJson({
                            modalName: "XSY_TCRSA_DRAWRESULTS",
                            data: [{o:{
                                ActivityID:window.did,
                                WXID:window.wx_openId
                            },n:{
                                ActivityID:window.did,
                                WXID:window.wx_openId,
                                AID:g_sys_info.aid
                            }}]
                        })
                    },
                    load:lang.hitch(this,function(result){
                        if(result&&result.data&&result.data.items&&result.data.items.length){
                            //上传图片
                            var oldImg = result.data.items[0].IMG,dtlId = result.data.items[0].DID,count = result.data.items[0].Counts-0;
                            xhr("POST",{
                                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                handleAs: "json",
                                content: {
                                    data: json.toJson({
                                        modalName: "APP_TBSSC_IMG_LIB",
                                        data: [{n:{
                                            RID:"XSY_TCRSA_DRAWRESULTS",
                                            RIID:result.data.items[0].DID,
                                            AID:g_sys_info.aid,
                                            URL:url2
                                        }}]
                                    })
                                },
                                load:lang.hitch(this,function(result){
                                    if(result&&result.data&&result.data.items&&result.data.items.length){
                                        //更新图片到抽奖结果
                                        var imgId = result.data.items[0].DID;
                                        xhr("POST",{
                                            url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                            handleAs: "json",
                                            content: {
                                                data: json.toJson({
                                                    modalName: "XSY_TCRSA_DRAWRESULTS",
                                                    data: [{o:{
                                                        "DID":dtlId
                                                    },n:{
                                                        IMG:imgId,
                                                        Counts:count||0
                                                    }}]
                                                })
                                            },
                                            load:lang.hitch(this,function(){
                                                //更新图片的显示，并提示报名成功
                                                this.draw5UploadImg.src = "/w/img/load/"+window.code+"-"+imgId+".png";
                                                alert(oldImg?"图片更新成功":"报名成功");
                                                window.free();
                                            }),
                                            error:function(){
                                                alert("系统出错，请稍后重试");
                                                window.free();
                                            }
                                        })
                                    }else{
                                        alert("系统出错，请稍后重试");
                                        window.free();
                                    }
                                }),
                                error:function(){
                                    alert("系统出错，请稍后重试");
                                    window.free();
                                }
                            });
                        }else{
                            alert("系统出错，请稍后重试");
                            window.free();
                        }
                    }),
                    error:function(){
                        alert("系统出错，请稍后重试");
                        window.free();
                    }
                });
            }));
        },
        
        //随机投票大转盘相关处理函数
        //大转盘随机投票
        onPrizeDrawImg:function(){
            if (this._timer) {
                return;
            }
            //处理头像的地址和透明度
            array.forEach(this.pDraImg, function(node, index) {
                domAttr.set(node, "src", "../../Content/htapp/images/headImg.png");
                domAttr.set(node, "class", "pDraImg intOpcity");
            }, this);
            this.curCount = 1;
            //大转盘开始旋转，通过透明度的变化实现旋转效果
            this.pDraStart();
            //加载抽奖结果
            this.onImport();
        },
        //开始抽奖，大转盘开始转动
        pDraStart: function() {
            if (this.curCount < 20||null===this.importedData) {
                //通过class改变转盘周围的图片的样式
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg pDraOpcity" + (1+((20-this.curCount + index)%8)));
                }, this);
                this.curCount++;
                //通过定时器循环改变
                this._timer = setTimeout(lang.hitch(this, this.pDraStart), 80);
            } else {
                //大转盘转动完成
                this.updateShow();
            }
        },
        
        //刷新所有数据
        refreshAllList: function() {
            //加载抽奖信息
            window.loadData({
                modalName:"XSY_TCRSA_PRIZEDRAWING",
                filter:"01",
                pageSize:1,
                pageIndex:1,
                param:{
                    DID:window.did
                }
            }).then(lang.hitch(this,function(data){
                var title = "",wxOpenId = "",draw1Display = "none",draw5Display = "none";
                if(data.length){
                    //抽奖的类型
                    this.curType = data[0].ShowManner.toString();
                    //取到了抽奖活动信息
                    this.pCom.innerHTML = data[0].Comment;
                    //标题
                    title = data[0].ActivityName;
                    
                    if("1"===this.curType){
                        //显示
                        draw1Display = "";
                        //随机大转盘抽奖时，取自己的得票信息
                        wxOpenId = window.wx_openId;
                    }else if("5"===this.curType){
                        draw5Display = "";
                        //图片投票时刷新来源的得票信息
                        wxOpenId = window.srcWxId;
                        //图片投票按钮，可能需要获取图片的模块
                        if(!this.imgCapture){
                            require([
                                "cqthink/mobile/imgPrc/capture",
                                "cqthink/mobile/imgPrc/selector"
                            ],lang.hitch(this,function(capture,selector){
                                //获取图片模块
                                this.imgCapture = capture;
                                //截取图片模块
                                this.imgSelector = selector;
                            }));
                        }
                        //隐藏图片投票界面的所有元素，在数据加载好了之后处理是否显示
                        domStyle.set(this.draw5VoteImg,"display","none");
                        domStyle.set(this.draw5UploadImg,"display","none");
                        domStyle.set(this.voteImgBtn,"display","none");
                        domStyle.set(this.voteToImgBtn,"display","none");
                        domStyle.set(this.voteImgUploadBtn,"display","none");
                        domStyle.set(this.voteImgUploadBtn1,"display","none");
                        //加载当前人的得票信息
                        this._loadWxResult(window.wx_openId).then(lang.hitch(this,function(data){
                            //依据当前人是否已经报名来显示不同的标签
                            this.voteToImgBtn.value = data&&data.length&&data[0].IMG?"我的得票":"我也报名";
                            //显示这个按钮
                            domStyle.set(this.voteToImgBtn,"display","");
                        }));
                    }
                    domStyle.set(this.draw1,"display",draw1Display);
                    domStyle.set(this.draw5,"display",draw5Display);
                    this._getPDCounts(wxOpenId);
                    //刷新抽奖结果列表
                    this.resultCount.refreshList();
                }else{
                    //没有抽奖信息，隐藏界面抽奖和投票所有相关页面元素
                    domStyle.set(this.draw1,"display","none");
                    domStyle.set(this.draw5,"display","none");
                    title = "暂无抽奖信息";
                }
                if(window.updateTitle){
                    window.updateTitle(title);
                }
            }));
        },
        
        onImport: function() { //获取抽奖结果
            if(!window.wx_openId){
                return alert("无法识别您的身份，不能投票");
            }
            if("5"===this.curType){
                if(!window.srcWxId){
                    return alert("无法识别TA的身份，不能给TA投票");
                }
            }
            this.importedData = null;
            //加载数据
            
            xhr("POST", {
                url: "/w/prize/draw/" + g_sys_info.code,
                content:{
                    billId:window.did,
                    srcWxId:window.srcWxId,
                    wxId:window.wx_openId
                },
                handleAs: "json",
                load: lang.hitch(this, function(result) {
                    this.importedData = result;
                    if (1 == result.rtnType) {
                        //取票数，大转盘时为自己的票数，投票时为来源的票数
                        this._getPDCounts("5"==this.curType?window.srcWxId:window.wx_openId);
                        this.resultCount.refreshList();
                    } else if("5"===this.curType){
                        alert(result.message);
                    }
                }),
             
                error: lang.hitch(this,function() {
                    this.importedData = {
                        rtnType:"101",
                        message:"发生错误"
                    };
                    if("5"===this.curType){
                        alert("请求出错");
                    }
                })
            });
    
        },
        updateShow:function(){
            if(this.importedData&&this.importedData.rtnType=="101"){
                array.forEach(this.pDraImg, function(node, index) {
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
                alert(this.importedData.message);
            }else{
                var data = this.importedData.data;
                array.forEach(this.pDraImg, function(node, index) {
                    if (data[index]&&data[index].HEADIMGURL) {
                        domAttr.set(node, "src", data[index].HEADIMGURL);
                    } else {
                        domAttr.set(node, "src", "../../Content/htapp/images/headImg.png");
                    }
                    domAttr.set(node, "class", "pDraImg intOpcity");
                }, this);
            }
            window.free();
            this._timer = null;
        },
        _getPDCounts:function(wxOpenId){
            this._loadWxResult(wxOpenId).then(lang.hitch(this,function(data){
                if (data.length) {
                    //有被抽中信息，显示内容
                    this.nick.innerHTML = data[0]["WXID.NICKNAME"];
                    //得票数
                    this.counts.innerHTML = data[0].Counts;
                    //显示隐藏抽奖结果节点
                    domStyle.set(this.intPW,"display","none");
                    domStyle.set(this.resultPW,"display","");
                    if("5"==this.curType){
                        //图片投票的特殊处理
                        if(wxOpenId==window.wx_openId){ 
                            this.draw5UploadImg.src = "/w/img/load/"+window.code+"-"+data[0].IMG+".png";
                            //若是图片投票，且没有参与信息，显示上传图片的按钮
                            domStyle.set(this.voteImgUploadBtn,"display","");
                            domStyle.set(this.voteImgUploadBtn1,"display","");
                        }else{
                            this.draw5VoteImg.src = "/w/img/load/"+window.code+"-"+data[0].IMG+".png";
                            domStyle.set(this.voteImgBtn,"display","");
                            domStyle.set(this.draw5VoteImg,"display","");
                        }
                    }
                } else {
                    //没有被抽中信息，直接隐藏
                    domStyle.set(this.intPW,"display","");
                    domStyle.set(this.resultPW,"display","none");
                    if("5"==this.curType){
                        //图片投票需要特殊处理
                        if(wxOpenId===window.wx_openId){
                            //自己的得票结果
                            this.draw5UploadImg.src = "../../Content/htapp/images/headImg.png";
                            //设置报名的按钮标签为上传头像
                            //this.voteImgUploadBtn.value = "上传图片";
                            //显示上传头像的按钮
                            domStyle.set(this.voteImgUploadBtn,"display","");
                            domStyle.set(this.voteImgUploadBtn1,"display","");
                        }else{
                            //别人的得票信息
                            this.draw5VoteImg.src = "../../Content/htapp/images/headImg.png";
                            //隐藏投票按钮
                            domStyle.set(this.voteImgBtn,"display","none");
                            //设置提示信息的内容
                            this.intPW.innerHTML = ""
                        }
                    }
                }
                window.free();
                this._timer = null;
            }));
        },
        _loadWxResult:function(wxOpenId){
            //加载指定人的得票信息
            return window.loadData({
                modalName: "XSY_TCRSA_DRAWRESULTS",
                filter: "01",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "ActivityID": window.did,
                    "WXID": wxOpenId
                }
            });
        }
    });
});