define([
    "dojo/_base/declare",
    "dijit/registry",
    "widgets/userInfo",
    "dojo/_base/lang"], function(declare, registry,userInfo,lang) {
    return declare("widgets.common._ShowCompMixin", null, {
        isShowCompLoaded: function() {
            return !!this.sComplain;
        },
        indexShowCompElement: function() {
            this.sComplain = registry.byId("sComplain");
            //this.repair = query()[0];
        },
        initShowCompEvent: function() {
            this.inherited(arguments);
        },
        initShowCompData: function() {
            this.inherited(arguments);/*
            if (window.titleNode) window.titleNode.innerHTML = "报事记录";*/
            this.sComplain.refreshList();
        },
        refreshAllList: function() {
            //domAttr.set(this.repair, "class", "tableLi");
            if (window.titleNode) {
                window.titleNode.innerHTML = "报事报修记录";
            }
            userInfo.hasLogin().then(lang.hitch(this, function(success) {
                if (success) {
                    this.sComplain.refreshList();
                } else {
                    window.nextPageOnLogin = "showComplain";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
            this.resize;
        },
    });
});