define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-attr",
    "../userInfo",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/dom-style"], function(declare, registry,query,lang,array,domAttr,userInfo,json,xhr,domStyle) {
    return declare("widgets.common._WcDtlMixin", null, {
        wcDtl:{
            time:"",
            d_date:"",
            ser_id:"",
            ser_time:""
        },
        isWcDtlLoaded:function(){
            return !!this.wcDtl_info;
        },
        indexWcDtlElement: function() {
            this.wcDtl_info = registry.byId("wcDtl_info"); //头部信息
            this.wcDtl_rmk = registry.byId("wcDtl_rmk");// 介绍信息
            this.wcDtl_dtl = registry.byId("wcDtl_dtl");// 预约信息
            this.wcDtl_date = registry.byId("wcDtl_date");//日期
            this.wcDtl_time = query("#wcDtl_time")[0];//时间
            this.content = query(".withHeader",this.domNode)[0];
            //this.XXeva = registry.byId("XXeva"); //评价
            this.wcDtl_ul = query("#wcDtl_ul",this.domNode)[0]; // 标题
            this.wcDtl_Book_Btn = query(".wcDtl_Book_Btn",this.domNode)[0];//预约按钮
            this.wcDtl_BookNow_Btn = query(".wcDtl_BookNow_Btn",this.domNode)[0];//提交预约
            this.wcDtl_dtl_01 = registry.byId("wcDtl_dtl_01");//服务项目列表
            this.wcDtl_eva_01 = registry.byId("wcDtl_eva_01");//评价列表
            this.wcDtl_rmk_01 = registry.byId("wcDtl_rmk_01");
            this.show_wcDtl_time = query("#show_wcDtl_time")[0];
        },
        refreshAllList: function() {
            if(this.did!=window.did){
                this.did = window.did;
                this.wcDtl_info.refreshList();
                this.wcDtl_dtl_01.refreshList();
                this.wcDtl_eva_01.refreshList();
                this.wcDtl_rmk_01.refreshList();
                this.wcDtl_date.refreshList();
            }
            //初始化
            //this.wcDtl.time = "";
            //this.wcDtl.d_date = "";
            //this.wcDtl.ser_id = "";
            //this.wcDtl.ser_time = "";
            domStyle.set(this.show_wcDtl_time,"display","none");
            //query("#show_wcDtl_time")[0].style.display = "none";
            window.updateTitle("预约详情");
        },
        initWcDtlEvent:function(){
            this.connect(this.wcDtl_ul,"onclick",this.wcDtl_ul_fuc);
            this.connect(this.wcDtl_info.domNode,"onclick",this.wcDtl_Book_View);
            this.connect(this.wcDtl_date.domNode,"onclick",this.wcDtl_date_onclick);
            this.connect(this.wcDtl_time,"onclick",this.wcDtl_time_onclick);
            this.connect(this.content,"onclick",this.content_onclick);
            this.connect(this.wcDtl_BookNow_Btn,"onclick",this.wcDtl_BookNow_FUC);
            this.connect(this.wcDtl_dtl_01.domNode,"onclick",this.wcDtl_dtl_01_onclick);
            this.connect(this.wcDtl_date,"onDefRendered",function(data){
                items = data.data.items;
                array.forEach(items,function(item){
                    item.wcDate = item.T3_BDate.split("-")[1]+"-"+item.T3_BDate.split("-")[2];
                });
            });
            this.connect(this.wcDtl_eva_01,"onDefRendered",function(data){
                items = data.data.items;
                if(!items.length){
                    query("#evaNums1",this.domNode)[0].innerHTML = "0";
                }else{
                    query("#evaNums1",this.domNode)[0].innerHTML = data.data.totalCount;
                }
            });
        }, 
        wcDtl_ul_fuc:function(e){
            var dom = e.target;
            while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this.wcDtl_ul){
                dom = dom.parentNode;
            }
            if(dom&&"li"==dom.tagName.toLowerCase()){
                var id = domAttr.get(dom,"id"),
                    cls = domAttr.get(dom,"class");
                this.clearState(dom);
                domAttr.set(dom,"class",("on"===cls||""===cls)?"on":"");
                domStyle.set(query("."+id,this.domNode)[0],"display","");
                //query("."+id,this.domNode)[0].style.display = "";
            }
        },
        clearState:function(node){
            if(this.wcDtl_ul){
                query("li",this.wcDtl_ul).forEach(function(n){
                    if(n!==node){
                        domAttr.set(n,"class","");
                    }
                });
                array.forEach([query(".wcDtl_rmk",this.domNode)[0],query(".wcDtl_dtl",this.domNode)[0],query(".wcDtl_eva",this.domNode)[0]],function(a){
                    if(a!==node){
                        domStyle.set(a,"display","none");
                        //a.style.display = "none";
                    }
                });
            }
        },
        wcDtl_Book_View:function(e){
            if(e.target&&e.target.tagName.toLowerCase() =="a"){
                domStyle.set(query(".wcDtl_rmk",this.domNode)[0],"display","none");
                domStyle.set(query(".wcDtl_dtl",this.domNode)[0],"display","");
                domStyle.set(query(".wcDtl_eva",this.domNode)[0],"display","none");
                //query(".wcDtl_rmk",this.domNode)[0].style.display = "none";
                //query(".wcDtl_dtl",this.domNode)[0].style.display = "";
                //query(".wcDtl_eva",this.domNode)[0].style.display = "none";
                domAttr.set(query("#wcDtl_rmk",this.domNode)[0],"class","");
                domAttr.set(query("#wcDtl_dtl",this.domNode)[0],"class","on");
                domAttr.set(query("#wcDtl_eva",this.domNode)[0],"class","");
            }
        },
        wcDtl_date_onclick:function(e){
            //如果点击li
            if(e.target&&e.target.tagName.toLowerCase()=="li"){
                var dom = e.target,
                    cls = domAttr.get(dom,"class");
                // 如果点击的是日期
                var d_date = domAttr.get(e.target,"d_date"),
                    shift_stime = d_date+" "+domAttr.get(e.target,"shift_stime"),
                    shift_etime = d_date + " " +domAttr.get(e.target,"shift_etime"),
                    shift_now = shift_stime,
                    sHTML = "",
                    pDate = new Date();
                //如果日期是今天，则可选时间必须大于当前时间
                if(d_date == g_s.toDateTimeString(pDate).substring(0,10)){
                    if(pDate >= g_s.toDate(shift_etime)){//当前时间大于班次结束时间
                        
                    }else if(pDate > g_s.toDate(shift_stime) && pDate < g_s.toDate(shift_etime)){//当前时间大于班次开始时间，且小于班次结束时间
                        if((pDate > g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":00:00")) && (pDate < g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":15:00"))){
                            shift_now = g_s.toDateTimeString(pDate).substring(0,13)+":15:00";
                        }else if(pDate > g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":15:00") && (pDate < g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":30:00"))){
                            shift_now = g_s.toDateTimeString(pDate).substring(0,13)+":30:00";
                        }else if(pDate > g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":30:00") && (pDate < g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":45:00"))){
                            shift_now = g_s.toDateTimeString(pDate).substring(0,13)+":45:00";
                        }else if(pDate > g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":45:00")){
                            shift_now = g_s.toDateTimeString(g_s.dateAdd(g_s.toDate(g_s.toDateTimeString(pDate).substring(0,13)+":00:00"), 'h', 1));
                        }
                    }
                    
                }
                domAttr.set(dom,"class",(""===cls)?"optUnSelected wcDate":"optSelected wcDate");
                //将选中的服务项目存入全局变量
                this.wcDtl.d_date = d_date;
                //}
                query("li",this.wcDtl_date.domNode).forEach(function(n){
                    if(n!==dom){
                        domAttr.set(n,"class","optUnSelected wcDate");
                    }
                });
                // 加载工单
                window.loadData({
                    modalName:"XSY_TSCSF_WB",
                    filter:"01",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{"WC":window.did,"DDATE":d_date}
                }).then(lang.hitch(this,function(data){
                    //生成可选时间列表
                    //从班次的开始时间到结束时间，每15分钟一个时间点
                    //每个时间点判断是否有工单
                    while(g_s.toDate(shift_now)<g_s.toDate(shift_etime)){
                        var isFree = true;
                        for(var i = 0;i<data.length;i++){
                            if(g_s.toDate(shift_now)>=g_s.toDate(data[i].PLANSTIME)&&g_s.dateAdd(shift_now,'n',15)<=g_s.toDate(data[i].PLANETIME)){
                                isFree = false;
                                break;
                            }
                        }
                        if(isFree){
                            sHTML = sHTML+"<li class='normal'>"+g_s.toTimeString(shift_now).substring(11,16)+"</li>";
                        }else{
                            sHTML = sHTML+"<li class='delete'>"+g_s.toTimeString(shift_now).substring(11,16)+"</li>";
                        }
                        shift_now = g_s.toDateTimeString(g_s.dateAdd(shift_now,'n',15));
                    }
                    query("#wcDtl_time",this.domNode)[0].innerHTML = sHTML;
                    domStyle.set(query("#wcDtl_time",this.domNode)[0],"display","block");
                    //query("#wcDtl_time",this.domNode)[0].style.display = "block";
                }));
            }
        },
        wcDtl_time_onclick:function(e){
            //如果点击li,可预约
            if(e.target&&e.target.tagName.toLowerCase()=="li" && domAttr.get(e.target,"class") != "delete"){
                var deleteList = query(".delete", this.domNode),
                    dom = e.target;
                if(deleteList){//预约时间冲突问题
                    for(var i=0;i<deleteList.length;i++){
                        var serST = g_s.toDate(this.wcDtl.d_date + " " + dom.innerHTML + ":00"),
                            serET = this.wcDtl.ser_time?g_s.dateAdd(g_s.toDate(this.wcDtl.d_date + " " + dom.innerHTML + ":00"), 'n', this.wcDtl.ser_time):0,
                            unChoiseT = deleteList?g_s.toDate(this.wcDtl.d_date + " " + deleteList[i].innerHTML + ":00"):0;
                        if(!this.wcDtl.ser_id){
                            alert("请先选择服务项目");
                            return;
                        }
                        if(serET > unChoiseT && serST < unChoiseT){
                            alert("对不起，该时间段不能提供您选择的服务，请选择其他时间");
                             return;
                        }
                    }
                    domAttr.set(dom,"class", "onSelectedTime");
                    domStyle.set(query("#wcDtl_time")[0],"display","none");
                    domStyle.set(query("#show_wcDtl_time")[0],"display","inline-block");
                    //query("#wcDtl_time")[0].style.display = "none";
                    //在界面上显示
                    //query("#show_wcDtl_time")[0].style.display = "inline-block";
                    query("#show_wcDtl_time")[0].innerHTML = "您的预约时间为：<span class='choices'>" + this.wcDtl.d_date + " " + dom.innerHTML + "</span>";
                    //存入全局
                    this.wcDtl.time = dom.innerHTML+":00";
                     
                }else{
                    domAttr.set(dom,"class", "onSelectedTime");
                    domStyle.set(query("#wcDtl_time")[0],"display","none");
                    domStyle.set(query("#show_wcDtl_time")[0],"display","inline-block");
                    //query("#wcDtl_time")[0].style.display = "none";
                    //在界面上显示
                    //query("#show_wcDtl_time")[0].style.display = "inline-block";
                    query("#show_wcDtl_time")[0].innerHTML = "您的预约时间为：<span class='choices'>" + this.wcDtl.d_date + " " + dom.innerHTML + "</span>";
                    //存入全局
                    this.wcDtl.time = dom.innerHTML+":00";
                }
            }else if(e.target&&e.target.tagName.toLowerCase()=="li" && domAttr.get(e.target,"class") == "delete"){
                //如果点击li,不可预约
                //query("#wcDtl_time")[0].style.display = "none";
            }else if(e.target&&e.target.tagName.toLowerCase() != "li"){
                domStyle.set(query("#wcDtl_time")[0],"display","none");
                //query("#wcDtl_time")[0].style.display = "none";
            }
        },
        content_onclick:function(e){
            domStyle.set(query("#wcDtl_time")[0],"display","none");
            //query("#wcDtl_time")[0].style.display = "none";
        },
        wcDtl_BookNow_FUC:function(){
            //提交预约订单
            var d = this.wcDtl.d_date+" "+this.wcDtl.time,//预约开始时间
                ed = g_s.toDateTimeString(g_s.dateAdd(d,'n',this.wcDtl.ser_time)),//预约结束时间
                dept = domAttr.get(query("#infodetail",this.domNode)[0],"dept_id");//部门
            window.loadData({
                modalName:"XSY_TSCSF_WB",
                filter:"01",
                pageSize:"1",
                pageIndex:"1",
                param:{"WC":window.did,"DDATE":this.wcDtl.d_date}
                }).then(lang.hitch(this,function(data1){
                    //判断是否有先选服务时间再改选服务项目的情况
                    var isUsable = true;
                    for(var i = 0;i<data1.length;i++){
                        if((g_s.toDate(data1[i].PLANSTIME) < g_s.toDate(d) && g_s.toDate(data1[i].PLANETIME) > g_s.toDate(d)) || (g_s.toDate(data1[i].PLANSTIME) < g_s.toDate(ed) && g_s.toDate(data1[i].PLANETIME) > g_s.toDate(ed))){
                            isUsable = false;
                            i++;
                            break;
                        }
                    }
                    if(!isUsable){
                        alert("对不起，您选择的时间不可用，请重新选择！");
                        return ;
                    }
                    
                    //判断服务项目和日期、时间
                    if(!this.wcDtl.ser_id){
                        alert("请选择服务项目！");
                        return;
                    }else if(!this.wcDtl.d_date){ 
                        alert("请选择服务日期！");
                        return;
                    }else if(!this.wcDtl.time){ 
                        alert("请选择服务时间！");
                        return;
                    }
                   
                    info = {
                        n: {
                            SERVICEID: this.wcDtl.ser_id,//选择
                            WCID: window.did,
                            DEPTID: dept, //工作中心的部门
                            PLANSTIME: d, //页面上获取
                            PLANETIME:ed
                        }
                    };
                    userInfo.hasLogin().then(lang.hitch(this, function(s) {
                        if (s) {
                            //已登录
                            info["n"].CLIENT = userInfo.getUserInfo().partnerId;
                            this.postBook(info);
                        } else {
                            //登录成功
                            userInfo.showLogin().then(lang.hitch(this, function(s) {
                                if (s) {
                                    info["n"].CLIENT= userInfo.getUserInfo().partnerId;
                                    this.postBook(info);
                                } 
                            }));
                        }
                    }));
                }));
           
        },
        postBook: function(data) {
            window.busy();
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "XSY_TSCSF_WB",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("预约成功。");
                        window.moveToView("wbList");
                        window.free();
                    } else {
                        alert(result.message || "数据错误!");
                        window.free();
                    }
                })
            });
        },
        wcDtl_dtl_01_onclick:function(e){
            //如果点击li
            if(e.target&&e.target.tagName.toLowerCase()=="li"){
                var dom = e.target;
                //获取li样式
                var cls = domAttr.get(dom,"class");
                //设置li的样式为新
                domAttr.set(dom,"class",(""===cls)?"optUnSelected wcDtl":"optSelected wcDtl");
                //将选中的服务项目存入全局变量
                this.wcDtl.ser_id = domAttr.get(dom,"ser_id");
                this.wcDtl.ser_time = domAttr.get(dom,"ser_time");
                //}
                query("li",this.wcDtl_dtl_01.domNode).forEach(function(n){
                    if(n!==dom){
                        domAttr.set(n,"class","optUnSelected wcDtl");
                    }
                });
            }
        }
    });
});