define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/query",
    "dojo/dom-style",
    "widgets/_ShelfMixin",
    "dojo/dom-class"
],function(declare,base,query,domStyle,shelf,domClass){
    return declare("widgets.rct.Main",[base,shelf],{
        withBack:false,
        getShelfId:function(){
            return "31124";
        },
        getBaseShelfId:function(){
            return "30326";
        },
        isMainLoaded:function(){
            return !!query(".maincon",this.domNode)[0];
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isMainLoaded()){
                //this.updateCenterPaneHeight();
                // 如果是在app上 则要添加头部的高度
                var h = 0;
                if(domClass.contains(document.body,"inApp")){
                    h = (domStyle.get(this.domNode,"height")-46)+"px";
                }else{
                    h = domStyle.get(this.domNode,"height")+"px";
                }
                domStyle.set(query(".maincon",this.domNode)[0],"height",h);
            }
        },
        onTplLoaded:function(){
            //this.updateCenterPaneHeight();
            var h = 0;
            if(domClass.contains(document.body,"inApp")){
                h = (domStyle.get(this.domNode,"height")-46)+"px";
            }else{
                h = domStyle.get(this.domNode,"height")+"px";
            }
            domStyle.set(query(".maincon",this.domNode)[0],"height",h);
            domStyle.set(query(".maincon",this.domNode)[0],"height",h);
        }
    });
});