define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_NewUserMixin"
    ], function(declare, base, shelf, userMixin) {
    return declare("widgets.rct.User", [base, shelf, userMixin], {
        getShelfId: function() {
            return "30330";
        },
        onTplLoaded: function(pane) {
            this.indexNewUserElement();
            this.initNewUserEvent();
            this.refreshAllList();
        },
        initData: function() {
            if (this.isNewUserLoaded()) {
                this.refreshAllList();
            }
            this.inherited(arguments);
        }
    });
});