define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-style",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-class",
    "widgets/userInfo"
    ], function(declare, Base, Shelf , registry ,query, domStyle, lang ,array, domClass, userInfo) {//.partnerId
    return declare("widgets.sjmdsvc.MyPrize", [Base, Shelf], {
        getShelfId: function() {
            return "31119";
        },
        ismyEvalistLoaded:function() {
          return !!this.MyPrizelist;
        },
        initData:function(){
            if(this.isMyPrizelistLoaded()) {
                window.busy();
                this.refreshAllList();
            }
            this.initMyPrizelistElement();
            this.inherited(arguments);
        },
        isMyPrizelistLoaded:function(){
            return !!this.MyPrizelist;
        },
        initMyPrizelistElement: function() {
            this.MyPrizelist = registry.byId("MyPrizelist");
        },
        refreshAllList:function() {
            this.MyPrizelist.refreshList();
        },
    });
});