define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_DisSerList",
    "dojo/_base/array"
],function(declare,base,shelf,dis,array){
    return declare("widgets.standardTmp01.DisSerList",[base,shelf,dis],{
        getShelfId:function(){
            return "30538";
        },
        onTplLoaded:function(pane){
            this.indexDisSerElement();
            this.initDisSerEvent();
            this.refreshAllList();
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isDisSerListLoaded()){
                this.refreshAllList();
                window.free();
            }
        },
        initDisSerEvent:function(){
            this.inherited(arguments);
            this.connect(this.disSerList,"onDefRendered",function(data){
                var items = data.data.items;
                array.forEach(items,function(item){
                    item.ModifyDate = item.ModifyDate.split(" ")[0]?item.ModifyDate.split(" ")[0]:item.ModifyDate;
                });
            });
        }
    });
});