define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/_base/array"
],function(declare,base,shelf,query,domAttr,domStyle,domClass,array){
    return declare("widgets.standardTmp01.LogQry",[base,shelf],{
        getShelfId:function(){
            return "31110";
        },
        isLogQryLoaded:function(){
            return !!this.logQtyIframe;
        },
        initData:function(){
            if(this.isLogQryLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            this.logQtyIframe = query(".logQtyIframe",this.domNode)[0];
            this.noLogInfo = query(".noLogInfo",this.domNode)[0];
            this.refreshAllList();
        },
        refreshAllList:function(){
            // 快递100查询
            if(window.did){
                window.did = decodeURIComponent(window.did);
                var log = [],src = "";
                log = window.did.split("_");
                if(log.length==2&&log[0]&&log[1]){
                    var logcode = log[1];
                    logcode = logcode.split(/[，,]/g);
                    // 嵌套iframe的方式导致iframe拖不动
                    domClass.remove(this.logQtyIframe,"hide");
                    domClass.add(this.noLogInfo,"hide");
                    src = "http://m.kuaidi100.com/result.jsp?com="+log[0]+"&nu="+logcode[0];
                    domAttr.set(this.logQtyIframe,"src",src);
                    domStyle.set(this.logQtyIframe,"height",domStyle.get(this.domNode,"height")+"px");
                    domStyle.set(this.logQtyIframe,"width",domStyle.get(this.domNode,"width")+"px");
                }else{
                    domClass.add(this.logQtyIframe,"hide");
                    domClass.remove(this.noLogInfo,"hide");
                }
            }else{
                domClass.add(this.logQtyIframe,"hide");
                domClass.remove(this.noLogInfo,"hide");
            }
        }
    });
});