define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/common/_NewRegisterMixin",
    "widgets/_ShelfMixin"
],function(declare,base,NewRegisterMixin,ShelfMixin){
    return declare("widgets.standardTmp01.NewRegister",[base,NewRegisterMixin,ShelfMixin],{
        getShelfId:function(){
            return "30329";
        },
        onTplLoaded:function(pane){
            this.indexNewRegisterElement();
            this.initNewRegisterEvent();
            this.refreshAllList();
        },
        initData:function(){
            if(this.isNewRegisterLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        }
    });
});