define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_NewsMixin",
    "dojo/query",
    "dojo/dom-class",
    "dojo/dom-style"
], function(declare, Base, Shelf,NewMixin,query,domClass,domStyle) {
    return declare("widgets.standardTmp01.News", [Base,Shelf,NewMixin], {
        getShelfId:function(){
            return "31036";
        },
        initData:function(){
            if(this.isNewsLoaded()){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        indexNewsElement:function(){
            this.inherited(arguments);
            this.WB_feed_handle = query(".WB_feed_handle",this.domNode)[0];
        },
        onTplLoaded:function(pane){
            this.inherited(arguments);
            this.indexNewsElement();
            this.initNewsEvent();
            this.refreshAllList();
            // 按钮添加到footer中
            this.footerNode.appendChild(this.WB_feed_handle);
        }
    });
});