define([
    "dojo/_base/declare", 
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_OrderListMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array",
    "dojo/dom-attr",
    "widgets/userInfo",
    "dojo/dom-style",
    "dojo/_base/lang"
    ], function(declare, Base,Shelf,OrderListMixin,registry,query,array,domAttr,userInfo,domStyle,lang) {
    return declare("widgets.standardTmp01.OrderList", [Base,Shelf,OrderListMixin], {
        getShelfId:function(){
            return "30348";
        },
        initData:function(){
            if(this.isOrderListLoaded()){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            this.indexOrderListElement();
            this.initOrderListEvent();
            this.orderDetailHeader = query(".orderListHeader",pane.domNode)[0];
            this.headerFloor.domNode.appendChild(this.orderDetailHeader);
            /*if(window.util.isBrowser())
            {
                
            }*/
            domStyle.set(this.headerFloor.domNode.childNodes[0],"display","none");
            domStyle.set(this.headerFloor.domNode.parentNode,"display","block");
            //this.headerFloor
            this.refreshAllList();
        }
    });
});