<div class="withHeader withFooter">
    <!--订单数据-->
    <div id="distraBillOrd" data-dojo-type="cqthink.wb.List2" rs_wb_wait="nothing" rs_wb_md="XSY_VSDSG_DELIVERYBILL2" rs_wb_flt="25" rs_wb_param="({T4_EntryID:window.did})"><!--rs_wb_order="[T4_AID],[T4_MID.T0_MID] DESC"-->
    {% if items.length %}
    {% for item in items %}
        <li class="disBillLi">
            <div>
                <span class="disBillLeft">商品：{{item.T4_MID.T0_GName}}</span>
                <span class="disBillRight disBillcolor">×{{item.T4_AppliedQty|floatformat:"0"}}</span><!--购买商品的数量-->
            </div>
            <div>
                <span class="disBillLeft">总配送：{{item.T4_D_TIMES|floatformat:"0"}}{{item.T4_MID.T20_MeasureName}}</span>
                <span class="disBillRight">已配送：{{item.T4_DeliveryQty|floatformat:"0"}}{{item.T4_MID.T20_MeasureName}}</span>
    		 </div> 
		    <div class="disBillLeft">剩余数量：{% if item.newNum %}{{item.newNum|floatformat:"0"}}{% else %}0{% endif %}{{item.T4_MID.T20_MeasureName}}</div>
        </li>
    {% endfor %}
    {% endif %}     
    </div>
    <!--配送清单数据-->
    <div id="distraBillDel" class="distraBillDel" data-dojo-type="cqthink.wb.List3" rs_wb_wait="nothing" rs_wb_md="XSY_VSDSG_DISTRABILL" rs_wb_flt="01" rs_wb_param="({SourceBillID:window.did})" rs_wb_order="[T0_BillDate] DESC">
    {% if items.length %}
    {% for item in items %}
    {% ifequal item.T0_State 1 %}<!--配送单已经审核才显示-->
        <li class="disDelBillLi">
            <div>
                <span class="disBillDelLeft">配送日期：{{item.T0_BillDate}}</span>
                <span class="disBillDelRight">{{item.T2_ActualQty|floatformat:"0"}}{{item.T2_MID.T20_MeasureName}}</span><!--该次配送的数量-->
            </div> 
            <div>
                <span class="disBillDelLeft">配送员：{{item.T0_EMP}}</span>
                <span class="disBillDelRight disBillcolor">{{item.T0_TEL}}</span><!--配送员电话-->
            </div>    
            {% if item.T0_BillCode %}
            <div class="disBillDelLeft">货运单号：{{item.T0_BillCode}}</div>
            {% endif %}
        </li>
    {% endifequal %}    
    {% endfor %}
    {% endif %} 
    </div>
</div>
<style>
.disBillDelLeft{
    font-size:12px;
}
.disBillLeft{
    font-size:14px;
}
.disBillDelRight{
    font-size:12px;
    float: right;
}
.disBillRight{
    font-size:14px;
    float: right;
}
#distraBillOrd{
    border-bottom: solid 1px #ccc;
    background-color:#5d6b85;
    color:white;
}
.disBillLi{
    padding:16px 28px 16px 28px;
}
.disBillLi>div,.disDelBillLi>div{
    margin-bottom:12px;
}
.disBillLi>div:last-child{
    margin-bottom:0;
}
.disBillcolor{
    color:#ff4401;
}
#distraBillDel>li{
    padding-top:16px;
    padding-bottom:16px;
    border-bottom:solid 1px #E5E5E5;
}
#distraBillDel>li:last-child{
    border-bottom:0;
}
.disDelBillcolor{
    color:#5f6b85;
}
.disDelBillLi>div:last-child{
    margin-bottom:0;
}
.disDelBillLi{
    margin-right:28px;
    margin-left:28px;
}
</style>