<div class="productCelect_sjmdDiv">
    <div class="navTop">
        <div class="leftDiv">
            <p class="selected">商品</p>
        </div>
        <div class="rightDiv">
            <p>店铺</p>
        </div>
    </div>
    <ul id="productCelect_sjmdUl" class="productCelect_sjmdUl" data-dojo-type="cqthink.wb.List3" rs_wb_md="XSY_TWBCM_STORE" rs_wb_flt="04" rs_wb_param="({PID:window.userInfo.partnerId})" rs_wb_page="10" rs_wb_order="[S_DATE] DESC">
        {% if items.length %}
        {% for item in items %}
            <li class="productCelect_sjmdLi">
                {% ifequal item.MID.T18_IsUse '' %}
                <div class="pCelectDiv" onclick="jumpToMatDetail('{{item.MID}}','{{item.MID.T0_IsUse}}','{{item.DID}}');">
                {% else %}
                <div class="pCelectDiv" onclick="jumpToMatDetail('{{item.MID}}','{{item.MID.T18_IsUse}}'),'{{item.DID}}');">
                {% endifequal %}
                    <div class="pCelectImgDiv">
                        {% ifequal item.MID.T0_MTID '' %}
                        <img class="pCelectImg" src="/w/img/load/{{all_window.g_sys_info.code}}-{{item.MID.T0_IconURLID}}" style="width:82px; height:82px;" />
                        {% else %}
                        <img class="pCelectImg" src="/w/img/load/{{all_window.g_sys_info.code}}-{{item.MID.T18_IconURLID}}" style="width:82px; height:82px;" />
                        {% endifequal %}
                    </div>
                    
                    <div class="pCelectDetailDiv">
                        <div class="pCelectMatNameDiv">
                            <span class="pCelectMatName">{{item.MID.T0_GName}}</span>
                        </div>
                        
                        <div class="pCelectPriceDiv">
                        {% ifequal item.MID.T18_IsUse '' %}
                            {% ifequal item.MID.T0_IsUse 1 %}
                            <span class="pCelectPrice">￥&nbsp{{item.MID.T3_RetailPrice|floatformat:"2"}}</span>
                            {% else %}
                            <span class="pIsUsed">已失效</span>
                            {% endifequal %}
                        {% else %}
                            {% ifequal item.MID.T18_IsUse 1 %}
                            <span class="pCelectPrice">￥&nbsp{{item.MID.T3_RetailPrice|floatformat:"2"}}</span>
                            {% else %}
                            <span class="pIsUsed">已失效</span>
                            {% endifequal %}
                        {% endifequal %}
                        </div>
                        
                        <div class="pCelectDateDiv">
                            <span class="pCelectDate">{{item.S_DATE}}</span>
                        </div>
                        
                        <div class="cancelCelectDiv" onclick="cancelCelect('{{item.DID}}', event);">
                            <div class="cancelCelectImgDiv">
                                <img class="cancelCelectImg" src="http://w.cqthinkcontent/sjmdsvc/image/cancelCeleter.png" style="width:20px; height:20px;" />
                            </div>
                            <div>
                                <span class="cancelCelect">取消收藏</span>
                            </div>
                        </div>
                        
                    </div>
                    
                </div>
            </li>
        {% endfor %}
        {% else %}
		<div class="notFoundItem">
            <div class="notFoundItem_img">
                <img src="../../Content/standardTmp01/images/noOrder.png"/>
            </div>
            <div class="notFoundItem_txt">
                <span>没有收藏的商品！</span>
            </div>
            <div class="getTarget">
                <a href="#main">随便逛逛</a>
            </div>
        </div>
		{% endif %}
    </ul>
    <ul id="storeDept" style="display:none" data-dojo-type="cqthink.wb.List3" rs_wb_md="XSY_TWBCM_STORE" rs_wb_flt="07" rs_wb_param="({PID:window.userInfo.partnerId})" rs_wb_page="20">
        {% if items.length %}
            {% for item in items %}
            <li class="deptLists" data-deptid={{item.DEPTID}}>
                <img class="deptImg" src="/w/img/load/{{all_window.g_sys_info.code}}-{{item.DEPTID.T0_ICON}}.png">
                <ul class="deptDetails">
                    <li>{{ item.DEPTID.T0_DeptName }}</li>
                    <li>
                        <div class="deptRemark">
                            <p>{{item.DEPTID.T0_Remark}}</p>    
                        </div>
                        <div class="btnDept" data-did={{item.DID}}>
                            <div class="cancelCelectImgDiv">
                                <img class="cancelCelectImg" src="http://w.cqthink.com/w/Content/sjmdsvc/image/cancelCeleter.png" style="width:20px; height:20px;" />
                            </div>
                            <div>
                                <span class="cancelCelect">取消收藏</span>
                            </div>
                        </div>
                        <div class="clearFloat"></div>
                    </li>
                </ul>
            </li>
            {% endfor %}
        {% else %}
            <div class="notFoundItem">
                <div class="notFoundItem_img">
                    <img src="../../Content/standardTmp01/images/noOrder.png"/>
                </div>
                <div class="notFoundItem_txt">
                    <span>没有收藏的门店！</span>
                </div>
                <div class="getTarget">
                    <a href="#main">随便逛逛</a>
                </div>
            </div>
        {% endif%}
    </ul>
</div>
<style>
    .productCelect_sjmdDiv{
        background-color:#F3EFEF;
    }
    #productCelect_sjmdUl,#storeDept{
        background-color:#fff;
    }
    .navTop{
        height:36px;width:100%;
        border-bottom:1px solid #ccc;
        font-size:14px;
        color:rgb(102,102,102);
        text-align:center;
        line-height:36px;
        background-color:#fff;
        margin-bottom:8px;
    }
    .navTop .leftDiv,.navTop .rightDiv{
        width:48%;
        display:inline-block;
    }
    .navTop .leftDiv p{
        float:right;
    }
    .navTop p{
        width:56.25%;
        height:33px;
    }
    .selected{
        color:#e5004f;
        border-bottom:2px solid #e5004f;
    }
    .deptImg,.deptLists>ul{
        margin-top:8px;
    }
    img.deptImg{
        height:84px;
        width:84px;
        float:left;
        margin-left:8px;
    }
    .deptLists{
        width:100%;
        height:100px;
        border-bottom:1px solid #e5e5e5;
    }
    .deptDetails{
        margin-left:100px;
        height:84px;
    }
    .deptDetails>li{
        width:100%;
    }
    .deptDetails>li:first-child{
        font-size:14px;
        color:rgb(51,51,51);
        line-height:18px;
        margin-bottom:8px;
    }
    .deptDetails>li:last-child{
        font-size:12px;
        color:rgb(102,102,102);
        line-height:15px; 
        min-height:35px;
    }
    .deptRemark{
        float: left;
        margin-right: -56px;
        width: 100%;
        word-break: break-all;
        word-wrap: break-word;
    }
    .deptRemark p{
        margin-right:54px;
    }
    .btnDept{
        float: right;
        width: 48px;
        margin-right:8px;
    }
    .clearFloat{
        clear:both;
        height:0;width:0;
    }
</style>