﻿define([
	"dojo/Deferred",
	"./util"
],function(Deferred,util){
	if(util.Client.hasCanvasImageData()){
		return function(src,width,height){
			var def = new Deferred(),img = document.createElement("img");
			img.src = src;
			img.onload = function(){
				var scale = Math.max(img.width/width,img.height/height);
				if(scale>1){
					width = img.width/scale;
					height = img.height/scale;
					var c = document.createElement("canvas"),ctx = c.getContext("2d");
					c.width = width;
					c.height = height;
					ctx.drawImage(img,0,0,width,height);
					//赵春辉	强行转化为jpeg格式好了，这种格式的图片比较小，实际上应该保持来源图片格式	2014-07-18
					//赵春辉	要保持图片的原始格式，有些图标是透明背景，转为jpg格式后背景变成黑色		2015-07-23
					if(-1<img.src.split(".").pop().toLowerCase()==="png"||-1<img.src.toLowerCase().indexOf("data:image/png;base64,")){
						//赵春辉	png文件不存在压缩比的问题	2015-09-09
						def.resolve(c.toDataURL());
					}else{
						//赵春辉	处理图片压缩比	2015-09-09
						//赵春辉	支持配置图片压缩比	2015-10-09
						var q = ((window.cqthink&&cqthink.app&&cqthink.app.configer&&cqthink.app.configer.imageQuality)-0)||1;
						def.resolve(c.toDataURL("image/jpeg",q));
					}
				}else{
					def.resolve(src);
				}
			}
			return def;
		};
	}else{
		return function(src,width,height){return src};
	}
});