define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "dojox/mobile/SpinWheel",
    "dojox/mobile/SpinWheelSlot",
    "dojo/_base/array",
    "dojox/mobile/Opener",
    "dojox/mobile/Heading",
    "dojox/mobile/ToolBarButton",
    ], function(declare, registry, query, userInfo, xhr, json, lang, SpinWheel, SpinWheelSlot, array,Overlay,Heading,ToolBarButton) {
    return declare("widgets.common._AddWbMixin", null, {
        isAddWbMixinLoaded: function() {
            return !!this.dpt;
        },
        indexDeptListElement: function() {
            this.dpt = registry.byId("dptList_1");
            this.user = query(".username", this.domNode)[0];
            this.tel = query(".telnumber", this.domNode)[0];
            this.orderAdd = query(".orderAdd", this.domNode)[0];
            this.Remark = query(".Remark", this.domNode)[0];
            this.Re = query(".postRegist", this.domNode)[0];
            this.year = query(".year", this.domNode)[0];
            this.month = query(".month", this.domNode)[0];
            this.day = query(".day", this.domNode)[0];
            this.hour = query(".hour", this.domNode)[0];
            this.minute = query(".minute", this.domNode)[0];
            this.custom=query(".customPicker",this.domNode)[0];
            this.stor=query("#stor",this.domNode)[0];
            this.mblDomButton = query("#popup", this.domNode)[0];
            this.connect(this.mblDomButton, "onclick", lang.hitch(this, this.popshow));
            this.store_1=query("#store",this.domNode)[0];
            this.dateTimeCont = query(".addWb_Wheel", this.domNode)[0];

            this.customPicker=new Overlay({
                id:"dojox_mobile_Opener_0",
                style:{
                   width: "100%" 
                }
            });
            this.customPicker.placeAt(this.domNode);
            
            this.Heading=new Heading({
                style:{
                    background:"#d6d6d6",
                }
            })
            this.Heading.placeAt(this.customPicker);
            this.Heading.startup();
            
            
             this.ToolBarButtonExit=new ToolBarButton({
                label:"取消",
                style:"font-size:16px;color:#e5004f;float:left;margin-left: 2%;",
            })
             this.ToolBarButtonExit.placeAt(this.Heading);
            this.ToolBarButtonExit.startup();
            
            this.ToolBarButtonTime=new ToolBarButton({
                label:"可选时间",
               style:"font-size:16px;color:#ff78a0;",
            })
             this.ToolBarButtonTime.placeAt(this.Heading);
            this.ToolBarButtonTime.startup();
            
            this.ToolBarButton=new ToolBarButton({
                label:"完成",
              /*  onclick:"dijit.registry.byId('dojox_mobile_Overlay_0').hide()",*/
                style:"font-size:16px;color:#e5004f;float:right;margin-right: 2%;",
            })
             this.ToolBarButton.placeAt(this.Heading);
            this.ToolBarButton.startup();
            
            this.dateTime = new SpinWheel({
                id: "addWbDateTime",
                style:"width:100%;heigth:100px;background:#fff"
            });
            this.dateTime.placeAt(this.customPicker);
            
            this.customPicker.startup();

            var slot1 = new SpinWheelSlot({
                labels: this.getSevenDay(),
                style: {
                    textAlign: "center",
                    width: "50%",
                     heigth:"100px",
                }
            });
            this.dateTime.addChild(slot1);
            

            var slot2 = new SpinWheelSlot({
                labels: ["8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21"],
                style: {
                    textAlign: "center",
                    width: "24%",
                     heigth:"100px",
                }
            });
            this.dateTime.addChild(slot2);

            var slot3 = new SpinWheelSlot({
                labels: ["00", "15", "30", "45"],
                style: {
                    textAlign: "center",
                    width: "24%",
                    heigth:"100px",
                }
            });
            this.dateTime.addChild(slot3);

            this.dateTime.startup();
            //监听日期选择，如果日期是当前日期，则禁止选择当前小时以前的小时，如果当前分钟大于45则当前小时也禁止，

           
            this.connect(this.ToolBarButton,"onClick", lang.hitch(this, this.pophide));
            this.connect(this.ToolBarButtonExit,"onClick", lang.hitch(this, this.pophide_1));
            this.connect(this.stor,"onclick", lang.hitch(this, this.selectStor));
            this.connect(slot1, "onFlickAnimationEnd", lang.hitch(this, this.relatime));
            this.connect(slot2, "onFlickAnimationEnd", lang.hitch(this, this.relatime));
            this.connect(slot3, "onFlickAnimationEnd", lang.hitch(this, this.relatime));
            //监听小时选择如果日期是当天且小时是当前小时，则禁止选择当前分钟前的分钟，
            
            
            this.subscribe("cqthink/wx/sjmdsvc/addwb",function(deptItem){
               /* var store=query(".store",this.domNode)[0];
                store.innerHTML ="部门名称";*/
           
            
            var strs= new Array(); //定义一数组 
            strs=deptItem.split(",");//字符分割 
            query("#store", this.domNode)[0].innerHTML=strs[2];
            query("#store_id", this.domNode)[0].innerHTML=strs[1];
           
     /*       window.loadData({
                modalName: "XSY_TBSHR_DEPT2",
                filter: "03",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "AID": deptItem[0].AID
                    "DeptID": deptItem[0].DeptID,// 过滤器参数
                }
            }).then(lang.hitch(this, function(data) {
                if(data.length>0){*/
  /*              }
            }));*/
            });
        },
        selectStor:function(){
             window.loadData({
                modalName: "XSY_VSDSG_DELIVERYBILL2",
                filter: "25",
                pageSize: "1",
                pageIndex: "1",
                param: {
                    "T4_EntryID": window.did,// 过滤器参数
                }
            }).then(lang.hitch(this, function(data) {
                if(data.length>0){
                   window.moveToView("addWbdeptList",data[0].T4_AID);
                }}))
        },
        pophide_1:function(){
          registry.byId("dojox_mobile_Opener_0").hide();
        },
        pophide:function(){
            var sel=query("#selectTime", this.domNode)[0];
            var sss=this.dateTime.get("values")[0] + " " + this.dateTime.get("values")[1] + ":" + this.dateTime.get("values")[2] + ":00";
            sel.innerHTML=sss;
            
            registry.byId("dojox_mobile_Opener_0").hide();
            
        },
        popshow:function(){
            registry.byId("dojox_mobile_Opener_0").show();
        },
        getSevenDay: function() {
            //定义一个数组
            var dateArray = [];
            //获取当前日期
            var date = g_s.getDate();
            //循环7天
            for (var i = 0; i < 7; i++) {
                var d = g_s.dateAdd(date, "d", i);

                dateArray.push(g_s.toDateString(d));
            };
            //返数组
            return dateArray;
        },

  

        relatime: function() {
            var myDate = new Date();
            var time1 = myDate.getTime(); //获取当前时间毫秒数
            var strtime = this.dateTime.get("values")[0] + " " + this.dateTime.get("values")[1] + ":" + this.dateTime.get("values")[2] + ":00";
            var str = strtime.replace(/-/g, "/"); //获取选取时间
            var strdate = new Date(str);
            var time2 = strdate.getTime(); //获取选取时间(从1970.1.1开始的毫秒数)
            //判断时间范围
            if (time1 > time2) {
                var hs = myDate.getHours();
                var ms = myDate.getMinutes();
                var min = this.getminute(ms);
                var hos = registry.byId("dojox_mobile_SpinWheelSlot_1");
                var mins = registry.byId("dojox_mobile_SpinWheelSlot_2");
                if (hs == 20 && ms >= 45) {
                    //天数提前一天
                    var days = registry.byId("dojox_mobile_SpinWheelSlot_0");
                    days.set("value", myDate.getFullYear() + "-" + (myDate.getMonth().length == 1 ? "0" + myDate.getMonth() : (myDate.getMonth()+1)) + "-" + (myDate.getDate().length == 1 ? "0" + (myDate.getDate()+1) : myDate.getDate()))
                    //设置小时8点
                    hos.set("value", "8")
                    //设置分钟00
                    mins.set("value", "00")
                } else {

                    if (min == 60) {
                        hos.set("value", hs + 1 + "")
                        mins.set("value", "00")
                    } else {
                        hos.set("value", hs + "")
                        mins.set("value", min)
                    }
                }
                /*this.dateTime.get("values")[2].set("value","30")*/

            }
        },

        getminute: function(minute) {
            if (minute > 0 && minute < 15) {
                return 15
            }
            if (minute >= 15 && minute < 30) {
                return 30
            }
            if (minute >= 30 && minute < 45) {
                return 45
            }
            if (minute >= 45) {
                return 60
            }
        },

        refreshAllList: function() {
            if (window.did != this.did) {

                this.did = window.did;
                this.dpt.refreshList();
            }
            this.user.value = userInfo.getUserInfo().name;
            this.tel.value = userInfo.getUserInfo().tel;
            this.orderAdd.value = userInfo.getUserInfo().addr;
            window.updateTitle("预约详情");
            this.resize;
        },
        initAddwbElement: function() {
            this.connect(this.Re, "onclick", this.postwb);
        },


        userin: function() {
            if (!this.user.value) {
                alert("请输入姓名！");
                return false;
            }
            if (!this.tel.value) {
                alert("请输入电话！");
                return false;
            }
            if (this.tel.value) {
                if (!(/(^1[3|4|5|7|8][0-9]{9}$)/.test(this.tel.value))) {
                    alert("电话格式错误！");
                    return false;
                }
            }
            if (!this.orderAdd.value) {
                alert("请输入地址！");
                return false;
            }
            var selectTimes=query("#selectTime", this.domNode)[0].innerHTML;
            if(selectTimes=='点击选择时间'){
                  alert("请输入时间！");
                  return false;
            }
            if(!(query("#store_id",this.domNode)[0].innerHTML)){
                alert("请选择门店！");
                return false;
            }else{
                return true;
            }

        },

        hastime:function(){
            window.loadData({
                    modalName: "XSY_VSDSG_DELIVERYBILL2",
                    filter: "25",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "T4_EntryID": window.did
                    }
                }).then(lang.hitch(this, function(data) {
                    if((parseInt(data[0].T4_DeliveryQty))!=(parseInt(data[0].T4_D_TIMES))){
                        return true;
                    }
                    else{
                        alert("预约次数用完")
                        return false;
                    }
                }))
        },
        postwb: function() {
            var format = this.userin();
            var hastimes=this.hastime();
            
            if (format == true&&(hastimes == true||hastimes==undefined)) {

                var wb = {};
                wb.REMARK = this.Remark.value;
                wb.ConsigneeName = this.user.value;
                wb.ConsigneeNumber = this.tel.value;
                wb.ConsigneeAddres = this.orderAdd.value;
                wb.DEPTID = query("#store_id",this.domNode)[0].innerHTML;
                wb.CLIENT = userInfo.getUserInfo().partnerId;
                wb.DELBILLTOWB = window.did;
                wb.PLANSTIME = query("#selectTime", this.domNode)[0].innerHTML;
                
              window.loadData({
                    modalName: "XSY_TSDSG_DELIVERYBILLDTS",
                    filter: "02",
                    pageSize: "1",
                    pageIndex: "1",
                    param: {
                        "EntryID": window.did // 过滤器参数
                    }
                }).then(lang.hitch(this, function(data) {
                    if (data.length > 0) {
                        wb.SERVICEID = data[0].MID;
                        xhr("POST", {
                            url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                            handleAs: "json",
                            content: {
                                data: json.toJson({
                                    modalName: "XSY_TSCSF_WB",
                                    data: [{
                                        n: wb
                                    }]
                                })
                            },
                            load: lang.hitch(this, function(result) {
                                if (1 === result.rtnType) {
                                    window.moveToView("wbList_sjmd");
                                } else {
                                    alert(result.message || "数据错误!");
                                }
                            })
                        });
                    } else {
                        alert("预约失败")
                    }
                }));
            }

        }
    });
});