define([
    "dojo/_base/declare", 
    "dijit/registry"], function(declare,registry) {
    return declare("widgets.common._AutoReplyMixin", null, {
        mGroupName:"",
        isAutoReplyLoaded:function(){
            return !!this.autoReply;
        },
        indexAutoReplyElement:function(){
            this.autoReply = registry.byId("autoReply1");
        },
        refreshAllList: function() {
            if (window.did != this.did) {
                window.updateTitle("智能回复");
                window.did = this.did = decodeURIComponent(window.did);
                this.autoReply.refreshList();
                this.scrollTo({x:0,y:0});
            }else{
                window.updateTitle(this.mGroupName);
            }
        },
        initAutoReplyEvent:function(){
            this.connect(this.autoReply, "onDefRendered", function(data) {
                if(data.data&&data.data.items&&data.data.items.length){
                    if(this.did){// 有did才指定资讯栏目
                        this.mGroupName = data.data.items[0]["AR_TOPIC"];
                    }
                }else{
                    this.mGroupName = '暂无回复';
                }
                //处理界面的标题
                window.updateTitle(this.mGroupName);
            });
        }
    });
});