define([
    "dojo/_base/declare", 
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/array"
], function(declare,domAttr,registry,array) {
    return declare("widgets.common._EnterpriseMixin",null,{
        isEnterpriseLoaded:function(){
            return !!this.matGroupShow;
        },
        indexEnterpriseElement:function(){
            this.matGroupShow = registry.byId("enterpriseId");
            //this.matGroupList = registry.byId("enterpriseMatList");
        },
        initEnterpriseListEvent:function(){
            if(this.isEnterpriseLoaded()){
                this.connect(this.matGroupShow, "onBeforeRender", function() {
                    if (this.matGroupShow.items.length > 0) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.LOGO + ".png";
                        item.title = item.APP_TITLE;
                    }
                });
            }
            /*this.connect(this.matGroupList.domNode,"onclick",function(e){
                var dom = e.target;
                while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.domNode){
                    dom = dom.parentNode;
                }
                if(dom){
                    window.moveToView("MatList", dom.MGID);
                }
            });*/
        },
        refreshAllList:function(){
            if(window.did!=this.did&&this.isEnterpriseLoaded()){
                this.did = window.did;
                this.matGroupShow.refreshList();
                //this.matGroupList.refreshList();
            }
            this.inherited(arguments);
        }
    });
});