define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "dojo/query",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dijit/registry"
    ], function(declare, array, query, json, xhr, lang, userInfo, registry) {
    return declare("widgets.common._MatEvaToAddMixin", null, {
        isMatEvaToAddLoaded:function(){
            return !! this.postMatEvaToAddEle;
        },
        indexMatEvaToAddElement: function() {
            this.inherited(arguments);
            this.postMatEvaToAddEle = query(".postMatEvaToAdd", this.domNode)[0];
        },
        refreshAllList: function() {
            this.inherited(arguments);
            window.updateTitle("评价追加");
            this.type = window.did.split("_")[1];
            window.did = window.did.split("_")[0];
            if (window.did != this.did) {
                this.did = window.did;
                if(this.type=="wb"){
                    registry.byId("wbevaToAdd").refreshList();
                    registry.byId("wbevaToAdd").domNode.style.display = "";
                    registry.byId("evaToAdd").domNode.style.display = "none";
                }else{
                    registry.byId("evaToAdd").refreshList();
                    registry.byId("evaToAdd").domNode.style.display = "";
                    registry.byId("wbevaToAdd").domNode.style.display = "none";
                }
            }
        },
        initMatEvaToAddEvent: function() {
            this.inherited(arguments);
            this.connect(this.postMatEvaToAddEle, "onclick", this.postMatEva);
        },
        postMatEva: function() {
            //alert("----");
            if((this.type=="mat"&&!query(".matEvaInput_mat")[0].value)||(this.type=="wb"&&!query(".matEvaInput_wb")[0].value)){
                alert("请先填写评价。");
                return;
            }
            var data = {
                n: {
                    IS_ADD: 1,
                    ADD_CONTENT: this.type=="mat"?query(".matEvaInput_mat")[0].value:query(".matEvaInput_wb")[0].value
                },
                o: {
                    "DID": window.did
                }
            };
            xhr("POST", {
                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                handleAs: "json",
                content: {
                    data: json.toJson({
                        modalName: "APP_TBSAV_CMMNT",
                        data: [data]
                    })
                },
                load: lang.hitch(this, function(result) {
                    if (1 === result.rtnType) {
                        alert("提交评论成功。");
                        window.moveToView("matEvaList", "");
                        window.free();
                        query(".matEvaInput", this.domNode)[0].value = "";

                    } else {
                        alert(result.message || "数据错误!");
                        query(".matEvaInput", this.domNode)[0].value = "";
                        window.free();
                    }
                })
            });
        }
    });
});