define([
    "dojo/_base/declare", 
    "dojo/_base/array",
    "dijit/registry"
],function(declare,array,registry){
    return declare("widgets.common._MatSaleListMixin",null,{
        TName:"",
        indexMatSaleListElement:function(){
            this.mList = registry.byId("matSaleList1");
        },
        refreshAllList:function(){
            this.mList.refreshList();
            this.scrollTo({x:0,y:0});
        },
        initMatSaleListEvent:function(){
            this.connect(this.mList,"onDefRendered",function(data){
                if(data.data.items.length){
                    var items = data.data.items;
                    this.TName = items[0].MID.T0_GName;
                    array.forEach(items,function(item){
                        item.apples = new Array(item.NUM-0+1).join("❤");
                        item.hrefs = window.wx_openId?'<a style="color:blue;" href="#wxconnect-'+encodeURIComponent(window.wx_openId+"&"+item.OPENID)+'">和TA对话</a>':"";
                    });
                }else{
                    this.TName = "暂无商品";
                }
                window.updateTitle(this.TName);
            });
        }
    });
});