define([
    "dojo/_base/declare", 
    "dojo/_base/lang",
    "dojo/query",
    "dijit/registry",
    "../userInfo",
    "dojo/dom-attr",
    "dojo/_base/array",
    "dojo/dom-style"],function(declare,lang,query,registry,userInfo,domAttr,array,domStyle){
    return declare("widgets.common._OrderListMixin",null,{
        //isTrade:false,
        isOrderListLoaded:function(){
            return !!this.tradeList;
        },
        indexOrderListElement:function(){
            //if(!this.isOrderListLoaded()){
            this.tradeList = registry.byId("tradeList1");
            //this.tradeListInfo = query("#tradeListInfo")[0];
            this.orderHead = query(".orderHead")[0];//找到订单列表的头部
            //}
        },
        initOrderListEvent:function(){
            this.connect(this.tradeList, "onDefRendered", function(data) {//加载购物车list2之前
                var itemNotPost = array.filter(data.data.items,function(item){
                    return item.T4_MID!=29999;
                });
                //关于修改数据
                var items = data.data.items,
                    len = itemNotPost.length,orderMatNums = [];
                array.forEach(itemNotPost,function(item,index){
                    item.last = index < (itemNotPost.length-1) && item.T0_DeliBillID == itemNotPost[index+1].T0_DeliBillID ? 0 : 1;
                });
                array.forEach(items,function(item,index){
                    item.type=index>0&&item.T0_DeliBillID==data.data.items[index-1].T0_DeliBillID?0:1;//判断是否交易单的第一个订单
                    
                    //item.last = index < (items.length-1) && item.T0_DeliBillID == data.data.items[index+1].T0_DeliBillID ? 0 : 1;
                    
                    /*if(itemNotPost.length==1){
                        item.last=1;
                    }else{
                        item.last=index<itemNotPost.length-1&&item.T0_DeliBillID==data.data.items[index+1].T0_DeliBillID?0:1;
                        if(item.T4_MID==29999&&index>0){
                            item.last = 0;
                            data.data.items[index-1].last=1;
                        }
                    }*/
                    // 判断订单的状态
                    if(item.T4_MID!=29999){
                        if(index>0&&item.T0_DeliBillID==data.data.items[index-1].T0_DeliBillID){//如果是第二行且与上一行的AID一致
                            array.forEach(orderMatNums,function(orderMatNum){
                                if(orderMatNum.T0_DeliBillID==item.T0_DeliBillID){
                                    orderMatNum.totalNum += 1;
                                }
                            },this);
                        }else{
                            orderMatNums.push({
                                T0_DeliBillID:item.T0_DeliBillID,
                                totalNum:1
                            });
                        }
                    }
                },this);
                array.forEach(items,function(item){
                    array.forEach(orderMatNums,function(orderMatNum){
                        if(item.T0_DeliBillID==orderMatNum.T0_DeliBillID){
                            item.totalNum = orderMatNum.totalNum;
                        }
                    },this);
                },this);
                window.free();
                //this.updateFooter();
            });
            //this.subscribe("widgets/show/view",function(id){
            //    if(id===this.id){
            //        this.updateFooter();
            //    }
            //});
            if(this.orderHead){// 判断是否有商品列表中的排序节点
                this.connect(this.orderHead,"onclick",function(e){
                    var dom = e.target;
                    while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this.orderHead){
                        dom = dom.parentNode;
                    }
                    if(dom){
                        var name = domAttr.get(dom,"name");
                        var cls = domAttr.get(dom,"class");
                        this.clearState(dom);
                        domAttr.set(dom,"class",(("tableLiChecked"===cls)||cls=="")?"tableLi":"tableLiChecked");
                        domAttr.set(dom,"class","tableLiChecked");
                        this.tradeList.rs_wb_flt = name;
                        //window.busy();
                        this.tradeList.refreshList();
                    }
                });
            }
        },
        refreshAllList:function(){
            this.isTrade = true;
            window.updateTitle("消费记录");
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    if (this.tradeList) {
                        if(this.orderHead){
                            if(window.did){
                                query("li",this.orderHead).forEach(function(n){
                                    if(domAttr.get(n,"name")==window.did){
                                        domAttr.set(n,"class","tableLiChecked");
                                    }else{
                                        domAttr.set(n,"class","tableLi");
                                    }
                                });
                                this.tradeList.rs_wb_flt = window.did;
                            }
                        }
                        this.tradeList.refreshList();
                        this.scrollTo({x:0,y:0});
                    }
                }else{
                    window.nextPageOnLogin = "orderList";//+window.did?("-"+window.did):"";
                    userInfo.showLogin();
                }
            }));
        },
        clearState:function(node){
            if(this.orderHead){
                query("li",this.orderHead).forEach(function(n){
                    if(n!==node){
                        domAttr.set(n,"class","tableLi");
                    }
                });
            }
        }/*,
        updateFooter:function(){
            if(g_sys_info.temp!="lx2"){
                if(this.isTrade){
                    domStyle.set(this.tradeListInfo,"display","none");
                }else{
                    domStyle.set(this.tradeListInfo,"display","");
                }
            }
        }*/
    });        
});