define([
    "dojo/_base/declare",
    "dojo/query",
    "widgets/userInfo",
    "dojo/_base/lang",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dijit/registry",
    "dojo/dom-style",
    "dojo/_base/event",
],function(declare, query, userInfo, lang, xhr, json, registry, domStyle, event){
    return declare("widgets.common._ProductCelect_sjmdMixin",null,{
        isProductCelect_sjmdLoaded:function(){
            return !!this.productCelect;
        },
        indexProductCelect_sjmdElement:function(){
            this.productCelect = registry.byId("productCelect_sjmdUl");
        },
        initProductCelect_sjmdEvent:function(){
            var pC = this.productCelect;
            //取消收藏事件
            cancelCelect = function(did,e){
                this.updateResource(did);
                event.stop(e);
            };
            //商品收藏跳转
            jumpToMatDetail = function(mid,isUse,did){
                //记得把1改为‘1’
                if(isUse === "1") window.moveToView("matDetail", mid);
                else {
                    //window.defAlert("做什么？");
                    window.defConfirm("商品已失效!(是否移除商品?)","否","是").then(lang.hitch(this,function(s){
                        if(s){
                            this.updateResource(did);
                        }
                    }));
                }
            };
            //更改资源
            updateResource = function(did){
                userInfo.hasLogin().then(lang.hitch(this,function(su){
                    if(su){
                        var data = {
                                o:{
                                    "DID":did
                                },
                                n:{
                                    "ISSTORE":0
                                }
                            };
                            xhr("POST", {
                                url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                                handleAs: "json",
                                content: {
                                    data: json.toJson({
                                        modalName: "XSY_TWBCM_STORE",
                                        data: [data]
                                    })
                            },
                            load: lang.hitch(this, function(result) {
                                if (1 === result.rtnType) {
                                    //this.refreshAllList();
                                    window.free();
                                } else {
                                    alert(result.message || "数据错误!");
                                    window.free();
                                }
                            })
                        });
                    }else{
                        window.nextPageOnLogin = "productCelect";
                        userInfo.showLogin();
                    }
                }));
                pC.refreshList();
            };
            // window.bb=function(e){
            //     event.stop(e);
            //     userInfo.hasLogin().then(lang.hitch(this,function(s){
            //         if(s){
            //             var data = {
            //                 o:{
            //                     "MID":window.did,
            //                     "PID":window.userInfo.partnerId
            //                 },
            //                 n:{
            //                     "MID":window.did,
            //                     "PID":window.userInfo.partnerId,
            //                     "ISSTORE":0,
            //                     "S_TYPE":0
            //                 }
            //             };
            //             xhr("POST", {
            //                 url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
            //                 handleAs: "json",
            //                 content: {
            //                     data: json.toJson({
            //                         modalName: "XSY_TWBCM_STORE",
            //                         data: [data]
            //                     })
            //             },
            //             load: lang.hitch(this, function(result) {
            //                 if (1 === result.rtnType) {
            //                     //this.refreshAllList();
            //                     window.free();
            //                 } else {
            //                     alert(result.message || "数据错误!");
            //                     window.free();
            //                 }
            //             })
            //         });
            //         }else{
            //             window.nextPageOnLogin = "productCelect_sjmd";
            //             userInfo.showLogin();
            //         }
            //     }));
            // };
        },
        refreshAllList:function(){
            this.productCelect.refreshList();
        }
    });
});