define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/json",
    "dojo/_base/xhr",
    "dojo/dom-style",
    "dijit/focus"
], function(declare,lang, registry,query,json,xhr,domStyle,focusUtil) {
    return declare("widgets.common._SubNewsEvaMixin", null, {
        isSubNewsEvaLoaded: function() {
            return !!this.subNewsEva;
        },
        indexSubNewsEvaElement: function() {
            this.subNewsEva = registry.byNode(query(".subNewsEva",this.domNode)[0]);
            // 提交评价
            this.subNewsEvaBtn = query(".subNewsEvaBtn",this.domNode)[0];
            // 评论的内容
            this.evaContent = query(".evaContent",this.domNode)[0];
        },
        initSubNewsEvaEvent: function() {
            this.connect(this.subNewsEvaBtn,"onclick",this.subNewsEvaFuc);
        },
        subNewsEvaFuc:function(e){
            var activeElement = focusUtil.curNode;
            focusUtil.curNode && focusUtil.curNode.blur();
            if(!this.evaContent.value){
                alert("写点什么吧~");
                return;
            }
            window.busy();
            xhr("POST",{
            url:"/w/order/comment/" + window.code,
                handleAs: "json",
                content:{
                    data:json.toJson({
                         RID:"XSY_TWBCM_NEWS",
                         RIID:window.did,
                         CONTENT:this.evaContent.value
                    })
                },
                load: lang.hitch(this, function(result) {
                    window.free();
                    if (1 === result.rtnType) {
                        alert("评论成功！");
                        //评论成功，清空评论内容
                        this.evaContent.value="";
                        window.moveToView("news",window.did);
                    } else {
                        alert(result.message || "数据错误!");
                    }
                })
            });
        },
        refreshAllList: function() {
            if(this.isSubNewsEvaLoaded()){
                this.subNewsEva.refreshList();
            }
        }
    });
});