define([
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/query",
    "dojo/_base/array"
],function(declare,registry,query,array){
    return declare("widgets.common._VoteMgntMixin",null,{
        isVoteMgntLoaded:function(){
            return !!this.voteQtsList;
        },
        indexVoteMgntElement:function(){
            this.voteQtsList = registry.byId("voteQtsList");
            this.postVote = query(".postVote",this.domNode)[0];
        },
        initVoteMgntEvent:function(){
            this.connect(this.voteQtsList,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length){
                    array.forEach(items,function(item,i){
                        item.type = i>0&&(item.T2_ASID==items[i-1].T2_ASID)?0:1;
                    });
                }
            });
            this.connect(this.postVote,"onclick",this.postVoteFuc);
        },
        refreshAllList:function(){
            this.voteQtsList.refreshList();
        }
    });
});