define([
    "dojo/_base/lang",
    "dojo/_base/declare",
    "dijit/registry",
    "dojo/_base/xhr",
    "dojo/dom-style",
    "dojo/Deferred",
    "widgets/userInfo",
    "dojo/query"
    ], function(lang,declare,registry,xhr, domStyle,Deferred,userInfo,query) {
    return declare("widgets.common._cdsMixin", null, {
        isCdsLoaded:function(){
            return !!this.cds;
        },
        indexCdsElement:function(){
            this.cds = registry.byId("cdsList");
            /*this.getCheckCodePane = query(".getCheckCodePane", this.domNode)[0];
            this.submitPane = query(".submitPane", this.domNode)[0];
            this.phoneNumberInput = query(".phoneNumberInput", this.domNode)[0];
            this.checkCodeInput = query(".checkCodeInput", this.domNode)[0];*/
        },
        refreshAllList: function() {
            this.inherited(arguments);
            /*userInfo.hasLogin().then(lang.hitch(this, function(s){
                if(!s){
                    userInfo.showLogin().then(lang.hitch(this,function(){
                        window.moveToView("cds");
                    }));
                }
            }));*/
        },
        initCdsEvent: function(){
            //domStyle.set(query(".cdsPane", this.domNode)[0], {height: domStyle.get(document.body, "height") + "px"});
        },
        getCheckCodeFuc:function(){
            if(!userInfo.validPhoneNumber(query(".phoneNumberInput", this.domNode)[0].value)){
                alert("手机不合法。" + query(".phoneNumberInput", this.domNode)[0].value);
            }else{
                window.sendMsg(query(".phoneNumberInput", this.domNode)[0].value);
            }
        },
        // 获取并判断是否有二维码，如果没有生成
        sendBCard: function(phoneNumber){
            /*var def = new Deferred();
            xhr("GET", {
                url: "/w/user/GetWxBusinessCard/" + window.code,
                handleAs: "json",
                content: {
                },
                error: lang.hitch(this, function(message){
                    defAlert(message || "数据错误");
                }),
                load: lang.hitch(this, function(result) {
                    console.log(result);
                    if (1 === result.rtnType && result.imageId) {
                        xhr("GET",{
                            url: "/w/user/GetBCardToWx/" + window.g_sys_info.code,
                            handleAs: "json",
                            content: {
                            },
                            load: function(dt){
                                console.log(dt);
                                if(1 === dt.rtnType){
                                    try{
                                        WeixinJSBridge.call("closeWindow");
                                    }catch(e){
                                        //alert(e);
                                        window.open('about:blank',"_self").close();
                                    }
                                }
                            }
                        });
                        def.resolve();
                    } else {
                        defAlert(result.message || "数据错误!");
                        window.free();
                        return;
                    }
                })
            });*/
            // 判断二维码是否存在
            var def = new Deferred();
            xhr("GET",{
                url: g_sys_info.url_usr,
                handleAs: "json",
                content: {
                    modalName: "XSY_VCRCS_PARTNER",
                    pageSize: 1,
                    pageIndex: 1,
                    appId: window.g_sys_info.aid,
                    where: "[T1_Fax]='" + phoneNumber + "' AND [T0_AID]=" + window.g_sys_info.aid
                },
                load: lang.hitch(this,function(data){
                    def.resolve(data);
                })
            });
            def.then(lang.hitch(this,function(data){
                xhr("GET",{
                    url: g_sys_info.url_usr,
                    handleAs: "json",
                    content: {
                        modalName: "XSY_TCRCS_CLIENT_DCARD",
                        pageSize: 1,
                        pageIndex: 1,
                        appId: window.g_sys_info.aid,
                        where: "[PID]=" + data.data.items[0].T0_PartnerID + " AND [AID]=" + window.g_sys_info.aid
                    },
                    load: lang.hitch(this,function(dt){
                        // 如果二维码已经存在，直接发送
                        // 否则发送请求，生成二维码，再发送
                        if(!(dt && dt.data && dt.data.items && dt.data.items.length && dt.data.items[0].CARDID)){
                            xhr("GET", {
                                url: "/w/user/GetWxBusinessCard/" + window.code,
                                handleAs: "json",
                                content: {
                                },
                                load: lang.hitch(this, function(result) {
                                    if (1 === result.rtnType && result.imageId) {
                                        xhr("GET",{
                                            url: "/w/user/GetBCardToWx/" + window.g_sys_info.code,
                                            handleAs: "json",
                                            content: {
                                            },
                                            load: function(dt1){
                                                if(1 === dt1.rtnType){
                                                    try{
                                                        WeixinJSBridge.call("closeWindow");
                                                    }catch(e){
                                                        window.open('about:blank','_self').close();
                                                    }
                                                }
                                            }
                                        });
                                        def.resolve();
                                    } else {
                                        defAlert(result.message || "数据错误!");
                                        window.free();
                                        return;
                                    }
                                })
                            });
                        }else{
                            xhr("GET",{
                                url: "/w/user/GetBCardToWx/" + window.g_sys_info.code,
                                handleAs: "json",
                                content: {
                                },
                                load: function(dt1){
                                    if(1 === dt1.rtnType){
                                        try{
                                            WeixinJSBridge.call("closeWindow");
                                        }catch(e){
                                            window.open('about:blank','_self').close();
                                        }
                                    }
                                }
                            });
                        }
                        def.resolve(dt);
                    })
                });
            }));
            /*def.then(lang.hitch(this,function(){
                xhr("GET",{
                    url: "/w/user/GetBCardToWx/" + window.g_sys_info.code,
                    handleAs: "json",
                    content: {
                    },
                    load: function(data){
                        if(1 === data.rtnType){
                            window.open("","_self").close();
                        }
                    }
                });
            }));*/
        },
        randPassword: function() {
            var text = ['abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', '1234567890', '~!@#$%^&*()_+;,./?<>'];
            var rand = function(min, max) {
                return Math.floor(Math.max(min, Math.random() * (max + 1)));
            };
            var len = rand(6, 10); // 长度为6-10 
            var pw = '';
            for (i = 0; i < len; ++i) {
                var strpos = rand(0, 2);
                pw += text[strpos].charAt(rand(0, text[strpos].length));
            }
            return pw;
        },
        postPhoneNumFuc: function(){
            var phoneNumber = query(".phoneNumberInput", this.domNode)[0].value;
            var checkCode = query(".checkCodeInput", this.domNode)[0].value;
            if(!phoneNumber||!checkCode){
                alert("请填写手机号和验证码。");
            }else{
                window.busy();
                window.postVerCode(phoneNumber,checkCode).then(lang.hitch(this,function(s){
                    if(s){
                        //判断手机号是否已经注册
                        userInfo.checkUName(phoneNumber).then(lang.hitch(this,function(ss){
                            //已注册
                            if(ss){
                                /*userInfo.hasLogin().then(lang.hitch(this, function(s){
                                    if(s){
                                        console.log("hasLogin1");
                                    }
                                }));*/
                                this.sendBCard(phoneNumber);
                                query(".checkCodeInput", this.domNode)[0].value = "";
                            }
                            //未注册
                            else{
                                var info = {
                                    "OPENID": phoneNumber,
                                 //   "ConsigneeName": this.PhoneNum.value, //姓名
                                    "Fax":phoneNumber,
                                    "PWD":this.randPassword()//生成随机密码
                                };
                                userInfo.regist(info).then(lang.hitch(this, function(success) {
                                    if (success) {
                                        //userInfo.onLogin(info.OPENID, info.PWD).then(lang.hitch(this,function() {
                                            /*userInfo.hasLogin().then(lang.hitch(this, function(s){
                                                if(s){
                                                    console.log("hasLogin2");
                                                }
                                            }));*/
                                            //如果有微信ID,绑定微信
                                            if (window.wx_openId) {
                                               userInfo.bindWx();
                                            }
                                        //}));
                                        this.sendBCard(phoneNumber);
                                    } else {
                                        alert("注册失败！");
                                        window.free();
                                    }
                                }));
                            }
                        }));
                    }else{
                        window.free();
                    }
                }));
            }
        }
    });
});