define([
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Deferred"],function(lang, array, Deferred){
        return lang.mixin(lang.getObject("widgets.common._matDisHandler",true),{
            getMatsDisRateByID:function(matts,qtys){
                
                var def = new Deferred();
                if(matts){
                    var mids = [];
                    for(var mid in matInfo){
                        mids.push(mid);
                    }
                    if(mids.length){
                        window.loadData({
                            modalName: "YY_TSDCD_PRICEDTS",
                            filter: "01",
                            pageSize: "1",
                            pageIndex: "1",
                            param: {
                                "MID": mids
                            }
                        }).then(lang.hitch(this,function(matData){
                            array.forEach(matData,function(mat){
                                matts.push({
                                    "MID":mat.MID,
                                    "AppliedQty":matInfo[mat.MID].QTY,
                                    "Price":mat.Price
                                });
                            });
                        }));
                    }
                }
            }
        });
    });