define([
    "dojo/_base/declare", 
    "dijit/registry",
    "dojo/dom-attr",
    "dojo/query",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class"
], function(declare, registry,domAttr,query,array,lang,domStyle, domClass) {
    return declare("widgets.common._matListSjmdMixin.js",null,{
        //LIST2列表的过滤器
        _Defaultflt:"37",
        _IsPlatform:true,
        _MatOrder:"[T0_MCode] ASC",
        _BigParam:{},
        isMatListLoaded:function(){
            return !!this.matList;
        },
        refreshAllList:function(){
            //商品列表请求参数;
            this._BigParam={"APPID":"","TPCH_NUM":"","IS_CX":"","IS_TG":"","childMGID":"","parentMGID":"","SERVICE_TYPE":"","INPUT":""};
            /*
                APPID:平台ID、商家ID、
                TPCH_NUM：限购
                IS_CX:促销
                IS_TG：团购 
                childMGID：商家二级分类ID、平台二级分类ID
                parentMGID:商家一级分类ID、平台一级分类ID
                SERVICE_TYPE:商品类型(0:普通商品；1：到店服务；2：上门服务)
                INPUT：商品名称(搜索)
            */
            
            window.updateTitle("商品列表");
            // if(this.order_control){
            //     this.matList.rs_wb_order = "[T0_MCode] ASC";
            //     query("a",this.order_control).forEach(function(n){
            //         if(!domAttr.get(n,"changeViewEf")){
            //             if(domAttr.get(n,"name")=="[T0_MCode]"){
            //                 domAttr.set(n,"class","arrow-up");
            //                 domAttr.set(n,"selected","true");
            //             }else{
            //                 domAttr.set(n,"class","");
            //                 domAttr.set(n,"selected","false");
            //             }
            //         }
            //     });
            // }
            query("#topUl li",this.domNode)[1].innerText="全部分类";
            window.isPlatform().then(lang.hitch(this,function(result){
                var groupID="";
                this._IsPlatform=result;
                //this._did = window.did;
                if(this._IsPlatform){
                    groupID=window.g_sys_info.aid;               //取平台分类ID
                    if(window.did==""){                          //平台不带参数
                        this._Defaultflt="37";
                        this._BigParam.APPID=window.g_sys_info.aid;
                    }
                    else if(window.did.indexOf('aid_')>-1){      //平台带AID参数
                        var aid=window.did.split("_")[1];
                        this._Defaultflt="38";
                        this._BigParam.APPID=aid;
                        if(aid==window.g_sys_info.aid){     //若AID参数=当前平台的AID
                            this._Defaultflt="39";
                        }
                    }
                    else if(window.did.indexOf('srvPar_')>-1){     //平台带srvPar_一级分类ID参数
                        this._Defaultflt="41";
                        var aid=window.did.split("_")[1];
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.parentMGID=aid;
                    }
                     else if(window.did.indexOf('srvChild_')>-1){     //平台带srvChild_二级分类ID参数
                        this._Defaultflt="41";
                        var aid=window.did.split("_")[1];
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.childMGID=aid;
                    }
                     else if(window.did.indexOf('srvDept_')>-1){     //平台带srvDept_商家ID_门店ID参数
                        this.isDept=1;
                        this._Defaultflt="42";
                        var aid=window.did.split("_")[1];
                        window.deptID=window.did.split("_")[2];
                        this._BigParam.APPID=aid;
                        if(aid==window.g_sys_info.aid){
                            this._Defaultflt="44";
                        }
                    }
                    else if(window.did.indexOf('srv')>-1){           //平台带srv参数
                        this._Defaultflt="41";
                        this._BigParam.APPID=window.g_sys_info.aid;
                    }
                    else{                                       //平台带一级分类ID
                        this._Defaultflt="37";
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.parentMGID=window.did;
                    }
                }
                else{
                    groupID=window.g_sys_info.aid;               //取商家分类ID
                    if(window.did==""){                          //商家不带参数
                        this._Defaultflt="39";
                        this._BigParam.APPID=window.g_sys_info.aid;
                    }
                    else if(window.did.indexOf('aid_')>-1){      //商家带AID参数
                        //this._did = window.did;
                        var aid=window.did.split("_")[1];
                        this._BigParam.APPID=aid;
                        this._Defaultflt="40";
                        groupID=aid;
                    }
                    else if(window.did.indexOf('srvPar_')>-1){       //商家带srvPar_一级分类ID参数
                        this._Defaultflt="43";
                        var aid=window.did.split("_")[1];
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.parentMGID=aid;
                    }
                    else if(window.did.indexOf('srvChild_')>-1){     //商家带srvChild_二级分类ID参数
                        this._Defaultflt="43";
                        var aid=window.did.split("_")[1];
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.childMGID=aid;
                    }
                    else if(window.did.indexOf('srvDept_')>-1){       //商家带srvDept_商家ID_门店ID参数
                        this._Defaultflt="44";
                        var aid=window.did.split("_")[1];
                        window.deptID=window.did.split("_")[2];
                        this._BigParam.APPID=aid;
                        groupID=aid;
                    }
                    else if(window.did.indexOf('srv')>-1){           //平台带srv参数
                        this._Defaultflt="43";
                        this._BigParam.APPID=window.g_sys_info.aid;
                    }
                    else{                                            //商家带一级分类ID
                        this._Defaultflt="39";
                        this._BigParam.APPID=window.g_sys_info.aid;
                        this._BigParam.parentMGID=window.did;
                    }
                }
                
                var ser=query("#pointType .smartFilter>li[ServiceType]",this.domNode)[0];
                domStyle.set(ser,{display:"block"});
                this.matList.rs_wb_flt = this._Defaultflt;
                this.matList.rs_wb_param="("+JSON.stringify(this._BigParam)+")";
                if(window.oldView=="main"){
                    this._MatOrder="[T0_MCode] ASC";
                    window.historys={flt:this.matList.rs_wb_flt,publicParam:this._BigParam,order:this.matList.rs_wb_order};
                    this._clearUlStyle();
                    this.scrollTo({x:0,y:0});

                }
                else if(window.oldView=="conversList"||(window.oldView=="matDetail"&&window.did.indexOf('aid_')<0)||(window.oldView=="orderCar"&&window.did.indexOf('aid_')<0)){
                    if(window.historys){
                        this.matList.rs_wb_flt=window.historys.flt;
                        this.matList.rs_wb_param="("+JSON.stringify(window.historys.publicParam)+")";
                        this.matList.rs_wb_order=window.historys.order;
                        this._BigParam=window.historys.publicParam;
                    }
                }
                else if(window.did.indexOf('srv')>-1){
                    var ser=query("#pointType .smartFilter>li[ServiceType]",this.domNode)[0];
                    if(ser){
                        domStyle.set(ser,{display:"none"});
                    }
                    this._MatOrder="[T0_MCode] ASC";
                    window.historys={flt:this.matList.rs_wb_flt,publicParam:this._BigParam,order:this.matList.rs_wb_order};
                }
                else{
                    this._MatOrder="[T0_MCode] ASC";
                    //this.matList.rs_wb_order="[T0_MCode] ASC";
                    this.matList.rs_wb_param="("+JSON.stringify(this._BigParam)+")";
                    window.historys={flt:this.matList.rs_wb_flt,publicParam:this._BigParam,order:this.matList.rs_wb_order};
                    this._clearUlStyle();
                    this.scrollTo({x:0,y:0});
                }
                this.matList.rs_wb_order=this._MatOrder;
                this.matList.refreshList();
                
                this.matGroup.rs_wb_param = "({AID:"+groupID+"})";
                this.matGroup.refreshList();
                this.curMatList = this.matList;
                this.childMG.onDataReady({
                    data:{items:[]}
                });
                this._closeNavDropDownItem();
            }));
                
    
            window.updateTitle("商品列表");
            
        },
        _myRefreshList:function(param,order,flt){
            if(this.matList)
            {
                // this._BigParam=param;
                this.matList.rs_wb_param =param||"("+JSON.stringify(this._BigParam)+")";
                this.matList.rs_wb_order = order||"[T0_MCode]";
                this.matList.rs_wb_flt=flt||this.curMatList.rs_wb_flt;
                this.scrollTo({x:0,y:0});
                this.matList.refreshList();
                if(window.historys){
                    window.historys.flt=this.matList.rs_wb_flt;
                    window.historys.publicParam=this._BigParam;
                    window.historys.order=this.matList.rs_wb_order;
                }
                this._closeNavDropDownItem();
                window.busy();
                this.curMatList = this.matList;
            }
        },
        indexMatListElement:function(){
            if(!this.isMatListLoaded()){
                this.order_control = query(".order_control",this.bodyNode)[0];   //找到商品列表中的排序
                this.matList = registry.byId("materList");                       //得到matlist节点的id
                //this.searchMatBtn = query(".btn-search",this.bodyNode)[0];
                var head=query(".m-list-1",this.domNode)[0];
                var search=query(".m-list-0",this.domNode)[0];
                this.shelfHeader=query(".shelfHeader",this.domNode)[0];
                this.SearchTxt=query(".searchExpert",this.domNode)[0];                        //搜索
                
                this.shelfHeader.appendChild(search);
                this.shelfHeader.appendChild(head);
                
                var head1 = query("#head", this.domNode)[0];
                this.shelfHeader.appendChild(head1);
                
                this.matGroup=registry.byId("MatGroup",this.domNode); //得到商品分类的节点
                this.childMG=registry.byId("ChildMG",this.domNode);   //得到商品二级节点
                this.orderDiv=registry.byId("orderUl",this.domNode);  //得到商品排序节点
                this.pointType=registry.byId("pointType",this.domNode);  //得到商品类型的节点
            }

            this.nav_ul = query(".nav_ul", this.domNode)[0];
            this.nav_li = query("li", this.nav_ul);
            this.nav_li.pop();
            this.nav_dropdown_items = query(".nav_dropdowm_item", this.domNode);
            this.nav_dropdowm = query(".nav_dropdowm", this.domNode)[0];
            this.nav_dropdownbg = query(".nav_dropdownbg", this.domNode)[0];
            // changeViewLI             
            this.changeViewLi = query(".changeViewLi", this.domNode)[0];
            this.changeViewLiChild = query("span", this.changeViewLi)[0];
            // 筛选页面所有复选框  所有的复选框及label
            this.checkboxForNav = query(".checkboxForNav", this.domNode);
        },
        initMatListEvent:function(){
            this.connect(this.matList, "onDefRendered", function(data) {
                
                //规范数据中 T0_TPCH_NUM (限购) 的值
                for(var i=0;i<data.data.items.length;i++)
                {
                    //限购，，取小数点前的数字
                    if(data.data.items[i].T0_MTID==""){
                        data.data.items[i].TPCH_NUM=data.data.items[i].T0_TPCH_NUM.substring(0,data.data.items[i].T0_TPCH_NUM.indexOf('.',0))||0;
                    }
                    if(data.data.items[i].T0_MTID!=""){
                        data.data.items[i].TPCH_NUM=data.data.items[i].T18_TPCH_NUM.substring(0,data.data.items[i].T18_TPCH_NUM.indexOf('.',0))||0;
                    } 
                    /*array.forEach(data.data.items,function(item,i){
                       if((i+1)%2==1){
                            item.matlistli="left";
                        }else{
                            item.matlistli="right";
                        }
                        // 如果是分销商品
                        if(item.T0_MTID)
                        {
                            if(item.T18_TPCH_NUM&&item.T18_TPCH_NUM!=0)
                            {
                                item.IS_XG = 1;
                            }
                            else
                            {
                                item.IS_XG = 0;
                            }
                        }
                        // 不是自己的商品
                        else
                        {
                            if(item.T0_TPCH_NUM&&item.T0_TPCH_NUM!=0)
                            {
                                item.IS_XG = 1;
                            }
                            else
                            {
                                item.IS_XG = 0;
                            }
                        }
                    });*/
                }
                //参数是否包含srv
                if(window.did.indexOf('srv')>-1){
                    data.data.items.isService=1;
                }
                //参数是否包含srvDept
                if(window.did.indexOf('srvDept_')>-1){
                        data.data.items.isDept=1;
                        data.data.items.deptID=window.deptID;
                    }
                //处理界面的标题
                window.free();
            });
          
            //商品分类
            this.connect(this.matGroup,"onDefRendered",function(data){
                var indexAid=window.did.indexOf('aid_');
                var index=window.did.indexOf('srv');
                var srvGroup=0;
                if(index>-1){
                    srvGroup=window.did.split('_')[1];
                }
                
                if(data&&data.data&&data.data.items){
                    //初始化二级分类信息
                    this._groupHash = {};
                    var len = data.data.items.length;
                    data.data.items.isBeSelected=0;
                    
                    while(len--){
                        data.data.items[len].selected=0;
                        //遍历所有分类
                        
                        if(indexAid==-1&&(((data.data.items[len].MGID==this._BigParam.parentMGID||data.data.items[len].MGID==this._BigParam.childMGID)&&window.historys)||((data.data.items[len].MGID==window.did || data.data.items[len].MGID==srvGroup)&&!window.historys)))
                        {
                            //设置首页进入的分类名称
                            query("#topUl li",this.domNode)[1].innerText=data.data.items[len].MGName;
                            data.data.items[len].selected=1;
                            data.data.items.isBeSelected=1;
                            this.cate_id=data.data.items[len].MGID;
                            
                        }
                        //若是二级分类
                        if(data.data.items[len].UpLevelMGID.MGID){
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID] = this._groupHash[data.data.items[len].UpLevelMGID.MGID]||[];
                            //将本分类添加到二级分类信息中
                            this._groupHash[data.data.items[len].UpLevelMGID.MGID].push(data.data.items[len]);
                            //将当前分类从加载到的分类信息中删除
                            data.data.items.splice(len,1);
                        }
                    }
                    this.childMG.onDataReady({
                        data:{items:this._groupHash[this.cate_id]||[]}
                    });
                }
            });
            
            //商品一级分类的点击事件
            this.connect(this.matGroup.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var str=domAttr.get(event.target,"cate_id");
                    
                    if(str)
                    {
                        array.forEach(dojo.query("#MatGroup li",this.domNode),function(item){
                            if (domClass.contains(item, "beSelected")){
                                domClass.remove(item,"beSelected");
                            }
                            domClass.remove(item,"cur");
                            domStyle.set(item,{"border-top":"0px"});
                        });
                        domClass.add(event.target,"cur");
                        if(str=="0")
                        {
                            str="";
                        }
                        window.dids=str;
                        //加载二级分类信息
                        if(this._groupHash[str]){
                            this.childMG.onDataReady({
                                data:{items:this._groupHash[str]}
                            });
                            var firstNode=query("#ChildMG li",this.domNode)[0];
                            if(firstNode)
                            {
                                domAttr.set(firstNode,"mgName",event.target.innerText);
                            }
                        }else{
                            //刷新商品列表的数据
                            query("#topUl li",this.domNode)[1].innerText=event.target.innerText;
                            
                            //清空参数信息
                            this._BigParam.parentMGID=str;
                            this._BigParam.childMGID='';
                            this._myRefreshList("("+JSON.stringify(this._BigParam)+")",this._MatOrder);
                            this.childMG.onDataReady({   //清空二级分类信息
                                data:{items:[]}
                            });
                        }
                    }
                }
            });
            
            //商品二级分类的点击事件
            this.connect(this.childMG.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var str=domAttr.get(event.target,"cate_id");
                   
                    //刷新商品列表的数据
                    if(str)
                    { 
                        //传入二级分类ID刷新list（点击二级分类）
                        query("#topUl li",this.domNode)[1].innerText=event.target.innerText;
                        this._BigParam.parentMGID='';
                        this._BigParam.childMGID=str;
                        this._myRefreshList("("+JSON.stringify(this._BigParam)+")",this._MatOrder)
                    }
                    else
                    {
                        //传入一级分类ID刷新list（点击全部）
                        this._BigParam.parentMGID=window.dids;
                        this._BigParam.childMGID='';
                        this._myRefreshList("("+JSON.stringify(this._BigParam)+")",this._MatOrder)
                        var mgName=domAttr.get(event.target,"mgName");
                        if(mgName){
                             query("#topUl li",this.domNode)[1].innerText=mgName;
                        }
                    }
                }
            });
            
            //商品排序点击事件
            this.connect(this.orderDiv.domNode,"onclick",function(event){
                if(event&&event.target&&event.target.tagName=="LI"){
                    var wborder=domAttr.get(event.target,"wborder");
                    if(wborder)
                    {
                        this._myRefreshList("("+JSON.stringify(this._BigParam)+")",wborder)
                        this._MatOrder=wborder;
                    }
                    query("#topUl li",this.domNode)[2].innerText=event.target.innerText;
                }
            });
            
            //活动商品的筛选
            this.connect(this.pointType.domNode,"onclick",function(event){
               // if(event&&event.target&&event.target.tagName=="LI"){
                    var cancel=domAttr.get(event.target,"myCancel");
                    var complete=domAttr.get(event.target,"myComplete");
                    var dom=event.target;
                    while(dom!=this.pointType.domNode){
                        if(dom.tagName=="LI"){
                            break;
                        }
                        dom=dom.parentNode;
                    }
                    if(event&&dom&&dom.tagName=="LI")
                    {
                        //设置选中样式
                        var check=query(".divCheckbox",dom)[0];
                        domClass.toggle(check, "divInput");
                        if(domClass.contains(check, "divInput")){
                            domStyle.set(check,{backgroundColor:"#e5004f"});
                        }
                        else{
                            domStyle.set(check,{backgroundColor:"white"});
                        }
                    }
                    var checkList=query("div.divInput",dom.parentNode);
                    if(cancel){   //重置
                        //清空选中
                        array.forEach(checkList,function(item){
                            domClass.remove(item,"divInput");
                            domStyle.set(item,{backgroundColor:"white"});
                        });
                        this._BigParam.TPCH_NUM="";   
                        this._BigParam.IS_CX="";   
                        this._BigParam.IS_TG="";  
                        this._BigParam.SERVICE_TYPE="";
                        this._myRefreshList("("+JSON.stringify(this._BigParam)+")",this._MatOrder);
                    }
                    else if(complete){   //完成
                        this._BigParam.TPCH_NUM="";   
                        this._BigParam.IS_CX="";   
                        this._BigParam.IS_TG="";  
                        this._BigParam.SERVICE_TYPE="";
                        array.forEach(checkList,lang.hitch(this,function(item){
                            var T0_TPCH_NUM=domAttr.get(item.parentNode,"T0_TPCH_NUM");
                            var myCx=domAttr.get(item.parentNode,"IS_CX");
                            var IS_TG=domAttr.get(item.parentNode,"IS_TG");
                            var ServiceType=domAttr.get(item.parentNode,"ServiceType");
                            if(T0_TPCH_NUM){
                                this._BigParam.TPCH_NUM=T0_TPCH_NUM;
                            }
                            else if(myCx){
                                this._BigParam.IS_CX=myCx;
                            }
                            else if(IS_TG){
                                this._BigParam.IS_TG=IS_TG;
                            }
                            else if(ServiceType){
                                this._BigParam.SERVICE_TYPE=ServiceType;
                            }
                        }));
                        this._myRefreshList("("+JSON.stringify(this._BigParam)+")",this._MatOrder);
                    }
                     event.stopPropagation();
                //}
            })
            
            
           /* if(this.searchMatBtn){
                this.searchMatBtn.onclick = lang.hitch(this,this._onMatListSearch);
            }
            if(document.getElementById('search_name')){
                document.getElementById('search_name').onkeydown = lang.hitch(this,function(){
                    if(event.keyCode==13){
                        this._onMatListSearch();
                    }
                });
            }*/
            /*if(this.order_control){// 判断是否有商品列表中的排序节点
                this.connect(this.order_control,"onclick",function(e){
                    var dom = e.target;
                    while(dom&&"a"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                        dom = dom.parentNode;
                    }
                    if(dom&&dom!==this.order_control){
                        if(!domAttr.get(dom,"changeViewEf")){
                            var name = domAttr.get(dom,"name");
                            var cls = domAttr.get(dom,"class");
                            var orderDesc = domAttr.get(dom,"orderDesc");
                            var selected = domAttr.get(dom,"selected");
                            if(selected=="true"){
                                //更新查询条件
                                domAttr.set(dom,"class",(cls===""||cls==="arrow-down")?"arrow-up":"arrow-down");
                                this.curMatList.rs_wb_order = name?((cls===""||cls==="arrow-down")?name:name+" DESC"):"";
                            }else{
                                domAttr.set(dom,"selected","true");
                                this.curMatList.rs_wb_order = name+" "+orderDesc;
                                domAttr.set(dom,"class",orderDesc==="DESC"?"arrow-down":"arrow-up");
                            }
                            this._clearSearchBarStart(dom);
                            this.curMatList.refreshList();
                        }else{
                            domAttr.set(dom,"class",domAttr.get(dom,"class")==="verticalList"?"levelList":"verticalList");
                            domAttr.set(this.matList.domNode,"class",(domAttr.get(this.matList.domNode,"class")==="m-list matList")?"m-l-list matList":"m-list matList");
                        }
                    }
                });
            }*/
            // 导航栏添加点击事件
            this.connect(query(".nav_ul", this.domNode)[0], "onclick", lang.hitch(this, this._navUlClicked));
            // 点击遮罩层时，关闭弹出的div
            this.connect(this.nav_dropdownbg, "onclick", lang.hitch(this, this._closeNavDropDownItem));
           
            // changeViewLi 点击事件
            this.connect(this.changeViewLi, "onclick", this.clickChangeViewLi);
            
            // 统一添加点击事件
            this.connect(this.nav_dropdowm, "onclick", lang.hitch(this, function(evt){
                var dom = evt.target;
                if(dom && dom.tagName === "LABEL"){
                    // 筛选页面复选框点击事件
                    domStyle.set(dom, {backgroundColor:domAttr.get(query("input", dom.parentNode)[0], "checked")?"white":"red"});
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartArea")){
                    // TODO 大区域点击事件
                    // 修改点击大区域的样式
                    array.forEach(query(".smartArea li", this.nav_dropdown_items[0]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                    // 显示对应子区域列表(实时加载对应区域数据到子区域列表中/提前加载好，显示对应子区域)
                    var subArea = query(".subSmartArea",this.domNode)[0];
                    if(domAttr.get(dom, "fujin") == 1){
                        subArea.innerHTML = '<li area_id="32095">石桥铺</li><li area_id="32091">杨家坪</li><li area_id="32030">解放碑</li><li area_id="32031">两路口</li>';
                    }else if(domAttr.get(dom, "hotarea") == 1){
                        subArea.innerHTML = '<li area_id="32095">沙坪坝</li><li area_id="32091">洋人街</li><li area_id="32030">解放碑</li><li area_id="32031">北京</li><li area_id="32031">上海</li>';
                    }else if(domAttr.get(dom, "areaid") == "123"){
                        subArea.innerHTML = '<li area_id="32095">科园一路</li><li area_id="32091">科园二路</li><li area_id="32030">科园三路</li><li area_id="32031">科园四路</li><li area_id="32031">科园五路</li>';
                    }else{
                        subArea.innerHTML = "";
                    }
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartArea")){
                    // TODO 子区域点击事件
                    array.forEach(query(".subSmartArea li", this.nav_dropdown_items[0]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartClassification") ){
                    // TODO 大分类点击
                    array.forEach(query(".smartClassification li", this.nav_dropdown_items[1]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                    
                    var subSmartClassification = query(".subSmartClassification",this.domNode)[0];
                    if(domAttr.get(dom, "cate_id") == 0){
                        subSmartClassification.innerHTML = '<li area_id="32095">分类1</li><li area_id="32091">分类2</li><li area_id="32030">分类3</li><li area_id="32031">分类4</li>';
                    }else if(domAttr.get(dom, "cate_id") == 1){
                        subSmartClassification.innerHTML = '<li area_id="32095">骨膜贴片1</li><li area_id="32091">骨膜贴片2</li><li area_id="32030">骨膜贴片3</li><li area_id="32031">骨膜贴片4</li><li area_id="32031">骨膜贴片5</li>';
                    }else if(domAttr.get(dom, "cate_id") == 2){
                        subSmartClassification.innerHTML = '<li area_id="32095">科园一路</li><li area_id="32091">科园二路</li><li area_id="32030">科园三路</li><li area_id="32031">科园四路</li><li area_id="32031">科园五路</li>';
                    }else{
                        subSmartClassification.innerHTML = "";
                    }
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartClassification") ){
                    // TODO 小分类点击
                    array.forEach(query(".subSmartClassification li", this.nav_dropdown_items[1]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartSort")){
                    // TODO 排序列表点击事件 排序后关闭页面
                    array.forEach(query(".smartSort li", this.nav_dropdown_items[2]), function(nthLi){
                        domClass.remove(nthLi, "beSelected");
                    });
                }
                if(dom && dom.tagName === "LI"){
                    domClass.add(dom, "beSelected");
                }
                if(dom && (dom.tagName === "LI" || dom.tagName === "UL") && 
                (domClass.contains(dom.parentNode, "subSmartArea") || domClass.contains(dom.parentNode, "subSmartClassification")
                || domClass.contains(dom.parentNode, "smartSort"))){
                    this._closeNavDropDownItem();
                }
            }));
            
            //搜索框的ENTER事件
            this.connect(this.SearchTxt,"onkeydown",function(e){
                if(e.keyCode==13){
                    this._searchEvent();
                }
            });
            
            //取消搜索
            if(query(".cancel",this.domNode)&&query(".cancel",this.domNode)[0])
            {
                this.connect(query(".cancel",this.domNode)[0],"onclick",lang.hitch(this,function(){
                    this.SearchTxt.value="";
                    this._BigParam.INPUT="";
                    this.matList.rs_wb_param="("+JSON.stringify(this._BigParam)+")";
                    this.matList.rs_wb_order=this._MatOrder;
                    window.busy();
                    this.matList.refreshList();
                    window.free();
                }));
            }
            
            //点击搜索
            this.connect(this.SearchTxt,"onclick",function(){
                this._closeNavDropDownItem();
            });
            // 筛选页面点击事件 复选框点击事件
            /* this.connect(this.nav_dropdown_items[3],"onclick",lang.hitch(this,function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LABEL"){
                    domStyle.set(dom, {backgroundColor:domAttr.get(query("input", dom.parentNode)[0], "checked")?"white":"red"});
                }
            })); */
            // 区域列表点击事件
            /* this.connect(this.nav_dropdown_items[0], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartArea")){
                    // TODO 大区域点击事件
                    // 修改点击大区域的样式
                    // 显示对应子区域列表
                    console.log(dom.innerHTML);
                }else if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartArea")){
                    // TODO 子区域点击事件
                    this.closeNavDropDownItem(0);
                    console.log(dom.innerHTML);
                }
            })); */
            // 分类列表点击事件
            /* this.connect(this.nav_dropdown_items[1], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartClassification") ){
                    // TODO 大分类点击
                    console.log(dom.innerHTML);
                }else if( dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "subSmartClassification") ){
                    // TODO 小分类点击
                    this.closeNavDropDownItem(1);
                    console.log(dom.innerHTML);
                }
            })); */
            // 智能排序点击事件
            /* this.connect(this.nav_dropdown_items[2], "onclick", lang.hitch(this, function(e){
                var dom = e.target;
                if(dom && dom.tagName === "LI" && domClass.contains(dom.parentNode, "smartSort")){
                    // TODO 排序列表点击事件 排序后关闭页面
                    this.closeNavDropDownItem(2);
                }
            })); */
        },
        clickChangeViewLi:function(e){
            var dom = e.target;
            if(dom && (dom == this.changeViewLi || dom == this.changeViewLiChild)){
                domAttr.set(this.changeViewLiChild, "class", domAttr.get(this.changeViewLiChild, "class")==="changeViewLiV"?"changeViewLiH":"changeViewLiV");
            }
            domAttr.set(this.matList.domNode,"class",(domAttr.get(this.matList.domNode,"class")==="m-list matList matListHeight")?"m-l-list matList":"m-list matList matListHeight");
            this._closeNavDropDownItem();
        },
        // 关闭弹出层方法
        _closeNavDropDownItem:function(itemIndex){
            domStyle.set(this.nav_dropdowm, {display:"none"});
            domStyle.set(this.nav_dropdownbg, {display:"none"});
            array.forEach(this.nav_li, function(nthLi){
                domClass.remove(nthLi, "beSelected");
            });
            
            // domClass.remove(this.nav_li[itemIndex], "beSelected");
        },
        _navUlClicked: function(e){
            var dom = e.target;
            // 判断事件源是否是导航栏前4个li元素
            if(dom.tagName === "LI" && !domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                // 先清除上次点击的li元素的beSelected类
                array.forEach(this.nav_li, function(nthLi){
                    domClass.remove(nthLi, "beSelected");
                });
                // 为当前事件源添加beSelected
                domClass.add(dom, "beSelected");
                // 隐藏上一次显示的div，并显示本次事件源所对应的div
                array.forEach(this.nav_dropdown_items, function(item, index){
                    if(index == domAttr.get(dom,"dropindex")){
                        domStyle.set(item,{display:"block"});
                    }else{
                        domStyle.set(item,{display:"none"});
                    }
                });
                
                domStyle.set(this.nav_dropdownbg, {display: "block"});
                domStyle.set(this.nav_dropdowm, {display: "block"});
                if(domAttr.get(dom,"dropindex")=="3"){
                    var myCx=query("li[IS_CX]",this.domNode)[0];
                    var myTG=query("li[IS_TG]",this.domNode)[0];
                    var myTPCH_NUM=query("li[T0_TPCH_NUM]",this.domNode)[0];
                    var myServiceType=query("li[ServiceType]",this.domNode)[0];
                    if(this._BigParam.IS_CX!=""){
                        domAttr.set(myCx,"IS_CX",this._BigParam.IS_CX);
                        domClass.add(query("div.divCheckbox",myCx)[0],"divInput");
                        domStyle.set(query("div.divCheckbox",myCx)[0],{backgroundColor:"rgb(229, 0, 79)"});
                    }
                    else{
                        domStyle.set(query("div.divCheckbox",myCx)[0],{backgroundColor:"white"});
                        domClass.remove(query("div.divCheckbox",myCx)[0],"divInput");
                    }
                    
                    if(this._BigParam.IS_TG!=""){
                        domAttr.set(query("div.divCheckbox",myTG)[0],"IS_TG",this._BigParam.IS_TG);
                        domClass.add(query("div.divCheckbox",myTG)[0],"divInput");
                        domStyle.set(query("div.divCheckbox",myTG)[0],{backgroundColor:"rgb(229, 0, 79)"});
                    }
                    else{
                        domStyle.set(query("div.divCheckbox",myTG)[0],{backgroundColor:"white"});
                        domClass.remove(query("div.divCheckbox",myTG)[0],"divInput");
                    }
                    
                    if(this._BigParam.TPCH_NUM!=""){
                        domAttr.set(myTPCH_NUM,"T0_TPCH_NUM",this._BigParam.TPCH_NUM);
                        domClass.add(query("div.divCheckbox",myTPCH_NUM)[0],"divInput");
                        domStyle.set(query("div.divCheckbox",myTPCH_NUM)[0],{backgroundColor:"rgb(229, 0, 79)"});
                    }
                    else{
                        domStyle.set(query("div.divCheckbox",myTPCH_NUM)[0],{backgroundColor:"white"});
                        domClass.remove(query("div.divCheckbox",myTPCH_NUM)[0],"divInput");
                    }
                    
                    if(this._BigParam.SERVICE_TYPE!=""){
                        domAttr.set(myServiceType,"ServiceType",this._BigParam.SERVICE_TYPE);
                        domClass.add(query("div.divCheckbox",myServiceType)[0],"divInput");
                        domStyle.set(query("div.divCheckbox",myServiceType)[0],{backgroundColor:"rgb(229, 0, 79)"});
                    }
                    else{
                        domStyle.set(query("div.divCheckbox",myServiceType)[0],{backgroundColor:"white"});
                        domClass.remove(query("div.divCheckbox",myServiceType)[0],"divInput");
                    }
                }
            }else if(dom.tagName === "LI" && domStyle.get(this.nav_dropdowm, "display") == "block" && domClass.contains(dom, "beSelected") && !domClass.contains(dom, "changeViewLi")){
                domClass.remove(dom, "beSelected");
                domStyle.set(this.nav_dropdownbg, {display: "none"});
                domStyle.set(this.nav_dropdowm, {display: "none"});
            }
        },
        mGroupName:"",
        _clearSearchBarStart:function(node){
            if(this.order_control){
                query("a",this.order_control).forEach(function(n){
                    if(n!==node&&!domAttr.get(n,"changeViewEf")){
                        domAttr.set(n,"class","");
                        domAttr.set(n,"selected","false");
                    }
                });
            }
        },
        _onMatListSearch:function(){
            //if(document.getElementById('search_name').value){
                if(window.did.indexOf("aid_")>-1){
                    this.curMatList.rs_wb_param = "({APP_ID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else if(window.did.indexOf("std_")>-1){
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did.split("_")[1]+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }else{
                    this.curMatList.rs_wb_param = "({MGID:'"+window.did+"',INPUT:'"+document.getElementById('search_name').value+"'})";
                }
                this.curMatList.refreshList();
            //}
        },
        _clearUlStyle:function(){
            query("#topUl li",this.domNode)[2].innerText="默认排序";
            query("#topUl li",this.domNode)[3].innerText="筛选";
            
            //清空样式信息
            var orde=query(".smartSort li.beSelected",this.domNode)[0];
            var flit=query(".nav_dropdowm_item_slider li.beSelected",this.domNode)[0];
            if(orde){
                 domClass.remove(orde,"beSelected");
            }
            if(flit){
                domClass.remove(flit,"beSelected");
            }
        },
        _searchEvent:function(){
            this._BigParam.INPUT=this.SearchTxt.value;
            this.matList.rs_wb_param="("+JSON.stringify(this._BigParam)+")";
            this.matList.rs_wb_order=this._MatOrder;
            window.busy();
            this.matList.refreshList();
            window.free();
        }
    });
});