define([
    "dojo/_base/declare",
    "dojo/_base/array",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/dom-class",
    "cqthink/mobile/SlideShow"
],function(declare,array,base,shelf,registry,query,domAttr,domClass,SlideShow){
    return declare("widgets.rct.Enjoy",[base,shelf],{
        getShelfId:function(){
            return "31127";
        },
        isEnjoyLoaded:function(){
            return !!this.cls;
        },
        onTplLoaded:function(pane){
            this.indexEnjoyElement();
            this.initEnjoyEvent();
            this.refreshAllList();
        },
        refreshAllList:function(){
            this.cls.refreshList();
            // 创建slideshow
            //data-dojo-type="cqthink.mobile.SlideShow"  data-dojo-props="panelsHeight:200,srcField:'link',items:[{link:'../../Content/rct/images/enjoybanner.jpg'}]"
            new SlideShow({
                panelsHeight:200,
                srcField:"link",
                items:[{link:"../../Content/rct/images/enjoybanner.jpg",onclick:function(){return false;}}]
            },this.enjoySlideShow);
        },
        initData:function(){
            this.inherited(arguments);
            if(this.isEnjoyLoaded()){
                this.refreshAllList();
            }
        },
        initEnjoyEvent:function(){
            this.connect(this.clsheader,"onclick",this.clsheaderClick);
            /*this.connect(this.enjoySlideShow,"onBeforeRender",function(){
                if (this.enjoySlideShow.items.length > 0) {
                    //domClass.remove(this.enjoySlideShow.domNode, "none");
                    array.forEach(this.enjoySlideShow.items, function(item) {
                        item.src = "/w/img/load/"+g_sys_info.code+"-"+item.URLID;
                        item.title = "";
                        item.onclick = lang.hitch(function(){
                            if(this.IMGURL){
                                if(this.IMGURL.indexOf("http://")===-1){
                                    this.IMGURL="http://"+this.IMGURL;
                                }
                                window.location.href=this.IMGURL;
                            }else{
                                return false;
                            }
                        });
                    });
                } //else {
                //    domClass.add(this.enjoySlideShow.domNode, "none");
                //}
            });*/
        },
        indexEnjoyElement:function(){
            this.cls = registry.byNode(query(".classroomList",this.domNode)[0]);
            this.clsheader = query(".clsheader",this.domNode)[0];
            this.enjoySlideShow = query(".enjoySlideShow",this.domNode)[0];
        },
        clsheaderClick:function(e){
            var dom = e.target;
            while(dom&&dom.tagName!="LI"&&dom!=this.clsheader){
                dom = dom.parentNode;
            }
            if(dom&&dom.tagName=="LI"){
                // 清除选中
                if(query(".checked",this.clsheader)[0]){
                    domClass.remove(query(".checked",this.clsheader)[0],"checked");
                }
                domClass.add(dom,"checked");
                var flt = domAttr.get(dom,"name");
                this.cls.rs_wb_flt = flt;
                this.cls.refreshList();
            }
        }
    });
});