define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dijit/registry",
    "dojo/_base/xhr",
    "dojo/_base/json",
    "dojo/_base/lang",
    "widgets/userInfo",
    "dojo/query",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/dom-attr",
    "dojo/_base/event",
    "dojox/mobile/ProgressIndicator",
    "dojo/_base/window",
    "widgets/_ShelfMixin",
    "dojo/_base/array"
], function(declare,base,registry,xhr,json,lang,userInfo,query,domConstruct,domStyle,domAttr,event,progressIndicator,win,Shelf,array) {
    return declare("widgets.ClientDistribute", [base,Shelf], {
        M_PEOPLE:"粉丝",
        M_UNIT:"元",
        M_AWARD:"收入",
        INCOME_WITHDRAW:0,
        maxAmt:0,
        minAmt:0,
        getShelfId:function(){
            return g_sys_info.aid==40887?"30674":"30749";
        },
        isClientDistributeLoaded:function(){
            return !!this.cd;
        },
        initData: function() {
            if (this.isClientDistributeLoaded()) {
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
            this.centerPane.scrollTo({x: 0, y: 0});
        },
        onTplLoaded: function(pane) {
            this.indexClientDistributeElement();
            this.initClientDistributeEvent();
            this.refreshAllList();
        },
        indexClientDistributeElement:function(){
            this.cd = registry.byId("myMsgforWX");
            this.rrd = registry.byId("retrievalRecordDetail");
            this.lofd = registry.byId("LevelOneFansDetail");
            
            //创建二维码名片节点
            var backgroundDivNode = domConstruct.create("div",{
                style:'width:100%;height:100%;background-color:rgba(0,0,0,0.5);z-index:998;position: absolute;visibility:hidden;',class:"backgroundDiv",id:"backgroundDiv"
            },document.body,"first");
            
            var imgNode = domConstruct.create("img",{
                style:'width:80%;z-index:999;margin: 52px 10% 0;position:relative;',class:"concelQRImg"
            });
            backgroundDivNode.appendChild(imgNode);
            
            var circleNode = domConstruct.create("div",{
                class:"sk-fading-circle",style:"visibility:hidden;z-index:998;",
                innerHTML:'<div class="sk-circle1 sk-circle"></div><div class="sk-circle2 sk-circle"></div><div class="sk-circle3 sk-circle"></div><div class="sk-circle4 sk-circle"></div><div class="sk-circle5 sk-circle"></div><div class="sk-circle6 sk-circle"></div><div class="sk-circle7 sk-circle"></div><div class="sk-circle8 sk-circle"></div><div class="sk-circle9 sk-circle"></div><div class="sk-circle10 sk-circle"></div><div class="sk-circle11 sk-circle"></div><div class="sk-circle12 sk-circle"></div>'
            });
            backgroundDivNode.appendChild(circleNode);
            
            var buttonNode = domConstruct.create("div",{
                innerHTML:"<span style='width:100%;z-index:999;color: #e5004f;font-size:14px;line-height:36px;'>重新获取二维码</span>",
                style:'width:80%;z-index:999;display:none;background-color: #fff;height:36px;text-align:center;margin: 0 10%;',
                class:'getQRCode'
            });
            backgroundDivNode.appendChild(buttonNode);
            
            // //创建修改签名节友情点
            // var backgroundDivNode2 = domConstruct.create("div",{style:'width:100%;height:100%;background-color:rgba(0,0,0,0.3);z-index:998;position: absolute;display:none;',class:"modifySignatureBackground",id:"modifySignatureBackground"},document.body,"first");
            // var textareaDivNode = domConstruct.create("div",{innerHTML:"<textarea maxlength='28' placeholder='限28字' class='modifySignatureTextareaNode' cols='14' rows='2' style='resize:none;overflow-y:hidden;position:absolute;top:50%;left:18.75%;z-index:999;width:62.5%;height:30px;margin-top:-15px;'></textarea>",autofocus:"true"},backgroundDivNode2);
            // var cancelDivNode = domConstruct.create("div",{innerHTML:"<span style='position:absolute;width:31%;height:20px;line-height:20px;background-color:#fff;top:50%;left:19%;margin-top:16px;text-align:center;'>取消</span>",style:"z-index:999;",class:"modifySignatureCancel"},textareaDivNode);
            // var okDivNode = domConstruct.create("div",{innerHTML:"<span style='position:absolute;width:31%;height:20px;line-height:20px;background-color:#fff;top:50%;left:50.5%;margin-top:16px;text-align:center;'>确定</span>",style:"z-index:999;",class:"modifySignatureOk"},textareaDivNode);
        },
        initClientDistributeEvent:function(){
            
            //domStyle.set(query(".mblScrollablePane",this.domNode)[0],{"backgroundColor":"white"});
            
            var prog = new progressIndicator({size:0,center:true});
            win.body().appendChild(prog.domNode);
            //"我的二维码"监听
            this.connect(query(".cdQRCodeDiv",this.domNode)[0],"onclick",function(e){
                //可视窗的宽高
                var concelQRImgNode = query(".concelQRImg",document.body)[0];
                var getQRCodeNode = query(".getQRCode",document.body)[0];
                var backgroundDivNode = query(".backgroundDiv",document.body)[0];
                window.busy();
                if(this.cardId){
                    window.free();
                    domAttr.set(concelQRImgNode,"src","/w/img/load/"+window.code+"-"+this.cardId);
                    domStyle.set(backgroundDivNode,{"visibility":"visible"});
                    domStyle.set(concelQRImgNode,{"visibility":"visible"});
                    domStyle.set(getQRCodeNode,{"display":"block"});
                }else{
                    //调用接口
                    xhr("POST", {
                    url: "/w/user/GetWxBusinessCard/" + window.code,
                    handleAs: "json",
                    content: {},
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            window.free();
                            //显示二维码
                            this.cardId = result.imageId;
                            domAttr.set(concelQRImgNode,"src","/w/img/load/"+window.code+"-"+this.cardId);
                            domStyle.set(backgroundDivNode,{"visibility":"visible"});
                            domStyle.set(concelQRImgNode,{"visibility":"visible"});
                            domStyle.set(getQRCodeNode,{"display":"block"});
                        } else {
                            window.free();
                            alert(result.message || "数据错误!");
                        }
                    })
                    });
                }
            });
            //"图片弹出重新获取二维码"监听事件
            this.connect(query(".getQRCode")[0],"onclick",function(e){
                window.busy();
                xhr("POST", {
                    url: "/w/user/GetWxBusinessCard/" + window.code,
                    handleAs: "json",
                    content: {},
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            //显示二维码
                            window.free();
                            this.cardId = result.imageId;
                            domAttr.set(query(".concelQRImg",document.body)[0],"src","/w/img/load/"+window.code+"-"+this.cardId);
                            domAttr.set(query(".backgroundDiv",document.body)[0],"visibility","visible");
                            domStyle.set(query(".concelQRImg",document.body)[0],{"visibility":"visible"});
                            domAttr.set(query(".getQRCode",document.body)[0],"display","block");
                        } else {
                            window.free();
                            alert(result.message || "数据错误!");
                            domStyle.set(query(".sk-fading-circle",document.body)[0],"visibility","hidden");
                            domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                            domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                            domAttr.set(query(".getQRCode",document.body)[0],"display","none");
                        }
                    })
                });
            });
            
            //"图片弹出取消"监听事件
            this.connect(query(".concelQRImg")[0],"onclick",function(e){
                domStyle.set(query(".concelQRImg",document.body)[0],"visibility","hidden");
                domStyle.set(query(".backgroundDiv",document.body)[0],"visibility","hidden");
                domAttr.set(query(".getQRCode",document.body)[0],"display","none");
            });
            //"我的粉丝"监听事件
            this.connect(query(".myFans",this.domNode)[0],"onclick",function(e){
                var node1 = query(".LevelOneFans",this.domNode)[0];
                var node2 = query(".levelTwoFans",this.domNode)[0];
                var node3 = query(".levelThreeFans",this.domNode)[0];
                var isShow1 = domAttr.get(node1,"isshow");
                var isShow2 = domAttr.get(node2,"isshow");
                var isShow3 = domAttr.get(node3,"isshow");
                
                var lofdNode = query(".LevelOneFansDetail",this.domNode)[0];
                var stateNode = query(".NICKAndTime>span:last-child",this.domNode);
                
                domStyle.set(lofdNode,"display","none");
                domAttr.set(lofdNode,"isshow","0");
                
                if(isShow1==="0"){
                    domAttr.set(node1,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node1,"display","block");
                }else{
                    domAttr.set(node1,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node1,"display","");
                }
                if(isShow2==="0"){
                    domAttr.set(node2,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node2,"display","block");
                }else{
                    domAttr.set(node2,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node2,"display","");
                }
                if(isShow3==="0"){
                    domAttr.set(node3,"isshow","1");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node3,"display","block");
                }else{
                    domAttr.set(node3,"isshow","0");
                    domStyle.set(query(".arrows2",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node3,"display","");
                }
                event.stop(e);
            });
            //"我的收入"监听事件
            this.connect(query(".myIncome",this.domNode)[0],"onclick",function(e){
                var node1 = query(".toPromoteIncome",this.domNode)[0];
                var node2 = query(".salesProceeds",this.domNode)[0];
                var node3 = query(".withdrawn",this.domNode)[0];
                var isShow1 = domAttr.get(node1,"isshow");
                var isShow2 = domAttr.get(node2,"isshow");
                var isShow3 = domAttr.get(node3,"isshow");
                if(isShow1==="0"){
                    domAttr.set(node1,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node1,"display","block");
                }else{
                    domAttr.set(node1,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node1,"display","");
                }
                if(isShow2==="0"){
                    domAttr.set(node2,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node2,"display","block");
                }else{
                    domAttr.set(node2,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node2,"display","");
                }
                if(isShow3==="0"){
                    domAttr.set(node3,"isshow","1");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","2px 0 0 2px");
                    domStyle.set(node3,"display","block");
                }else{
                    domAttr.set(node3,"isshow","0");
                    domStyle.set(query(".arrows3",this.domNode)[0],"border-width","0 2px 2px 0");
                    domStyle.set(node3,"display","");
                }
                event.stop(e);
            });
            
            //一级粉丝监听事件
            this.connect(query(".LevelOneFans",this.domNode)[0],"onclick",function(e){
                var lofdNode = query(".LevelOneFansDetail",this.domNode)[0];
                var stateNode = query(".NICKAndTime>span:last-child",this.domNode);
                if(domAttr.get(lofdNode,"isshow") == 0){
                    domStyle.set(lofdNode,"display","block");
                    domAttr.set(lofdNode,"isshow","1");
                }else{
                    domStyle.set(lofdNode,"display","none");
                    domAttr.set(lofdNode,"isshow","0");
                }
                stateNode.forEach(function(node){
                    if(node.innerHTML == "关注中" && domAttr.get(lofdNode,"isshow") == 1){
                        domStyle.set(node,"background","#ff4401");
                    }else{
                        domStyle.set(node,"background","#78909c");
                    }
                });
                //日期格式化
                query(".subscribeTime",this.domNode).forEach(function(node){
                    var dat = node.innerHTML.toString().split(" ")[0];
                    var tim = node.innerHTML.toString().split(" ")[1];
                    node.innerHTML = dat + " " + tim.substring(0,5);
                });
            });
            
            //修改 Radio选中状态
            updateRadioChecked = function(node){
                domAttr.set(query("input[name='aw']:checked",this.domNode)[0],"checked",false);
                
                if(domAttr.get(node,"value") == "r1") {
                    domAttr.set(query("input[name='aw'][value='r1']",this.domNode)[0],"checked",true);
                    domStyle.set(query(".bgd1",this.domNode)[0],"display","inline-block");
                    domStyle.set(query(".bgd2",this.domNode)[0],"display","none");
                }else if(domAttr.get(node,"value") == "r2") {
                    domAttr.set(query("input[name='aw'][value='r2']",this.domNode)[0],"checked",true);
                    domStyle.set(query(".bgd1",this.domNode)[0],"display","none");
                    domStyle.set(query(".bgd2",this.domNode)[0],"display","inline-block");
                }
            };
            
            //友情点击 Radio父层事件
            this.connect(query(".radioPDiv",this.domNode)[0],"onclick",function(e){
               var node = e.target;
               if("div" === node.tagName.toLowerCase() && "radioPDiv" === domAttr.get(node,"class")){
                   return false;
               }else{
                   updateRadioChecked(node);
               }
            });
            
            var _this = this;
            //获取 收入函数
            accordingToIncome = function(th){
                window.loadData({
                    modalName:"XSY_TCRCS_CLIENT_DCARD",
                    filter:"01",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{PID:userInfo.getUserInfo().partnerId}
                }).then(lang.hitch(this,function(data){
                    _this.maxWithdrawn = data[0].INCOME_WITHDRAW;
                    //显示收入
                    this.myIncome = data[0].INCOME;
                    query(".myIncomeValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncome,3)+((window.dstbtData&&window.dstbtData[0]&&window.dstbtData[0].M_UNIT)||"元");
                    query(".totalIncome",this.domNode)[0].innerHTML = window.fixedTo(this.myIncome,3);
                    
                    this.myIncomeDist = data[0].INCOME_UNE?data[0].INCOME_UNE:0;
                    query(".UNEIncomeValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeDist,3)+((window.dstbtData&&window.dstbtData[0]&&window.dstbtData[0].M_UNIT)||"元");
                    
                    this.myIncomeSale = data[0].INCOME_WITHDRAW?data[0].INCOME_WITHDRAW:0;
                    query(".WITHDRAWValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeSale,3)+((window.dstbtData&&window.dstbtData[0]&&window.dstbtData[0].M_UNIT)||"元");
                    domAttr.set(query(".maxWithdrawn",this.domNode)[0],"placeholder","最高可兑换"+window.fixedTo(this.myIncomeSale,3)+((window.dstbtData&&window.dstbtData[0]&&window.dstbtData[0].M_UNIT)||"元"));
                    
                    this.myIncomeWitndrawn = data[0].INCOME_WITHDRAWN?data[0].INCOME_WITHDRAWN:0;
                    query(".WITHDRAWNValue",this.domNode)[0].innerHTML= window.fixedTo(this.myIncomeWitndrawn,3)+((window.dstbtData&&window.dstbtData[0]&&window.dstbtData[0].M_UNIT)||"元");
                }));
            };
            
            //获取 粉丝函数
            forFansNumber = function(th){
                xhr("POST", {
                    url: "/w/Exec/executeSelect/" + window.code,
                    handleAs: "json",
                    content: {
                        tp: "wx_distribute_num"
                    },
                    load: lang.hitch(this, function(result) {
                        if (1 === result.rtnType) {
                            //求总人数
                            var total = 0;
                            total = parseInt(result.data.items[0].Q1,10)+parseInt(result.data.items[0].Q2,10)+parseInt(result.data.items[0].Q3,10);
                            //显示总人数
                            query(".myFansValue",this.domNode)[0].innerHTML = total+"人";
                            //显示一级人数
                            query(".leveloneFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q1+"人";
                            //显示二级人数
                            query(".leveltwoFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q2+"人";
                            //显示三级人数
                            query(".levelthreeFanNum",this.domNode)[0].innerHTML = result.data.items[0].Q3+"人";
                        } else {
                            alert(result.message || "数据错误!");
                        }
                    })
                });
            };
            
            //提交 监听事件
            this.connect(query(".sub",this.domNode)[0],"onclick",function(e){
                var maxWithdrawnValue = query(".maxWithdrawn",this.domNode)[0];
                
                //声明 兑换友情点正则表达式
                var exp = /^([1-9][\d]{0,7}|0)(\.[\d]{1,2})?$/;
                if(maxWithdrawnValue.value.replace(/\s/g,'') === ""){
                    alert("请输入兑换"+this.M_AWARD+"！");
                    maxWithdrawnValue.focus();
                }else if(exp.test(maxWithdrawnValue.value)){
                    var amt = parseFloat(maxWithdrawnValue.value,10),maxAmt = parseFloat(this.maxWithdrawn,10);
                    if(maxAmt === 0){
                        alert("可兑换"+this.M_AWARD+"为0！无法兑换");
                    }else if(amt == 0){
                        alert("请确认兑换"+this.M_AWARD+"大于0！");
                        maxWithdrawnValue.select();
                    }else{
                        if(amt > maxAmt){
                            if(confirm("由于输入兑换"+this.M_AWARD+"大于可兑换"+maxAmt+"，是否全部兑换？")){
                                amt = maxAmt;
                            }else{
                                return;
                            }
                        }
                        if(0<this.minAmt&&amt<this.minAmt){
                            alert("一次兑换不得少于"+window.fixedTo(this.minAmt,3));
                        }else if(0<this.maxAmt&&amt>this.maxAmt){
                            alert("一次兑换不得多于"+window.fixedTo(this.maxAmt,3));
                        }else{
                            xhr("POST", {
                                url: "/w/user/DisWithDrawAmt/" + window.code,
                                handleAs: "json",
                                content: {
                                    amt: amt,
                                    tp:domAttr.get(query("input[name='aw']:checked",this.domNode)[0],"value")=="r2"?"4":"3"
                                },
                                load: lang.hitch(this, function(result) {
                                    if (1 === result.rtnType) {
                                        alert("兑换成功!");
                                        maxWithdrawnValue.value="";
                                        accordingToIncome();
                                        this.rrd.refreshList();
                                    } else {
                                        alert(result.message || "数据错误!");
                                    }
                                })
                            });
                        }
                    }
                }else{
                    alert("兑换失败！请确认兑换"+this.M_AWARD+"格式！");
                }
           });
           
           this.connect(this.rrd,"onDefRendered",function(data){
               array.forEach(data.data.items,function(item,i){
                   if(item.TP==3)
                   {
                        item.M_UNIT = "积分";
                   }
                   else
                   {
                       item.M_UNIT = "现金";
                   }
                   
                },this);
           });
           
           //兑换记录 监听事件
           this.connect(query(".retrievalRecordDiv",this.domNode)[0],"onclick",function(e){
               if(e.target && domAttr.get(e.currentTarget,"class")=="retrievalRecordDiv" ){
                    if(domAttr.get(e.currentTarget,"isshow") == "0"){
                        domAttr.set(e.currentTarget,"isshow","1");
                        domStyle.set(query(".retrievalRecordTitle",this.domNode)[0],"display","block");
                        domStyle.set(query(".arrows5",this.domNode)[0],"border-width","2px 0 0 2px");
                        domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","block");
                    }else{
                        domAttr.set(e.currentTarget,"isshow","0");
                        domStyle.set(query(".retrievalRecordTitle",this.domNode)[0],"display","none");
                        domStyle.set(query(".arrows5",this.domNode)[0],"border-width","0 2px 2px 0");
                        domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","none");
                    }
               }
           });
           
           //返回 监听事件
           this.connect(query(".backto",this.domNode)[0],"onclick",function(e){
                this.centerPane.scrollTo({x: 0, y: 0});
                domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","none");
                domStyle.set(query(".hideDiv",this.domNode)[0],"display","block");
           });
           //兑换 监听事件
           this.connect(query(".myWithdraw",this.domNode)[0],"onclick",function(e){
               //日期格式化
                query(".formatDate",this.domNode).forEach(function(node){
                    var dat = node.innerHTML.toString().split(" ")[0];
                    var tim = node.innerHTML.toString().split(" ")[1];
                    node.innerHTML = dat + " " + tim.substring(0,5);
                });
               
                this.centerPane.scrollTo({x: 0, y: 0});
                domStyle.set(query(".hideDiv",this.domNode)[0],"display","none");
                domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","block");
                
                domAttr.set(query(".retrievalRecordDiv",this.domNode)[0],"isshow","1");
                domStyle.set(query(".arrows5",this.domNode)[0],"border-width","2px 0 0 2px");
                domStyle.set(query("#retrievalRecordDetail",this.domNode)[0],"display","block");
                /*if(window.dstbtData[0].M_AWARD){
                    if(query(".dui_huan",this.domNode)[0]){
                        query(".dui_huan",this.domNode)[0].innerHTML = "兑换"+window.dstbtData[0].M_AWARD;
                    }
                    
                    query(".money_distr",this.domNode)[0].innerHTML = window.dstbtData[0].M_AWARD+"("+ window.dstbtData[0].M_UNIT+")";
                    if(query(".youqing",this.domNode)[0]){
                        query(".youqing",this.domNode)[0].innerHTML = window.dstbtData[0].M_AWARD;
                    }
                    
                }else{
                    query(".dui_huan",this.domNode)[0].innerHTML = "提现收入";
                    query(".money_distr",this.domNode)[0].innerHTML = "收入(元)";
                    if(query(".youqing",this.domNode)[0]){
                        query(".youqing",this.domNode)[0].innerHTML = "收入";
                    }
                }*/
           });
           
           //提交兑换 监听事件
           this.connect(query(".maxWithdrawn",this.domNode)[0],"onkeypress",function(e){
                //获取 
                var keynum = e.keyCode || e.which;
                var keychar = String.fromCharCode(keynum);
                
                if(!isNaN(parseInt(keychar,10)) || keychar == "."){
                    
                }
                
           });
           
            //判断客户是否存在
            this.connect(this.cd,"onDefRendered",function(data){
                //window.busy();
                prog.start();
                //如果不存在向资源自动添加当前登陆用户
                if(data.data.items.length === 0){
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TCRCS_CLIENT_DCARD",
                                data: [{
                                    n:{
                                        "PID":window.userInfo.partnerId,
                                        "TYPE":0,
                                        "INCOME":0
                                    }
                                }]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            if (1 === result.rtnType) {
                                accordingToIncome(this);
                                forFansNumber(this);
                            } else {
                                alert(result.message || "数据错误!");
                            }
                        })
                    });
                }else{
                    //显示收入
                    accordingToIncome(this);
                    //获取粉丝数
                    forFansNumber(this);
                }
                //window.free();
                prog.stop();
            });
        },
        refreshAllList: function() {
            // 判断用户是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(hasLogin) {
                if (hasLogin) {
                    //确保 每次页面跳转都显示导航页面
                    if("http://www.cqthink.com/w/home/index/"+window.code+"#clientDistribute"==document.location.href){
                        domStyle.set(query(".hideDiv",this.domNode)[0],"display","block");
                        domStyle.set(query(".myWithdrawPDiv",this.domNode)[0],"display","none");
                    }
                    //判断 兑换类型
                    window.loadData({
                        modalName:"XSY_TSSCF_DSTBT",
                        filter:"999",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{}
                    }).then(lang.hitch(this,function(data){
                        this.maxAmt = data&&data[0]&&data[0]&&data[0].MAX_AMT?data[0].MAX_AMT:this.maxAmt;
                        this.minAmt = data&&data[0]&&data[0]&&data[0].MAX_AMT?data[0].MIN_AMT:this.minAmt;
                                
                        // 加载我的收入信息
                        window.loadData({
                            modalName:"XSY_TCRCS_CLIENT_DCARD",
                            filter:"01",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{PID:userInfo.getUserInfo().partnerId}
                        }).then(lang.hitch(this,function(dcardData){
                            if(dcardData.length)
                            {
                                this.INCOME_WITHDRAW = dcardData[0].INCOME_WITHDRAW;
                                //window.dcardData = dcardData;
                            }
                            if(data.length){
                                window.dstbtData = data;
                                if(data[0].WITHDRAW == 0){
                                    query("[value='r2']",this.domNode).forEach(function(node){
                                        domStyle.set(node,"display","none");
                                    });
                                } else if(data[0].WITHDRAW == 1){
                                    domStyle.set(query(".bgd2[value='r2']",this.domNode)[0],"display","none");
                                    domStyle.set(query("span[value='r2']",this.domNode)[0],"display","inline-block");
                                }
                                // 商家自己配置了分销相关 2015-11-16 郑兰
                                this.M_PEOPLE = data&&data[0]&&data[0].M_PEOPLE?data[0].M_PEOPLE:this.M_PEOPLE;
                                this.M_UNIT = data&&data[0]&&data[0].M_UNIT?data[0].M_UNIT:this.M_UNIT;
                                this.M_AWARD = data&&data[0]&&data[0]&&data[0].M_AWARD?data[0].M_AWARD:this.M_AWARD;
                                this.cardId = data&&data[0]&&data[0]&&data[0].CARDID;
                                
                                query(".myFansText",this.domNode)[0].innerHTML= "我的"+this.M_PEOPLE;
                                query(".LevelOneFansText",this.domNode)[0].innerHTML = "一级"+this.M_PEOPLE;
                                query(".LevelTwoFansText",this.domNode)[0].innerHTML = "二级"+this.M_PEOPLE;
                                query(".LevelThreeFansText",this.domNode)[0].innerHTML = "三级"+this.M_PEOPLE;
                                if(query(".zanwu",this.domNode)[0]){
                                    query(".zanwu",this.domNode)[0].innerHTML = "暂无"+ this.M_PEOPLE;
                                }
                                
                                query(".myIncomeText",this.domNode)[0].innerHTML="我的"+this.M_AWARD;
                                query(".UNEIncomeText",this.domNode)[0].innerHTML= "待确认" + this.M_AWARD;
                                query(".WITHDRAWText",this.domNode)[0].innerHTML= "可提现" + this.M_AWARD;
                                query(".WITHDRAWNText",this.domNode)[0].innerHTML= "已提现" + this.M_AWARD;
                                query(".totalIncomeTitle",this.domNode)[0].innerHTML = "累计" + this.M_AWARD;
                                
                                if(query(".dui_huan",this.domNode)[0]){
                                    query(".dui_huan",this.domNode)[0].innerHTML = "兑换"+this.M_AWARD;
                                }
                                
                                query(".money_distr",this.domNode)[0].innerHTML = this.M_AWARD+"("+ this.M_UNIT+")";
                                if(query(".youqing",this.domNode)[0]){
                                    query(".youqing",this.domNode)[0].innerHTML = this.M_AWARD;
                                }
                            }else{}
                            this.cd.refreshList();
                            this.rrd.refreshList();
                            this.lofd.refreshList();
                        }));
                    }));
                } else {
                    window.nextPageOnLogin = "clientDistribute";
                    // 若没有登录
                    userInfo.showLogin();
                }
            }));
        }
    });
});