define([
    "dojo/_base/declare",
    "dojo/dom",
    "dojo/_base/connect",
    "dijit/registry",
    "../_Base",
    "cqthink/mobile/SlideShow",
    "dojo/query",
    "dojo/dom-attr",
    "dojo/_base/xhr",
    "dojo/_base/lang",
    "dojo/dom-style",
    "../userInfo",
    "dojo/cookie",
    "dojo/_base/json",
    "dojo/_base/array"
    ], function(declare, dom, connect, registry, Base, SlideShow, query, domAttr, xhr, lang, domStyle, userInfo, cookie, json, array) {
    return declare("widgets.standardTmp01.DistraBill", Base, {
        indexElement: function() {
            this.inherited(arguments);
            // 配送明细
            this.distraBillDel = registry.byId("distraBillDel");
            // 订单数据 
            this.distraBillOrd = registry.byId("distraBillOrd");
        },
        initEvent: function() {
            this.inherited(arguments);
            //剩余配送数量
            this.connect(this.distraBillOrd,"onDefRendered",function(data){
                var item = data.data.items[0];
                var totalNum = item["T4_D_TIMES"],
                dQty = item["T4_DeliveryQty"];
                item.newNum= totalNum - dQty;
                // 检查订单类型
                // S_TYPE 0：直销，1：我分销，2：分销我
                // 如果是直销
                if(item.T4_S_TYPE==0)
                {
                  //  this.distraBillDel.rs_wb_param = "({SourceBillID:window.did})";
                    this.distraBillDel.refreshList();
                }
                // 如果是我分销
                else if(item.T4_S_TYPE==1)
                {
                    // 中转
                    if(item.T0_IS_TRANSIT==1)
                    {
                     //   this.distraBillDel.rs_wb_param = "({SourceBillID:window.did})";
                        this.distraBillDel.refreshList();
                    }
                    // 未中转
                    else
                    {
                        window.loadData({
                            modalName:"XSY_TSDSG_DELIVERYBILLDTS",
                            filter:"03",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"EntryID":window.did}
                        }).then(lang.hitch(this,function(data){
                            if(data.length)
                            {
                                this.distraBillDel.rs_wb_param = "({SourceBillID:'"+data[0].EntryID+"'})";
                                this.distraBillDel.refreshList();
                            }
                            else
                            {
                              //  this.distraBillDel.rs_wb_param = "({SourceBillID:window.did})";
                                this.distraBillDel.refreshList();
                            }
                        }));
                    }
                }
            });
        },
        initData: function() {
            this.inherited(arguments);
          //  this.distraBillDel.refreshList();//刷新配送清单数据
            this.distraBillOrd.refreshList();//刷新订单数据
        }
    });
});