define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatDetailMixin",
    "dojo/query",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/dom-construct",
     "../userInfo",
     "widgets/orderCarRecord",
     "cqthink/mobile/imgPrc/bigImg",
     "dojo/_base/xhr",
     "dojo/_base/json"
    ], function(declare, base, Shelf, MatDetailMixin, query, domStyle,domClass,domAttr,registry,array,lang,Deferred,domConstruct,userInfo,orderCarRecord,bigImg,xhr,json) {
    return declare("widgets.standardTmp01.MatDetail1", [base, Shelf, MatDetailMixin], {
        //配置是否右上角显示购物车
        showOrderCarNum: true,
        canAddtoOrderCar: false,
        IS_PRESALE:false,
        getShelfId: function() {
            return "30345";
        },
        onBeforeTransitionOut:function(){
            if(this.bgPane){
                domClass.add(this.bgPane,"hide");
            }
            this.inherited(arguments);
        },
        initData: function() {
            var freebak = window.free;
            window.free = function(){};
            this.updateSvcTitle = true;
            if (this.isMatDetailLoaded()) {
                this.refreshAllList();
            }
            this.inherited(arguments);
            window.free = freebak;
        },
        onTplLoaded: function(pane) {
            this.indexMatDetailElement();
            this.initMatDetailEvent();
            // 隐藏已下架提示
            if(this.saleoutTxt)
            {
                domConstruct.destroy(this.saleoutTxt);
            }
            //刷新所有的list
            this.refreshAllList();
        },
        free:function(){
            if(this.isPJLoaded){
                window.free();
            }
        },
        refreshAllList:function(){
            this.inherited(arguments);
            this.isPJLoaded = false;
            this.materDetail01.refreshList();
            this.materContent11.refreshList();
            this.pj.refreshList();
            this.canAddtoOrderCar = false;
            this.IS_PRESALE = false;
            this.free();
        },
        indexMatDetailElement:function(){
            this.inherited(arguments);
            this.bgPane = query(".bgPane",this.domNode)[0];
            this.bgMatInfoFixed = registry.byId("bgMatInfoFixed");
            this.bgMatInfoList = registry.byId("bgMatInfoList");
            this.materDetail01 = registry.byNode(query(".materDetail01",this.domNode)[0]);
            this.pj = registry.byNode(query(".pj",this.domNode)[0]);
            this.jsn = query(".jsn",this.domNode)[0];
            this.jqn = query(".jqn",this.domNode)[0];
            this.jrgwc = query(".jrgwc",this.domNode)[0];
            this.ljgm = query(".ljgm",this.domNode)[0];
            this.saleoutTxt = query(".saleoutTxt",this.domNode)[0];
            this.materContent11 = registry.byNode(query(".materContent11",this.domNode)[0]);
            this.bgFixedTop = query(".bgFixedTop",this.domNode)[0];
            //this.newdinfo = query(".new-d-info")[0];
            this.materDetail = registry.byId("materDetail");
        },
        djs_timerFunction:function(){
            if(window.djs_timer)
            {
                clearInterval(window.djs_timer);
            }
            // 如果近期有查询到未过期的限购活动
            if(window.priceData.length&&!window.fsData.length)
            {
                var time = g_s.dateDiff("s",g_s.getDateTime(),window.priceData[0].StartDate);
                domClass.remove(query(".xg",this.domNode)[0],"hide");
                domClass.remove(query(".xg_start",this.domNode)[0],"hide");
                domClass.add(query(".xg_end",this.domNode)[0],"hide");
                domAttr.set(query(".xg_call",this.domNode)[0],"call","1");
                 window.loadData({
                        modalName:"XSY_TSSUS_RESEND_MSG_LIST",
                        where:"[RID]='NY_TSDCD_PRICEDTS' AND [RIID]='"+window.priceData[0].PriceDtsID+"' AND [PID]='"+userInfo.getUserInfo().partnerId+"'"
                }).then(lang.hitch(this,function(data){
                    if(data.length>0){
                        this.msgData =1;
                        domAttr.set(query(".xg_cancel_call",this.domNode)[0],"call","1");
                        domClass.remove(query(".xg_cancel_call",this.domNode)[0],"hide");
                    }else{
                        domAttr.set(query(".xg_call",this.domNode)[0],"call","1");
                        domClass.remove(query(".xg_call",this.domNode)[0],"hide");
                    }
                }));
                window.xgtimer = setInterval(lang.hitch(this, function() { //节点加载出来后获取倒计时的节点
                    if (time > 0) {
                        time--;
                         var t = this.formatSeconds(time),
                            d = t.d,
                            t_time = t.t;
                            var xg_time ="";
                            if(d>0){
                              xg_time=xg_time + d+"天";  
                            }
                            xg_time = xg_time + t_time;
                        if(query(".xg_timer",this.domNode)[0]){
                            query(".xg_timer",this.domNode)[0].innerHTML = xg_time;
                        }
                    } else {
                        this.refreshAllList();
                        clearInterval(window.djs_timer);
                    }
                }), 1000);
            }
            else
            {
                clearInterval(window.djs_timer);
            }
        },
        initMatDetailEvent: function() {
            // 修改图片信息
            this.connect(this.picItemsScan, "onBeforeRender", function() {
                if (this.picItemsScan.items.length > 0) {
                    array.forEach(this.picItemsScan.items, function(item) {
                        item.src = "/w/img/load/" + g_sys_info.code + "-" + item.DID + ".png";
                        item.title = "";
                    });
                }
            });
           //商品详情的监听事件
            this.connect(this.materContent.domNode,"onclick",this.MatDetailOnClick);
            // 取商品详细信息
            this.connect(this.MatDetailList,"onDefRendered",function(data){
                this.getMatDtlInfo(data);
                // 限购结束倒计时
                setTimeout(lang.hitch(this,this.xg_timerFunction),100);
                // 限购开始倒计时
                setTimeout(lang.hitch(this,this.djs_timerFunction),100);
                // 修改标题
                query(".shop_module_item_title",this.domNode)[0].innerHTML = data.data.items[0].T0_GName;
            });
            // 侦听购物车
            this.connect(this.MatDetailList.domNode, "onclick", this._MatDetailClick); 
            
            //侦听标题
            this.connect(this._tabs_ul,"onclick",this._tabs_ul_fuc);
            this.connect(this.materCom,"onDefRendered",function(data){
                this.hasRecomment = true;
                var c = query("#XX-01",this.domNode)[0];
                domStyle.set(c,"display",data.data.items.length&&data.data.items[0].DOC_CONTENT?"":"none");
            });
            this.connect(this.XXmsg,"onDefRendered",function(data){
                domStyle.set(query("#XX-04",this.domNode)[0],"display",data.data.items.length?"":"none");
            });
            this.connect(this.bgMatInfoList.domNode,"onclick",this.bgMatInfoListClick);
            this.connect(this.pj,"onDefRendered",function(data){
                if(data.data.items.length){
                    data.data.items[0].totalCount = data.data.totalCount;
                    data.data.items[0].OPENID = data.data.items[0].PID.T1_OPENID[0]+"**"+data.data.items[0].PID.T1_OPENID[data.data.items[0].PID.T1_OPENID.length-1];
                }
                this.isPJLoaded = true;
                this.free();
            });
             // 取商品详细信息显示在购买界面
            this.connect(this.bgMatInfoList,"onDefRendered",function(data){
                if(data.data.items.length){
                    var item = data.data.items[0];
                    if(window.preDataDts.length){
                        item.PRE_EAR = window.preData[0].EARNEST;//定金
                        item.IS_PRESALE = 1;//是否预售商品
                        this.IS_PRESALE = true;
                    }else{
                            this.IS_PRESALE = false;
                            item.IS_PRESALE = 0;
                            item.PRE_EAR = "";
                    }
                }
            });
            // 数量+
            this.connect(this.jsn,"onclick",function(e){
                this._addMatNum(1);
            });
            // 数量-
            this.connect(this.jqn,"onclick",function(e){
                this._addMatNum(-1);
            });
            // 商品数量pane点击加入购物车
            this.connect(this.jrgwc,"onclick",this.jrgwcOnClick);
            // 商品数量pane点击立即购买
            this.connect(this.ljgm,"onclick",this.ljgmOnClick);
            this.subscribe("widgets/show/view", function(id) {
                if (id === this.id) {
                    this.updateFooter();
                }
            });
            this.connect(this.bgFixedTop,"onclick",this.bgFixedTopClick);
            this.connect(this.materDetail,"onDefRendered",function(data){
                var item = data.data.items[0];
                this.preEndsecond = g_s.dateDiff("s",g_s.getDateTime(),item.PRE_EDATE);
            });
        },
        MatDetailOnClick:function(event){
            //赵春辉    只有点击图片才做显示大图的操作  2016-01-29
            if(event&&event.target&&event.target.tagName&&"img"===event.target.tagName.toLowerCase()){
                var src=query("img",this.materContent.domNode);
                var index=0;  
                var srcArr=array.map(src,function(item,i){  //路径的数组对象
                    if(item==event.target) {
                        index=i;
                    }
                    return  {src:domAttr.get(item,"src")};
                });
                bigImg.show(srcArr,index);
            }
        },
        jrgwcOnClick:function(e){
            //取商品详细信息  处理消费者已经进入商品详情页面，此时商家端对商品属性（是否使用，是否可销售,库存等）做了修改的问题
            window.loadData({
                    modalName:"XSY_VBSSC_MAT",
                    filter:"17",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{"MID":window.did}
            }).then(lang.hitch(this,function(data){
                this.canAddtoOrderCar = false;
                var oData = {};
                oData.data = {};
                oData.data.items = data; 
                this.getMatDtlInfo(oData).then(lang.hitch(this,function(){
                    //如果能购买
                    if(this.canAddtoOrderCar&&!domClass.contains(this.footerFloor.boxes[2].domNode,"saleout")){
                        var car = orderCarRecord.getOrderCar(),n = 0;
                        n = parseFloat(car[window.did]||0)+parseFloat(query("#buynum",this.bgPane)[0].value);
                        if((data&&data[0]&&data[0].T0_TPCH_NUM&&data[0].T0_TPCH_NUM>0))
                        {
                            // 如果本次购买+购物车中数量 超过限购数量 
                            if(n>data[0].T0_TPCH_NUM)
                            {
                                alert("购物车中数量已超过限购数量,请先进入购物车结算");
                                domClass.add(this.bgPane,"hide");
                            }else{
                                window.addOrderCar(window.did,query("#buynum",this.bgPane)[0].value,this.GName);
                                domClass.add(this.bgPane,"hide");
                            }
                        }
                        else
                        {
                            window.addOrderCar(window.did,query("#buynum",this.bgPane)[0].value,this.GName);
                            domClass.add(this.bgPane,"hide");
                        }
                    } else {
                        alert("商品已售罄");
                    }
                }));
            }));
        },
        ljgmOnClick:function(e){
            //取商品详细信息  处理消费者已经进入商品详情页面，此时商家端对商品属性（是否使用，是否可销售,库存等）做了修改的问题
            window.loadData({
                    modalName:"XSY_VBSSC_MAT",
                    filter:"17",
                    pageSize:"1",
                    pageIndex:"1",
                    param:{"MID":window.did}
            }).then(lang.hitch(this,function(data){
                this.canAddtoOrderCar = false;
                var oData = {};
                oData.data = {};
                oData.data.items = data; 
                this.getMatDtlInfo(oData);
            })).then(lang.hitch(this,function(){
                //如果能购买
                if(this.canAddtoOrderCar&&!domClass.contains(this.footerFloor.boxes[3].domNode,"saleout")){
                    window.singleBuyMat(window.did,query("#buynum",this.bgPane)[0].value);
                    domClass.add(this.bgPane,"hide");
                } else {
                    alert("商品已售罄");
                }
            }));
        },
        CallOnclick:function(){
            //判断是否已经登录
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    var data ={
                        o:{
                            "RID":"NY_TSDCD_PRICEDTS",
                            "RIID":window.priceData[0].PriceDtsID,
                            "PID":userInfo.getUserInfo().partnerId  
                        },
                        n:{
                            "RID":"NY_TSDCD_PRICEDTS",
                            "RIID":window.priceData[0].PriceDtsID,
                            "PID":userInfo.getUserInfo().partnerId,
                            "WXID":userInfo.getUserInfo().wxId  
                        }
                    };
                    if(this.isPostCall){
                        return false;
                    }
                    this.isPostCall = true;
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TSSUS_RESEND_MSG_LIST ",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            this.isPostCall = false;
                            if (1 === result.rtnType) {
                                // 添加提示
                                alert("添加提示成功,我们将会在活动开始前一分钟给您发送消息通知");
                                domClass.add(query(".xg_call",this.domNode)[0],"hide");
                                domClass.remove(query(".xg_cancel_call",this.domNode)[0],"hide");
                            } else {
                                window.free();
                                alert("提醒失败");
                            }
                        })
                    });
                }else{
                    alert("请先登录");
                    //window.nextPageOnLogin = "matDetail-"+window.did;
                    //userInfo.showLogin();
                }
            }));
            
        },
        cancelCallOnClick:function(){
            userInfo.hasLogin().then(lang.hitch(this,function(s){
                if(s){
                    var data = {
                        o:{
                            "RID":"NY_TSDCD_PRICEDTS",
                            "RIID":window.priceData[0].PriceDtsID,
                            "PID":userInfo.getUserInfo().partnerId
                        }
                    };
                    if(this.isPostCancelCall){
                        return false;
                    }
                    this.isPostCancelCall = true;
                    xhr("POST", {
                        url: "../../data/update/" + window.code + "-" + window.openId + "?token=" + window.userInfo.token,
                        handleAs: "json",
                        content: {
                            data: json.toJson({
                                modalName: "XSY_TSSUS_RESEND_MSG_LIST ",
                                data: [data]
                            })
                        },
                        load: lang.hitch(this, function(result) {
                            this.isPostCancelCall = false;
                            if (1 === result.rtnType) {
                                alert("取消成功");
                                domClass.remove(query(".xg_call",this.domNode)[0],"hide");
                                domClass.add(query(".xg_cancel_call",this.domNode)[0],"hide");
                            } else {
                                alert("取消失败");
                            }
                        })
                    });
                }else{
                    alert("请先登录");
                }
            }));
        },
        formatSeconds:function(time) { 
            // 计算
            var h = 0,
                i = 0,
                d = 0,
                s = parseInt(time);
            if (s > 60) {
                i = parseInt(s / 60);
                s = parseInt(s % 60);
                if (i > 60) {
                    h = parseInt(i / 60);
                    i = parseInt(i % 60);
                    if (h >=24){
                        d = parseInt(h / 24);
                        h = parseInt(h % 24);
                    }
                }
            }
            // 补零
            var zero = function(v) {
                return (v >> 0) < 10 ? "0" + v : v;
            };
            return {
                d:parseInt(zero(d)),
                t:[zero(h),zero(i), zero(s)].join(":")
            };
        } ,
        timerFunction:function(){
            var timer = setInterval(lang.hitch(this,function(){
                if(this.preEndsecond&&this.preEndsecond>0){
                    this.preEndsecond = this.preEndsecond - 1;
                    var t = this.formatSeconds(this.preEndsecond),
                    d = t.d,
                    time = t.t;
                   query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "<table width='100%'><tr><td style='width:50%;'><div style='padding-left: 10px;line-height:24px;'><span style='display:block;line-height:25px;text-align: left;'>预售还有"+d+"天</span><span style='display:block;line-height:24px;text-align:left;'>"+time+"结束！</span></div></td>"+"<td style='width:50%;'>立刻付定金</td></tr></table>";
                } else if(this.preEndsecond==0){
                    this.refreshAllList();
                    clearTimeout(timer);
                }
            }),1000);
        },
        getMatDtlInfo:function(data){
            var def = new Deferred();
            if(data.data.items.length){
                var item = data.data.items[0];
                //使用、允许销售、有货架库存
                if("1"==item.T0_IsUse.toString()
                &&"1"===item.T0_IsAllowSale.toString()
                &&0<item.T9_SHELF_QTY
                // 去掉允许线上销售的限制 解决商家一些不常用商品不希望在商品列表中出现 但有希望有客户能够通过指定链接购买
                // 2016-3-15 刘轩修改 苟渝提出
                //&&"1"===item.T0_IS_ONLINESALE.toString()
            ){
                    if("1"===item.T0_IsAllSO.toString()||item.T0_AID==g_sys_info.aid){//允许分销或者是当前货主的产品
                        this.canAddtoOrderCar = true;
                    }
                }
                if(window.preDataDts.length){
                    var preEnd = window.preData[0].EDATE;
                    this.preEndTime = preEnd.split(" ")[1];
                    item.PRE_EDATE = window.preData[0].EDATE;
                    item.F_SDATE = window.preData[0].FINAL_PAY_SDATE;
                    item.F_EDATE = window.preData[0].FINAL_PAY_EDATE;
                    item.IS_PRESALE = 1;//是否预售商品
                    item.PRESALE_RULES = window.preData[0].REMAKR;//预售规则
                    item.PRE_EAR = window.preData[0].EARNEST;//定金
                    item.payEarNum = window.preData[0].PayEarNum;//已付定金数量
                    //item.MeasureName = window.preData[0].MID.T5_MeasureName;//单位名称
                    item.PRE_REPRIC = "";//预售零售价
                    item.PRI_CON = "<div class='cell'>";
                    array.forEach(window.preDataDts,function(preDataDts){
                        if(preDataDts.QTY2==""){
                            if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)){
                                window.DQPRI = preDataDts.RE_PRICE;
                                // 未选中的数量
                                item.PRI_CON += "<li class='cellItem biggerSize'><span class='left'>"+window.fixedTo(preDataDts.QTY1,0)+item.T5_MeasureName+"以上</span><span class='right'>¥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</span></li>";
                            }else{
                                // 选中的数量
                                item.PRI_CON += "<li class='cellItem '><span class='left'>"+window.fixedTo(preDataDts.QTY1,0)+item.T5_MeasureName+"以上</span><span class='right'>¥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</span></li>";
                            }
                        }else{
                            if(parseFloat(item.payEarNum)>=parseFloat(preDataDts.QTY1)&&parseFloat(item.payEarNum)<=parseFloat(preDataDts.QTY2)){
                                window.DQPRI = preDataDts.RE_PRICE;
                                item.PRI_CON += "<li class='cellItem biggerSize'><span class='left'>"+window.fixedTo(preDataDts.QTY1,0)+item.T5_MeasureName+"~"+window.fixedTo(preDataDts.QTY2,0)+item.T5_MeasureName+"</span><span class='right'>¥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</span></li>";
                            }else{
                                item.PRI_CON += "<li class='cellItem '><span class='left'>"+window.fixedTo(preDataDts.QTY1,0)+item.T5_MeasureName+"~"+window.fixedTo(preDataDts.QTY2,0)+item.T5_MeasureName+"</span><span class='right'>¥"+window.fixedTo(preDataDts.RE_PRICE,2)+"</span></li>";
                            }
                        }
                    });
                    item.PRI_CON += "</div>";
                    item.PRE_EDATE = item.PRE_EDATE.split(" ")[0]+(item.PRE_EDATE.split(" ")[1]?(" "+item.PRE_EDATE.split(" ")[1].split(":")[0]+":"+item.PRE_EDATE.split(" ")[1].split(":")[1]):"");
                    item.F_SDATE = item.F_SDATE.split(" ")[0]+(item.PRE_EDATE.split(" ")[1]?(" "+item.F_SDATE.split(" ")[1].split(":")[0]+":"+item.F_SDATE.split(" ")[1].split(":")[1]):"");
                    item.F_EDATE = item.F_EDATE.split(" ")[0]+(item.PRE_EDATE.split(" ")[1]?(" "+item.F_EDATE.split(" ")[1].split(":")[0]+":"+item.F_EDATE.split(" ")[1].split(":")[1]):"");
                    this.IS_PRESALE = true;
                }else{
                    item.PRE_REPRIC_F = "";
                    item.PRE_REPRIC_T = "";
                    if(window.preData.length){
                        item.IS_PRESALE = 1;
                        this.IS_PRESALE = true;
                        item.PRESALE_RULES = window.preData[0].REMAKR;
                        item.PRE_REPRIC = window.preData[0].RE_PRICE;
                        item.PRE_EAR = window.preData[0].EARNEST;
                        item.payEarNum = window.preData[0].PayEarNum;
                        item.PRE_EDATE = window.preData[0].EDATE.split(" ")[0]+(window.preData[0].EDATE.split(" ")[1]?(" "+window.preData[0].EDATE.split(" ")[1].split(":")[0]+":"+window.preData[0].EDATE.split(" ")[1].split(":")[1]):"");//window.preData[0].EDATE;//
                        item.F_SDATE = window.preData[0].FINAL_PAY_SDATE.split(" ")[0]+(window.preData[0].FINAL_PAY_SDATE.split(" ")[1]?(" "+window.preData[0].FINAL_PAY_SDATE.split(" ")[1].split(":")[0]+":"+window.preData[0].FINAL_PAY_SDATE.split(" ")[1].split(":")[1]):"");//window.preData[0].FINAL_PAY_SDATE;
                        item.F_EDATE = window.preData[0].FINAL_PAY_EDATE.split(" ")[0]+(window.preData[0].FINAL_PAY_EDATE.split(" ")[1]?(" "+window.preData[0].FINAL_PAY_EDATE.split(" ")[1].split(":")[0]+":"+window.preData[0].FINAL_PAY_EDATE.split(" ")[1].split(":")[1]):"");//window.preData[0].FINAL_PAY_EDATE;
                        item.PRI_CON = "<div class='cell'><li class='cellItem biggerSize'><span class='left'>0"+item.T5_MeasureName+"以上</span><span class='right'>¥"+window.fixedTo(window.preData[0].RE_PRICE,0)+"</span></li></div>";
                    }else{
                        this.IS_PRESALE = false;
                        item.IS_PRESALE = 0;
                        item.PRESALE_RULES = "";
                        item.PRE_REPRIC = "";
                        item.PRE_EAR = "";
                        item.payEarNum = "";
                        item.PRI_CON = "";
                    }
                }
                //分时限购
                item.StartDate="";
                item.EndDate="";
                if(window.fsData.length)
                {
                    item.T0_TPCH_NUM=window.fsData[0].TPCH_NUM;
                    item.StartDate = window.fsData[0].StartDate;
                    item.EndDate = window.fsData[0].EndDate;
                    item.IS_XG = window.fsData[0].IS_XG;
                }
                // 取商品优惠信息20150430
                var mats = window.did;
                this._dealDeposit(mats,1).then(lang.hitch(this,function(Deposit){
                    if(Deposit){
                        this._updateBonusPointsInfo("购买即送"+window.fixedTo(Deposit,0)+"个积分"+(item.T0_MainUnitID.MeasureName?("/"+item.T0_MainUnitID.MeasureName):""));  
                    }
                    // 更新底部的显示
                    this.updateFooter();
                    // 取商品的邮费信息
                    // 查看商家的配置中是否启用邮费模板 未启用邮费模板 邮费按照以前的规则计算 否则按照新规则计算
                    var msg = "";
                    if(item["T0_AID.ENABLE_P_TMP"]==1)
                    {
                        window.loadData({
                            modalName:"XSY_TBSSC_MAT_TRAN",
                            filter:"01",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"MID":window.did}
                        }).then(lang.hitch(this,function(midTran){
                            window.loadData({
                                modalName:"XSY_TBSAV_POSTAGE_TMP",
                                pageSize:"1",
                                pageIndex:"1",
                                where:midTran.length&&midTran[0].TRAN_TMP?
                                ("[DID]="+midTran[0].TRAN_TMP+" AND [AID]="+
                                (item["AID"]?item["AID"]:item["T0_AID.APP_ID"]))
                                :("[AID]="+(item["AID"]?item["AID"]:item["T0_AID.APP_ID"])+" AND [ISALLUSE]=1")
                            }).then(lang.hitch(this,function(tranData){
                                if(tranData.length)
                                {
                                    msg = (tranData[0].POSTAGE<=0?"￥0.00":"￥"+window.fixedTo(tranData[0].POSTAGE,3))+(tranData[0].DESCRIBE?(","+tranData[0].DESCRIBE):"");
                                }else{
                                    msg = "￥0.00";
                                }
                                this._updateBonusLogisticsInfo(msg);
                            }));
                        }));
                    }else{
                        window.loadData({
                            modalName:"XSY_TSSCF_APP",
                            filter:"999",
                            pageSize:"1",
                            pageIndex:"1",
                            param:{"AID":item.T0_AID.APP_ID,"INPUT":""}
                        }).then(lang.hitch(this,function(data){
                            // 如果有对应的物流货主，那么货主设置的邮费政策不起作用
                            if(data[0].TRAN_AID){
                                this._updateBonusLogisticsInfo(data.length?(data[0].TRAN_REGION?("限"+data[0].TRAN_REGION+"，运费￥0.00"):"￥0.00"):"￥0.00");
                            }else{
                                this._updateBonusLogisticsInfo(data.length?(data[0].TRAN_REGION?("限"+data[0].TRAN_REGION+"，"):"")+(data[0].DIR_LMT>0?"未满￥"+window.fixedTo(item.T0_AID==g_sys_info.aid?data[0].DIR_LMT:data[0].DIS_LMT,3)+"，收取运费￥"+window.fixedTo(data[0].TRAN_FEE,3):"￥0.00"):"");
                            }
                        }));
                    }
                }));
                window.updateTitle(item.T0_GName);
                //处理库存默认值
                this.matShelfQty = item.T9_SHELF_QTY = (item.T9_SHELF_QTY||0) - 0;
                //处理限购数量
                this.TPCH_NUM = item.T0_TPCH_NUM = (item.T0_TPCH_NUM||0);
            }
            def.resolve();
            return def;
        },
        xg_timerFunction:function(){
            //var timer = null;
            
            if(window.hasCoupons&&query(".coupons",this.domNode)[0])
            {
                domClass.remove(query(".coupons",this.domNode)[0],"hide");
            }
            if(window.xgtimer){
                clearInterval(window.xgtimer);
            }
            if (window.fsData.length) {
                var time = g_s.dateDiff("s",g_s.getDateTime(),window.fsData[0].EndDate);
                domClass.remove(query(".xg",this.domNode)[0],"hide");
                domClass.remove(query(".xg_end",this.domNode)[0],"hide");
                domClass.add(query(".xg_start",this.domNode)[0],"hide");
                window.xgtimer = setInterval(lang.hitch(this, function() { //节点加载出来后获取倒计时的节点
                    if (time > 0) {
                        time--;
                         var t = this.formatSeconds(time),
                            d = t.d,
                            t_time = t.t;
                            var xg_time ="";
                            if(d>0){
                              xg_time=xg_time + d+"天";  
                            }
                            xg_time = xg_time + t_time;
                        if(query(".xg_timer",this.domNode)[0]){
                            query(".xg_timer",this.domNode)[0].innerHTML = xg_time;
                        }
                    } else {
                        this.refreshAllList();
                        clearInterval(window.xgtimer);
                    }
                }), 1000);
            }
            else
            {
                clearInterval(window.xgtimer);
            }
        },
        // 如果点击非空白区域,则关闭div
        bgFixedTopClick:function(e){
            domClass.add(this.bgPane,"hide");
        },
        // 添加减少数量
        _addMatNum:function(inc){
            var matNode = query("#buynum",this.bgPane),msg = "";
            matNode = matNode.length&&matNode[0];
            if(matNode){
                // 页面上显示
                //增加数量时  如果超过库存或者限购数量则不能增加
                var matNum = inc-0+(matNode.value-0);
                // 数量大于0
                if(0<matNum){
                    // 需要购买的数量小于库存数量
                    if(matNum<=this.matShelfQty)
                    {
                        // 数量大于限购数量
                        if(this.TPCH_NUM>0&&matNum>this.TPCH_NUM)
                        {
                            alert("只能购买"+window.fixedTo(this.TPCH_NUM,0)+"哦~");
                        }
                        else{
                            matNode.value = matNum;
                        }
                    }
                    // 数量小于库存数量
                    else{
                        alert("库存不足哦~");
                    }
                }
            }
        },
        // 预售规则,点击后显示隐藏预售规则内容
        _MatDetailClick:function(e){
            var dom = e.target;
            /*while(dom&&dom!=this.MatDetailList&&!domClass.contains(dom,"gzh")){
                dom = dom.parentNode;
            }*/
            if(dom&&dom!=this.MatDetailList&&!domClass.contains(dom,"gzh")){
                dom = dom.parentNode;
            }
            if(domClass.contains(dom,"gzh")){
                // 查找到gzh中的三角形节点
                var n = query('.triangle',dom)[0];
                // 如果是向上,则修改为向下,否则修改为向上
                if(domClass.contains(n,"triangle-up"))
                {
                    domClass.replace(n,'triangle-down',"triangle-up");
                }
                else
                {
                    domClass.replace(n,'triangle-up',"triangle-down");
                }
                // 规格若已被隐藏,则显示,否则隐藏
                if(domClass.contains(query(".gzc",this.MatDetailList.domNode)[0],"hide"))
                {
                    domClass.remove(query(".gzc",this.MatDetailList.domNode)[0],"hide");
                }else
                {
                    domClass.add(query(".gzc",this.MatDetailList.domNode)[0],"hide");
                }
            }else if(domClass.contains(dom,"xg_call")){
                // 插入数据
                this.CallOnclick();
            }else if(domClass.contains(dom,"xg_cancel_call")){
                // 删除数据
                this.cancelCallOnClick();
            }
        },
        onShelfLoaded:function(){
            this.inherited(arguments);
            this.updateBoxClass();
            this.initMatFooterEvent();
        },
        updateBoxClass:function(){
            // 修改底部陈列位的class属性
            domClass.add(this.footerFloor.boxes[0].domNode,"matDtlFooterBoxH1");
            domClass.add(this.footerFloor.boxes[1].domNode,"matDtlFooterBoxH1 matDtlFooterBoxBk");
            domClass.add(this.footerFloor.boxes[2].domNode,"matDtlFooterBoxH2 hide");
            domClass.add(this.footerFloor.boxes[3].domNode,"matDtlFooterBoxH2 hide");
            
            domClass.add(query(".shop_module_item_title",this.footerFloor.boxes[2].domNode)[0],"matDtlFooterBox matDtlFooterBox3");
            domClass.add(query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0],"matDtlFooterBox matDtlFooterBox4");
        },
        updateFooter:function(){
            // 如果有已下架的节点,则销毁掉
            if(query(".saleoutTxt",this.domNode)[0])
            {
                domConstruct.destroy(query(".saleoutTxt",this.domNode)[0]);
            }
            // 能购买
            if(this.canAddtoOrderCar)
            {
                // 不是预售商品
                if(!this.IS_PRESALE){
                    // 显示立即购买和加入购物车节点
                    domClass.remove(this.footerFloor.boxes[2].domNode,"hide saleout");
                    domClass.remove(this.footerFloor.boxes[3].domNode,"hide saleout");
                    domClass.replace(this.footerFloor.boxes[3].domNode,"matDtlFooterBoxH2","matDtlFooterBoxH22");
                    // 修改立即购买节点的标签
                    query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "立即购买";
                }
                // 是预售商品
                else
                {
                    // 隐藏添加到购物车节点
                    domClass.add(this.footerFloor.boxes[2].domNode,"hide");
                    // 修改立即购买节点样式
                    domClass.replace(this.footerFloor.boxes[3].domNode,"matDtlFooterBoxH22","matDtlFooterBoxH2");
                    // 移除立即购买节点的隐藏和已售罄样式
                    domClass.remove(this.footerFloor.boxes[3].domNode,"hide saleout");
                    // 修改立即购买节点的标签
                   // query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "预售还有"+this.preEndsecond+"秒结束！"+"立刻付定金";
                  //  query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "<div style='float:left;'><a>预售还有"+this.preEndDay+"天</a><a>"+this.preEndTime+"结束！</a></div>"+"<div>立刻付定金</div>";
                  //  query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "<table><tr><td style='width: 60px;'><div style='padding-left: 10px;'><span style='display:block;line-height:25px;text-align: left;'>预售还有"+this.preEndDay+"天</span><span style='display:block;line-height:24px'>"+this.preEndTime+"结束！</span></div></td>"+"<td style='width: 80px;'>立刻付定金</td></tr></table>";
                }
                // 重新设置底部高度
                domStyle.set(this.footerFloor.domNode.parentNode,"height","49px");
                this.updateCenterPaneHeight();
            }
            // 不能购买
            else
            {
                // 创建已下架节点
                var saleout = domConstruct.create("div",{
                    "class":"saleoutTxt",
                    "innerHTML":"已售罄"
                });
                //提高购物车高度
                domStyle.set(query(".orderCarNode",this.domNode)[0],"margin-bottom","16px");
                // 将已下架节点作为第一个孩子节点放到底部
                domConstruct.place(saleout,this.footerFloor.domNode,"first");
                // 显示立即购买和加入购物车按钮
                domClass.remove(this.footerFloor.boxes[2].domNode,"hide");
                domClass.remove(this.footerFloor.boxes[3].domNode,"hide");
                
                domClass.replace(this.footerFloor.boxes[3].domNode,"matDtlFooterBoxH2","matDtlFooterBoxH22");
                // 修改立即购买节点的标签
                query(".shop_module_item_title",this.footerFloor.boxes[3].domNode)[0].innerHTML = "立即购买";
                // 设置立即购买和加入购物车已售罄样式
                domClass.add(this.footerFloor.boxes[2].domNode,"saleout");
                domClass.add(this.footerFloor.boxes[3].domNode,"saleout");
                // 重新设置底部高度
                domStyle.set(this.footerFloor.domNode.parentNode,"height","69px");
                this.updateCenterPaneHeight();
            }
        },
        initMatFooterEvent:function(){
            // 加入购物车节点点击事件侦听
            this.connect(this.footerFloor.boxes[2].domNode,"onclick",function(){
                //取商品详细信息  处理消费者已经进入商品详情页面，此时商家端对商品属性（是否使用，是否可销售,库存等）做了修改的问题
                window.loadData({
                        modalName:"XSY_VBSSC_MAT",
                        filter:"17",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{"MID":window.did}
                }).then(lang.hitch(this,function(data){
                    this.canAddtoOrderCar = false;
                    var oData = {};
                    oData.data = {};
                    oData.data.items = data; 
                    this.getMatDtlInfo(oData).then(lang.hitch(this,function(){
                        // 如果能够购买 // 有库存
                        if(this.canAddtoOrderCar&&!domClass.contains(this.footerFloor.boxes[2].domNode,"saleout")){
                            this.showBgPane();
                        }
                    }));
                }))/*.then(lang.hitch(this,function(){
                    
                }))*/;
            });
            // 立即购买节点点击事件侦听
            this.connect(this.footerFloor.boxes[3].domNode,"onclick",function(){
                //取商品详细信息  处理消费者已经进入商品详情页面，此时商家端对商品属性（是否使用，是否可销售，库存等）做了修改的问题
                window.loadData({
                        modalName:"XSY_VBSSC_MAT",
                        filter:"17",
                        pageSize:"1",
                        pageIndex:"1",
                        param:{"MID":window.did}
                }).then(lang.hitch(this,function(data){
                    if(data.length){
                        this.canAddtoOrderCar = false;
                        var oData = {};
                        oData.data = {};
                        oData.data.items = data; 
                        this.getMatDtlInfo(oData);
                    }
                })).then(lang.hitch(this,function(){
                    // 如果能够购买
                    if(this.canAddtoOrderCar&&!domClass.contains(this.footerFloor.boxes[3].domNode,"saleout")){
                        this.showBgPane();
                    }
                }));
            });
            this.timerFunction();
        },
        // 显示商品数量
        showBgPane:function(){
            // 显示选择购买数量的页面
            domClass.remove(this.bgPane,"hide");
            query("#buynum",this.bgPane)[0].value = 1;
            // 将节点移动到body中
            document.body.appendChild(this.bgPane);
            this.bgMatInfoFixed.resize();
            // 刷新商品显示
            this.bgMatInfoList.refreshList();
            // 确认显示的按钮
            // 如果能购买
            if(this.canAddtoOrderCar)
            {
                domClass.remove(this.jrgwc,"saleout");
                domClass.remove(this.ljgm,"saleout");
                if(this.IS_PRESALE)
                {
                    domClass.remove(this.ljgm,"hide");
                    domClass.add(this.jrgwc,"hide");
                    domStyle.set(this.ljgm,"width","100%");
                    this.ljgm.innerHTML = "立刻付定金";/*"预售还有"+this.preEndDay+"天"+"立刻付定金"*/
                }
                else
                {
                    domClass.remove(this.jrgwc,"hide");
                    domClass.remove(this.ljgm,"hide");
                    domStyle.set(this.ljgm,"width","50%");
                    this.ljgm.innerHTML = "立即购买";
                }
            }
            else
            {
                domClass.add(this.jrgwc,"saleout");
                domClass.add(this.ljgm,"saleout");
            }
        },
        // 商品数量pane的点击
        bgMatInfoListClick:function(e){
            var dom = e.target;
            while(dom&&!domClass.contains(dom,"bgHeaderClose")&&dom!=this.bgMatInfoList.domNode){
                dom = dom.parentNode;
            }
            // 点击关闭后,隐藏商品数量pane
            if(domClass.contains(dom,"bgHeaderClose")){
                domClass.add(this.bgPane,"hide");
            }
        },
        initOrderCarNumberNode:function(){
            var a = null,
                b = null,
                c = null;
            a = domConstruct.create("div", {
                "class": "stdOrderCarNode stdMainOrderCarNode",
                onclick: "window.moveToView('orderCar')"
            });
            a.appendChild(b = domConstruct.create("div", {
                "class": "orderCarNode"
            }));
            b.appendChild(domConstruct.create("img", {
                "src": "../../Content/standardTmp01/images/oc.png"
            }));
            a.appendChild(c = domConstruct.create("div", {
                "class": "stdOrderNum orderCarNum",
                innerHTML: "0"
            }));
            this.domNode.appendChild(a);
            return c;
        }
    });
});