define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "dijit/registry",
    "dojo/_base/lang",
    "dojo/_base/array",
    "cqthink/mobile/imgPrc/bigImg",
    "dojo/dom-attr",
    "dojo/query"
    ],function(declare,base,shelf,registry,lang,array,bigImg,domAttr,query){
    return declare("widgets.htapp.MatDetailEva",[base,shelf],{
        getShelfId:function(){
            return "30593";
        },
        isMatDetailEvaLoaded:function(){
            return !!this.XXeva1;
        },
        onTplLoaded:function(pane){
            this.inherited(arguments);
            this.indexMatDetailEvaElement();
            this.initMatDetailEvaEvent();
            this.refreshAllList();
        },
        indexMatDetailEvaElement:function(){
            this.XXeva1 = registry.byId("XXeva1");
        },
        initMatDetailEvaEvent:function(){
            this.connect(this.XXeva1,"onDefRendered",function(data){
                var items = data.data.items;
                if(items.length)
                {
                    array.forEach(items,function(item){
                        item.OPENID = item.PID.T1_OPENID[0]+"**"+item.PID.T1_OPENID[item.PID.T1_OPENID.length-1];
                        item.MKDT = item.MKDT.split(" ")[0]+" "+item.MKDT.split(" ")[1].split(":")[0]+":"+item.MKDT.split(" ")[1].split(":")[1];
                        
                        item.imgIds = [];
                        // 如果有图片ID 则要将图片解析出来
                        if(item.IMGIDS){
                            array.forEach(item.IMGIDS.split(","),function(imgId){
                                item.imgIds.push({
                                    DID:imgId
                                });
                            });
                        }
                    });  
                }
            });
            this.connect(this.XXeva1.domNode,"onclick",function(event){
                //赵春辉    只有点击图片才做显示大图的操作  2016-01-29
                if(event&&event.target&&event.target.tagName&&"img"===event.target.tagName.toLowerCase()){
                    var evaId = domAttr.get(event.target,"evaId");
                    var src=query("img[evaId='"+evaId+"']",this.XXeva1.domNode);
                    var index=0;  
                    var srcArr=array.map(src,function(item,i){  //路径的数组对象
                        if(item==event.target) {
                            index=i;
                        }
                        return  {src:domAttr.get(item,"src")};
                    });
                    bigImg.show(srcArr,index);
                }
            });
        },
        initData:function(){
            this.inherited(arguments);
            //this.indexMatDetailEvaElement();
            if(this.isMatDetailEvaLoaded()){
                this.refreshAllList();
            }
        },
        refreshAllList:function(){
            this.XXeva1.refreshList();
        }
    });
});