define([
    "dojo/_base/declare",
    "dojo/query",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatEvaToAddMixin","dijit/registry"], function(declare,query, Base, Shelf, MatEvaToAddMixin,registry) {
    return declare("widgets.wyapp.MatEvaToAdd", [Base, Shelf,MatEvaToAddMixin], {
        getShelfId: function() {
            return "30355";
        },
        initData: function() {
            if(this.isMatEvaToAddLoaded()){
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        indexMatEvaToAddElement:function(){
            this.evaToAdd = registry.byId("evaToAdd");
            this.wbevaToAdd = registry.byId("wbevaToAdd");
            this.buttondiv = query(".buttondiv")[0];
            this.inherited(arguments);
        },
        initMatEvaToAddEvent:function(){
            this.connect(this.evaToAdd,"onDefRendered",function(data){
                var items = data.data.items;
                var datetime = items[0]["MKDT"];
                 items.newtime= datetime.split(" ")[0]+" "+datetime.split(" ")[1].split(":")[0]+":"+datetime.split(" ")[1].split(":")[1];
            });
            this.inherited(arguments);
        },
        onTplLoaded: function(pane) {
            this.indexMatEvaToAddElement();
            //让底部固定
            this.footerFloor.domNode.appendChild(this.buttondiv);
            this.initMatEvaToAddEvent();
            this.refreshAllList();
            this.inherited(arguments);
        }
    });
});