define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatLegalMixin"], function(declare, Base, Shelf, MatLegalMixin) {
    return declare("widgets.wyapp.MatLegal", [Base, Shelf,MatLegalMixin], {
        getShelfId: function() {
            return "30352";
        },
        initData: function() {
            if(this.isMatLegalLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        onTplLoaded: function(pane) {
            this.indexMatLegalElement();
            this.initMatLegalEvent();
            this.refreshAllList();
            this.inherited(arguments);
        }
    });
});