define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatLegalListMixin"], function(declare, Base, shelf,MatLegalListMixin) {
    return declare("widgets.wyapp.MatLegalList", [Base,shelf,MatLegalListMixin], {
        getShelfId:function(){
            return "30350";
        },
        initData:function(){
            if(this.isMatLegalListLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            //索引页面元素
            this.indexMatLegalListElement();
            //绑定事件
            this.initMatLegalListEvent();
            //刷新所有的list
            this.refreshAllList();
        }
    });
});