define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatOptionMixin",
    "dijit/registry",
    "dojo/query"
    ],function(declare,base,shelf,Mat,registry,query){
    return declare("widgets.standardTmp01.MatOption",[base,shelf,Mat],{
        getShelfId:function(){
            return "30574";
        },
        onTplLoaded:function(pane){
            this.indexMatOptionElement();
            this.initMatOptionEvent();
            this.refreshAllList();
        },
        initData:function(){
            if(this.isMatOptionLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        },
        indexMatOptionElement: function() {
            this.inherited(arguments);
            this.matRecord = registry.byNode(query(".matRecord",this.domNode)[0]);
        },
        refreshAllList: function() {
            this.matRecord.refreshList();
            this.inherited(arguments);
            
        }
    });
});