define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/_ShelfMixin",
    "widgets/common/_MatListMixin",
    "dojo/query",
    "dojo/dom-attr",
    "dijit/registry",
    "dojo/_base/lang",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/_base/array",
    "dojox/mobile/Pane",
    "dojo/dom-construct",
    "widgets/orderCarRecord"
    ],function(declare, Base,Shelf,MatListMixin,query,domAttr,registry,lang,domStyle,domClass,array,pane,domConstruct,orderCarRecord){
    return declare("widgets/standardTmp01/NewMatList",[Base,Shelf,MatListMixin],{
        showOrderCarNum:true,
        fieldMap:{
            PGName:"PGName",
            MGName:"MGName",
            TPCH_NUM:"TPCH_NUM",
            MGID:"MGroupID"
        },
        defultAidFlt:"41",
        defultAidParam:{
            "APP_ID":"",
            "MGID":"",
            "INPUT":""
        },
        getShelfId:function(){
            return "31012";
        },
        onBeforeTransitionOut:function(){
            domClass.add(query(".matGrp",this.domNode)[0],"hide");
            this.inherited(arguments);
        },
        currentmgid:window.did.split("_").length>1?"":window.did,
        isNewMatListLoaded:function(){
            return !!this.matList;
        },
        refreshAllList:function(){
            // 进来时判断 有没有历史的商品分类ID 和商品分类名称
            if(this.did==window.did){
                if(window.historys&&window.historys.currentmgid){
                    this.currentmgid = window.historys.currentmgid;
                }else{
                    this.currentmgid = window.did.split("_").length>1?(this.currentmgid||""):
                    (window.did.split("_")[0]?window.did.split("_")[0]:(""));
                }
                if(window.historys&&window.historys.currentmgname){
                    this.currentmgname = window.historys.currentmgname;
                }else{
                    this.currentmgname = "";
                }
                this.did = window.did;
                window.historys = {
                    currentmgid:this.currentmgid,
                    currentmgname:this.currentmgname
                };
            }else{
                window.historys = {
                    currentmgid:window.did.split("_").length>1?(
                        window.did.split("_")[2]||""
                    ):window.did,
                    currentmgname:""
                };
                this.currentmgid = window.did.split("_").length>1?(
                    window.did.split("_")[2]||""
                ):window.did;
                this.currentmgname = "";
            }
            
            this.matGrpListLoaded = false;
            this.defultAidParam.MGID = this.currentmgid||"";
            this.inherited(arguments);
        },
        setMr:function(){
            if(this.order_control){
                if(this.currs_wb_order){//商品列表时间 销量 价格排序切换BUG 2015-11-03
                    this.matList.rs_wb_order = this.currs_wb_order;
                }else{
                    this.matList.rs_wb_order = "[TOTAL_SALE] DESC";
                }
                query("li",this.order_control).forEach(function(n){
                    if(!domAttr.get(n,"changeViewEf")){
                        if(domAttr.get(n,"name")=="[TOTAL_SALE]"){
                            if(domClass.contains(n,"_LiSelDown")){
                                domClass.add(n,"_LiSelFu _LiSel");
                            }else{
                                domClass.add(n,"_LiSelDown _LiSel");
                            }
                            domAttr.set(n,"selected","true");
                        }else{
                            domClass.remove(n,"_LiSelFu _LiSel");
                            domClass.remove(n,"_LiSelDown _LiSel");
                            domAttr.set(n,"selected","false");
                        }
                    }
                });
            }
            this.headerFloor.domNode.parentNode.appendChild(query(".n-l-search",pane.domNode)[0]);
            this.headerFloor.domNode.parentNode.appendChild(query(".mat_control_node",pane.domNode)[0]);
            //mat_control_node
            //this.headerFloor.domNode.parentNode.appendChild(query(".order_control2",pane.domNode)[0]);
            //this.headerFloor.domNode.parentNode.appendChild(query(".matGrp",pane.domNode)[0]);
            domStyle.set(this.headerFloor.domNode.parentNode,"display","block");
            domStyle.set(this.headerFloor.domNode,"display","none");
            window.updateTitle("商品列表");
        },
        handleMatListData:function(data){
            this.inherited(arguments);
            var items = data.data.items;
            // 如果有记录的分类名称
            if(window.historys){
                if(window.historys.currentmgname){
                    query(".gname",this.domNode)[0].innerHTML = window.historys.currentmgname;
                }
                else if(window.historys.currentmgid){
                    query(".gname",this.domNode)[0].innerHTML = items&&items[0]&&items[0][this.fieldMap.MGName]||"暂无商品";
                }else{
                    query(".gname",this.domNode)[0].innerHTML = "全部分类";
                }
            }
            // 如果没有
            else {
                query(".gname",this.domNode)[0].innerHTML = "全部分类";
            }
        },
        initData:function(){
            if(this.isMatListLoaded()){
                //已经初始化，刷新所有列表
                this.refreshAllList();
                //2015-11-03 搜索框中有内容时 应该调用搜索的方法
                if(this.searchName.value){
                    this._onMatListSearch();
                }
            }
            this.inherited(arguments);
        },
        onTplLoaded:function(pane){
            this.indexMatListElement();
            this.initMatListEvent();
            this.refreshAllList();
            
        },
        indexMatListElement:function(){
            this.order_control = query(".order_control2",this.bodyNode)[0];//找到商品列表中的排序
            this.matList = registry.byNode(query(".materList",this.domNode)[0]);//得到matlist节点的id
            this.searchMatBtn = query(".btn-search2",this.domNode)[0];
            this.searchName = document.getElementById('search_name2');
            this.matGrpList = registry.byNode(query(".matGrpList",this.domNode)[0]);
        },
        matControlClick:function(e){
            var dom = e.target;
            while(dom&&"li"!==dom.tagName.toLowerCase()&&dom!=this.order_control){
                dom = dom.parentNode;
            }
            if(dom&&dom!==this.order_control){
                //如果选中的节点不是切换按钮
                if(!domAttr.has(dom,"img")&&!domAttr.has(dom,"grp")){
                    //找到得到有name属性对应的排序值定义为变量
                    var name = domAttr.get(dom,"name");
                    //得到属性为orderDesc的属性值定义为变量
                    var orderdesc = domAttr.get(dom,"orderdesc");
                    //如果选中的节点不是销量优先
                    if(!domAttr.has(dom,"saletotal")){
                        domClass.add(dom,"_LiSel");
                        //为了正倒序排列标识
                        var statusCls = domClass.contains(query(".mat_price",dom)[0],"_EtDown")?"_EtUp":"_EtDown";
                        // 移除选中
                        domClass.remove(query(".mat_price",dom)[0],"_EtDown");
                        domClass.remove(query(".mat_price",dom)[0],"_EtUp");
                        var selected = domAttr.get(dom,"selected");
                        if(selected=="true"){
                            //更新查询条件
                            domClass.add(query(".mat_price",dom)[0],statusCls);
                            this.curMatList.rs_wb_order = domClass.contains(query(".mat_price",dom)[0],"_EtDown")?name:name+" DESC";
                        }else{
                            domAttr.set(dom,"selected","true");
                            this.curMatList.rs_wb_order = name+" "+orderdesc;
                            domClass.add(query(".mat_price",dom)[0],orderdesc==="DESC"?"_EtUp":"_EtDown");
                        }
                        this._clearSearchBarStart(dom);
                        this.curMatList.refreshList();
                    }
                    //如果是销量优先节点，直接将selected属性设为ture并按照降序排序
                    else{
                        domClass.add(dom,"_LiSel");
                        domAttr.set(dom,"selected","ture");
                        this.curMatList.rs_wb_order = name+" "+orderdesc;
                        this._clearSearchBarStart(dom);//调用切换函数
                        this.curMatList.refreshList();
                    }
                    this.currs_wb_order = this.curMatList.rs_wb_order;    
                }else if(domAttr.has(dom,"grp")){
                    if(domClass.contains(query(".all_group",dom)[0],"_FuDown")){
                        domClass.remove(query(".matGrp",this.domNode)[0],"hide");
                    }else{
                        domClass.add(query(".matGrp",this.domNode)[0],"hide");
                    }
                    var statusCls = domClass.contains(query(".all_group",dom)[0],"_FuDown")?"_FuUp":"_FuDown";
                    // 移除选中
                    domClass.remove(query(".all_group",dom)[0],"_FuDown");
                    domClass.remove(query(".all_group",dom)[0],"_FuUp");
                    domClass.add(query(".all_group",dom)[0],statusCls);
                    if(!this.matGrpListLoaded){
                        this.matGrpListLoaded = true;
                        // 判断是否当前账套
                        if(window.did.indexOf("aid")>-1){
                            this.matGrpList.rs_wb_param = "({AID:"+window.did.split("_")[1]+",INPUT:''})";
                            this.matGrpList.refreshList();
                        }else{
                            this.matGrpList.rs_wb_param = "({AID:"+g_sys_info.aid+",INPUT:''})";
                            this.matGrpList.refreshList();
                        }
                    }else{
                        if(query(".matGrpItemSel",this.matGrpList.domNode)[0]){
                            domClass.remove(query(".matGrpItemSel",this.matGrpList.domNode)[0],"matGrpItemSel");
                        }
                        domClass.add(query("li[gid='"+this.currentmgid+"']",this.matGrpList.domNode)[0],"matGrpItemSel");
                    }
                }else if(domAttr.has(dom,"img")){
                    this.changeClass(dom);
                }
            }
        },
        initMatListEvent:function(){
            this.inherited(arguments);
            this.connect(this.matGrpList,"onDefRendered",function(data){
                var items = data.data.items;
                items.push({
                    MGName:"全部分类",
                    MGID:""
                });
                items.sort(function(a,b){
                    if(!a.MGID){
                        return 1;
                    }else if(a.MGID>b.MGID){
                        return 1;
                    }else{
                        return -1;
                    }
                });
                // 设置选中的商品分类
                array.forEach(items,function(item,i){
                    item.index = i;
                    if(item.MGID==this.currentmgid){
                        item.spanClo = "matGrpItemSel";
                        window.historys.currentmgname = item.MGID;
                        window.historys.currentmgname = item.MGName;
                    }else{
                        item.spanClo = "";
                    }
                },this);
            });
            this.connect(query(".marGrpBck",this.domNode)[0],"onclick",function(){
                domClass.add(query(".matGrp",this.domNode)[0],"hide");
            });
            this.connect(this.matGrpList.domNode,"onclick",function(e){
                var dom = e.target;
                while(dom&&dom.tagName!="LI"&&dom!=query(".matGrpList",this.domNode)[0]){
                    dom = dom.parentNode;
                }
                window.busy();
                // 切换到指定的商品分类页面
                var gid = domAttr.get(dom,"gid"),
                    gname = domAttr.get(dom,"gname");
                // 判断当前是否在分销货主
                this.currentmgid = gid;
                this.searchName.value = "";
                domClass.add(query(".matGrp",this.domNode)[0],"hide");
                domClass.remove(query(".all_group",this.domNode)[0],"_FuUp");
                domClass.add(query(".all_group",this.domNode)[0],"_FuDown");
                // 设置标签的商品分类
                query(".gname",this.domNode)[0].innerHTML = gname;
                window.historys.currentmgid = gid;
                window.historys.currentmgname = gname;
                // 直接修改list的查询条件
                if(window.did.indexOf("aid")>-1){
                    this.defultAidParam.MGID = gid;
                    this.curMatList.rs_wb_param = "("+JSON.stringify(this.defultAidParam)+")";
                }else{
                    this.defultMParam.MGID = gid;
                    this.curMatList.rs_wb_param = "("+JSON.stringify(this.defultMParam)+")";
                }
                this.curMatList.refreshList();
                window.free();
            });
        },
        _clearSearchBarStart:function(node){//这里的node是选择的节点
            if(this.order_control){
                query("li",this.order_control).forEach(function(n){
                    if(n!==node&&!domAttr.get(n,"changeViewEf")&&!domAttr.get(n,"grp")){
                        domClass.remove(n,"_LiSel");
                        query(".mat_price",n)[0]&&domAttr.set(query(".mat_price",n)[0],"class","mat_price _Triangle4 _EtDown");
                        domAttr.set(n,"selected","false");
                    }
                });
            }
        },
        initOrderCarNumberNode:function(){
            var a = null,b = null,c = null;
            a = domConstruct.create("div",{
                "class":"stdOrderCarNode stdMainOrderCarNode",
                onclick:"window.moveToView('orderCar')"
            });
            a.appendChild(b = domConstruct.create("div",{
                "class":"orderCarNode"
            }));
            b.appendChild(domConstruct.create("img",{
                "src":"../../Content/standardTmp01/images/oc.png"
            }));
            a.appendChild(c = domConstruct.create("div",{
                "class":"stdOrderNum orderCarNum",
                innerHTML:"0"
            }));
            this.domNode.appendChild(a);
            this._orderCarNumNode = c;
            return this._orderCarNumNode;
        }
    });
});
