define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "widgets/common/_UserSettingMixin",
    "widgets/_ShelfMixin",
    "dojo/query"
],function(declare,base,UserSettingMixin,ShelfMixin,query){
    return declare("widgets.standardTmp01.UserSetting",[base,UserSettingMixin,ShelfMixin],{
        getShelfId:function(){
            return "30331";
        },
        onTplLoaded:function(pane){
            this.indexUserSettingElement();
            this.initUserSettingEvent();
            //var a = query(".stdLoginout",this.domNode)[0];
            //this.footerFloor.domNode.appendChild(a);
            this.refreshAllList();
        },
        initData:function(){
            if(this.isUserSettingLoaded()){
                this.refreshAllList();
            }
            this.inherited(arguments);
        }
    });
});