define([
    "dojo/_base/declare",
    "widgets/_ViewBase",
    "dojo/query",
    "widgets/userInfo",
    "cqthink/mobile/TalkMsgList",
    "dojo/_base/lang",
    "dojo/dom-style",
    "widgets/_ShelfMixin",
    "dijit/registry"
    ], function(declare, base, query, userInfo, TalkMsgList, lang, domStyle, Shelf,registry) {
    return declare("widgets.sjmdsvc.pacTeamList", [base, Shelf], {
        getShelfId: function() {
            return "31025";
        },
        isTeamListLoaded:function(){
            return !!this.teamList;
        },
        initData: function() {
            if (this.isTeamListLoaded()) {
                this.scrollTo({
                    x:0,
                    y:0
                });
                this.refreshAllList();
                window.free();
            }
            this.inherited(arguments);
        },
        onTplLoaded: function(pane) {
             //索引页面元素
            this.indexTeamListElement();
            
            //绑定事件
            this.initTeamListEvent();
            
            //刷新所有的list
            this.refreshAllList();
        },
        indexTeamListElement:function(){
            if(!this.isTeamListLoaded()){
                this.teamList=registry.byId("teamList");     //我的团队列表
            }
        },
        initTeamListEvent:function(){
            /*this.connect(this.teamList, "onDefRendered", function(data) {
               debugger; 
            });*/
        },
        refreshAllList:function(){
            window.updateTitle("我的团队列表");
            userInfo.hasLogin().then(lang.hitch(this,function(success){
                if(success){
                    if (this.teamList) {
                        this.teamList.rs_wb_param="({PID:"+userInfo.info.partnerId+"})";
                        this.teamList.refreshList();
                        this.scrollTo({x:0,y:0});
                    }
                }else{
                    window.nextPageOnLogin = "pacTeamList"+(window.did?("-"+window.did):"");
                    userInfo.showLogin();
                }
            }));  
        }
    })
});